{
  AutoStat, knihovna funkci a procedur
  Zde se nachz funkce a procedury nezbytn pro chod makra AutoStat
  
  GeoGet, http://geoget.ararat.cz
  HaLuMa, MaFa, LudekV, mikrom
  Ikonky: Silk, http://www.famfamfam.com
  
  Skript je mozno dale sirit a libovolne upravovat. Jedinou podminkkou je
  uvedeni odkazu na puvodni skript.
  
  Historie verzi:
  v2.23, 20081207, konfigurace ve zvlastnim souboru, takze jde pohodlne menit primo v geoetu v2.16 a vyssi
  v2.24, 20081230, pridana moznost otagovani kesi Kraj a Okres pro mapky, taguji se jen nalezene
  v2.25, 20090108, pridana moznost otagovani kesi nadmorskou vyskou pro statistiky, taguji se jen nalezene
  v2.26, 20090111, uz neni nutno vyplnovat adresu profilu
  v2.26c, 20090113, mala uprava kvuli malemu bugu v GeoGetu, kdy se pri ulozeni nastaveni odmazaly dve promenne
  v2.27, 20090126, opraveno par drobnych chybek, konfigurace mapy nalezu gc.cz v configu, import logu na vlastnich kesich
  v2.28, 20090129, implantovana nova verze makra elevation + nejaky drobnosti
  v2.29, 20090201, implantovana nova verze elevation (strm) + nejaky drobnosti
  v2.30, 20090216, gordikovy opravy, novy algoritmus importu logu na vlastnich kesich + nejaky drobnosti
  v2.31a, 20090305, opraven problem s proxy
  v2.32, 20090605, velke zmeny. prejmenovani makra na AutoStat, volani maker a par drobnosti
  v2.32a, 20090608, webcam kese, countryid, gcczlogin
  v2.32b, 20090608, opraven problem s proxy v geojarry
  v2.33a, 20090617, znamky kesi, smazani slozky %temp%/par- pri startu
  v2.34, 20090630, presunuty CONST!, import logu z webu i kdyz neni cache oznacena v GG jako nalezena
  v2.35, 20090805, parametr -q v silentmodeYES, notrans, quickmenu od LukdaV
  v2.36, 20090811, kontroa pritomnosti GgStatu, onmouseover napovedy k moznostem v quickmenu, kontrola verzi na netu
  v2.37, 20090811, konfigurace v ini, zmena volani GgStatu (rel. cesty, pres BAT)
  v2.38, 20090830, opravena prace s nastavenim z chceckboxu, pridano detailni nastaveni, cela konfigurace v ini, pokud je nick s mezerou da se pro ggstat do uvozovek
  v2.39, 20090901, par chybicek, mozna i ta ze se pri prechodu zaskrtnula moznost uploadu na profil i kdyz jste meli na ftp
  v2.40, 20090908, par chybicek, optimalizace kodu, dodelano tahani nastaveni s puvodniho autostat.config.pas, takze si ho makro po sobe ted smaze, prihlasovaci udaje na gc.cz/com si uklada autostat k sobe a kontroluje zda se nezmenily v configach prislusnych maker, kontrola formatu zadavanych souradnic, vyber template pomoci open dialogu
  v2.41, 20090915, kontrola nove verze hned pri spusteni a ne az po 'OK', Nastaveni -> Pokrocile, opraveno kontrolovani formatu souradnic, opraveno nezobrazovani casti nastaveni pokud je pouzit klasicky vzhled windows, rozsireni editboxu
  v2.42, 20090930, template muze mit i lobovolnou priponu, rozsireny geojarry chyby
  v2.43, 20091010, geojarry -> geojarryw, pri aktualizaci se otevre datadir, vylepseno zadavani domacich souradnic, imunni k cestam skriptu atd..
  v2.44, 20091111, ignoruju stateid a countryid, opravena chyba s ini, pridano kontrolovani platnosti UID, rozeny chybove hlasky
  v2.45, 20091113, opravena chyba s geojarry, opraveny chyba s UID, implantovano geojarry-my, predelana prace s chybama/silentmode
  v2.50, 20091214, formulare prepsany do GFM, funkce/procedury v AutoStat.lib.pas, hromadne upravy, spis k prehlednosti a funkcnosti, podpora lokalizace
  v2.51, 201001yy, po vygenerovani statistik se otevira stranke s GjUsername(bylo GEOGET_OWNER), podpora databazi, pridany dva cudliky na GgStat, opraveno importallmyfinds

  ToDo/Bugs:
  - znamky makrem stahovat jen pro vlastni, prip. nalezeny kese
  - kontrolovat novy verze geojarryho (ale jak zjistit verzi soucasnyho??)
  - kontrolovat novy verze GgStatu ("ggstat.exe -v" ...)
  - problem s mezerou v loginu (Qnik) <- vyskakuje mu hlaska o ruznych udajich v autostatu a configach
}

uses
  AutoStatSettings, AutoStatAdvancedSettings, AutoStatAbout;

const
  Verze         = '2.53';
  {pro makra polygon a elevation}
  ForCountry    = 'Czech Republic';
  TagKraj       = 'CZ kraj';
  TagOkres      = 'CZ okres';
  PolyKraj      = 'CZ kraje';
  PolyOkres     = 'CZ okresy';
  TagElev       = 'Elevation';
  TagElevcoord  = 'Elevation-coord';
  Url           = 'http://ws.geonames.org';

var
  Counter, Found, FTF   :Integer;
  GgStatIncludeFTF      :String;
  Finds                 :String;
  GjCounter             :Integer;
  GjData                :String;
  GgStatBat             :String;
  AutoStatPath          :String;
  GeocachingCzConfig    :String;
  GeojarryConfig        :String;
  Akce                  :String;
  GeojarryExe           :String;
  GeojarryResult        :Integer;
  GeojarryIni           :String;
  UploadBatFile         :String;
  ErrCnt                :Integer;
  ErrFlag               :Boolean;
  CzKraje, CzOkresy     :TGeoPolyList;
  Options               :TIniFile;
  {vsechny dulezity promenny z nastaveni}
  SilentMode            :Boolean;
  CheckNewVersion       :Boolean;
  UseCurrentDatabase    :Boolean;
  Database              :String;
  GenerateCachemap      :Boolean;
  UseCachemapMacro      :Boolean;
  GcCzLogin             :String;
  GcCzPassword          :String;
  GcCzUID               :String;
  GcCzTypMapy           :String;
  Statistics            :String;
  Template              :String;
  HomeLat, HomeLon      :String;
  DownloadLogs          :Boolean;
  DownloadOwnLogs       :Boolean;
  ImportAllFindsFromWeb :Boolean;
  AddRank               :Boolean;
  DivideByPolygon       :Boolean;
  UsePolygonMacro       :Boolean;
  AddElevation          :Boolean;
  UseElevationMacro     :Boolean;
  UseGgStatMacro        :Boolean;
  GenerateFtfIndex      :Boolean;
  GenerateFooter        :Boolean;
  FooterText            :String;
  GeojarryForUpload     :Boolean;
  FtpUrl                :String;
  FtpName               :String;
  FtpPassword           :String;
  FtpDirectory          :String;
  GjUsername            :String;
  GjPassword            :String;
  Language              :String;

{natahne preklad ze souboru a prelozi vetsinu veci, krome hintu, DOCASNY}
procedure Translate(Language: String);
var
  Localization :TIniFile;
begin
  if FileExists(AutoStatPath + '\' + Language + '.lng') then
  begin
    Localization := TIniFile.Create(AutoStatPath + '\' + Language + '.lng');
    {FormSettings}
    FormSettings_CbSilentMode.Caption            := Localization.ReadString('Settings','CbSilentMode','');
    FormSettings_CbGenerateCachemap.Caption      := Localization.ReadString('Settings','CbGenerateCachemap','');
    FormSettings_CbDownloadLogs.Caption          := Localization.ReadString('Settings','CbDownloadLogs','');
    FormSettings_CbDownloadOwnLogs.Caption       := Localization.ReadString('Settings','CbDownloadOwnLogs','');
    FormSettings_CbImportAllFindsFromWeb.Caption := Localization.ReadString('Settings','CbImportAllFindsFromWeb','');
    FormSettings_CbAddRank.Caption               := Localization.ReadString('Settings','CbAddRank','');
    FormSettings_CbDivideByPolygon.Caption       := Localization.ReadString('Settings','CbDivideByPolygon','');
    FormSettings_CbAddElevation.Caption          := Localization.ReadString('Settings','CbAddElevation','');
    FormSettings_ButtonOK.Caption                := Localization.ReadString('Settings','ButtonOK','');
    FormSettings_ButtonCancel.Caption            := Localization.ReadString('Settings','ButtonCancel','');
    FormSettings_ButtonAdvancedSettings.Caption  := Localization.ReadString('Settings','ButtonAdvancedSettings','');
    {FormAdvancedSettings}
    FormAdvancedSettings.Caption                         := 'AutoStat ' + Verze + ' ' + Localization.ReadString('AdvancedSettings','AdvancedSettings','');
    FormAdvancedSettings_CbSilentMode.Caption            := Localization.ReadString('AdvancedSettings','CbSilentMode','');
    FormAdvancedSettings_CbCheckNewVersion.Caption       := Localization.ReadString('AdvancedSettings','CbCheckNewVersion','');
    FormAdvancedSettings_LabelHomeLat.Caption            := Localization.ReadString('AdvancedSettings','LabelHomeLat','');
    FormAdvancedSettings_LabelHomeLon.Caption            := Localization.ReadString('AdvancedSettings','LabelHomeLon','');
    FormAdvancedSettings_ButtonCoordinates.Caption       := Localization.ReadString('AdvancedSettings','ButtonCoordinates','');
    FormAdvancedSettings_LabelStatistics.Caption         := Localization.ReadString('AdvancedSettings','LabelStatistics','');
    FormAdvancedSettings_LabelTemplate.Caption           := Localization.ReadString('AdvancedSettings','LabelTemplate','');
    FormAdvancedSettings_CbUseGgStatMacro.Caption        := Localization.ReadString('AdvancedSettings','CbUseGgStatMacro','');
    FormAdvancedSettings_CbGenerateCachemap.Caption      := Localization.ReadString('AdvancedSettings','CbGenerateCachemap','');
    FormAdvancedSettings_CbUseCachemapMacro.Caption      := Localization.ReadString('AdvancedSettings','CbUseCachemapMacro','');
    FormAdvancedSettings_CbDownloadLogs.Caption          := Localization.ReadString('AdvancedSettings','CbDownloadLogs','');
    FormAdvancedSettings_CbDownloadOwnLogs.Caption       := Localization.ReadString('AdvancedSettings','CbDownloadOwnLogs','');
    FormAdvancedSettings_CbImportAllFindsFromWeb.Caption := Localization.ReadString('AdvancedSettings','CbImportAllFindsFromWeb','');
    FormAdvancedSettings_CbAddRank.Caption               := Localization.ReadString('AdvancedSettings','CbAddRank','');
    FormAdvancedSettings_CbDivideByPolygon.Caption       := Localization.ReadString('AdvancedSettings','CbDivideByPolygon','');
    FormAdvancedSettings_CbUsePolygonMacro.Caption       := Localization.ReadString('AdvancedSettings','CbUsePolygonMacro','');
    FormAdvancedSettings_CbAddElevation.Caption          := Localization.ReadString('AdvancedSettings','CbAddElevation','');
    FormAdvancedSettings_CbUseElevationMacro.Caption     := Localization.ReadString('AdvancedSettings','CbUseElevationMacro','');
    FormAdvancedSettings_CbGenerateFtfIndex.Caption      := Localization.ReadString('AdvancedSettings','CbGenerateFtfIndex','');
    FormAdvancedSettings_CbGenerateFooter.Caption        := Localization.ReadString('AdvancedSettings','CbGenerateFooter','');
    FormAdvancedSettings_GbCachemap.Caption              := Localization.ReadString('AdvancedSettings','GbCachemap','');
    FormAdvancedSettings_LabelGcCzLogin.Caption          := Localization.ReadString('AdvancedSettings','LabelGcCzLogin','');
    FormAdvancedSettings_LabelGcCzPassword.Caption       := Localization.ReadString('AdvancedSettings','LabelGcCzPassword','');
    FormAdvancedSettings_LabelGcCzUID.Caption            := Localization.ReadString('AdvancedSettings','LabelGcCzUID','');
    FormAdvancedSettings_ButtonGcCzUID.Caption           := Localization.ReadString('AdvancedSettings','ButtonGcCzUID','');
    FormAdvancedSettings_LabelGcCzTypMapy.Caption        := Localization.ReadString('AdvancedSettings','LabelGcCzTypMapy','');
    FormAdvancedSettings_GbGeojarry.Caption              := Localization.ReadString('AdvancedSettings','GbGeojarry','');
    FormAdvancedSettings_LabelGjUsername.Caption         := Localization.ReadString('AdvancedSettings','LabelGjUsername','');
    FormAdvancedSettings_LabelGjPassword.Caption         := Localization.ReadString('AdvancedSettings','LabelGjPassword','');
    FormAdvancedSettings_GbUpload.Caption                := Localization.ReadString('AdvancedSettings','GbUpload','');
    FormAdvancedSettings_RbProfile.Caption               := Localization.ReadString('AdvancedSettings','RbProfile','');
    FormAdvancedSettings_RbFtp.Caption                   := Localization.ReadString('AdvancedSettings','RbFtp','');
    FormAdvancedSettings_LabelFtpUrl.Caption             := Localization.ReadString('AdvancedSettings','LabelFtpUrl','');
    FormAdvancedSettings_LabelFtpUser.Caption            := Localization.ReadString('AdvancedSettings','LabelFtpUser','');
    FormAdvancedSettings_LabelFtpPassword.Caption        := Localization.ReadString('AdvancedSettings','LabelFtpPassword','');
    FormAdvancedSettings_LabelFtpDirectory.Caption       := Localization.ReadString('AdvancedSettings','LabelFtpDirectory','');
    FormAdvancedSettings_ButtonOpenTemplate.Caption      := Localization.ReadString('AdvancedSettings','ButtonOpenTemplate','');
    FormAdvancedSettings_ButtonOpenReadme.Caption        := Localization.ReadString('AdvancedSettings','ButtonOpenReadme','');
    FormAdvancedSettings_ButtonSave.Caption              := Localization.ReadString('AdvancedSettings','ButtonSave','');
    FormAdvancedSettings_ButtonCancel.Caption            := Localization.ReadString('AdvancedSettings','ButtonCancel','');
    FormAdvancedSettings_ButtonAbout.Caption             := Localization.ReadString('AdvancedSettings','ButtonAbout','');
    {FormAbout}
    FormAbout.Caption                   := 'AutoStat ' + Verze + ' ' + Localization.ReadString('About','About','');
    FormAbout_ButtonClose.Caption       := Localization.ReadString('About','ButtonClose','');
    FormAbout_ButtonCheckUpdate.Caption := Localization.ReadString('About','ButtonCheckUpdate','');
  end;
end;

{ziska nadm. vysku bodu podle zadanych souradnic}
function GetElevation(Lat,Lon: String): Integer;
var
  s,p :String;
  i   :Integer;
begin
  i := srtmElevation(StrToFl(Lat),StrToFl(Lon),Geoget_DataDir + '\srtm\');
  if i > -32768 then
  begin
    Result := i;
    Exit;
  end;
  s := '';
  i := -32768;
  p := '?lat=' + Lat + '&lng=' + Lon;
  if HttpAsk('GET',Url + '/srtm3' + p,'','',s) then
  begin
    s := ReplaceString(s,CRLF, '');
   	s := Trim(s);
    i := StrToIntDef(s,-32768);
    if i = -32768 then
    begin
      if HttpAsk('GET',Url + '/gtopo30' + p,'','',s) then
      begin
        s := ReplaceString(s,CRLF,'');
        s := Trim(s);
        i := StrToIntDef(s,-32768);
      end
      else
        Inc(ErrCnt);
    end;
  end
  else
    Inc(ErrCnt);
  Result := i;
end;

{funkce priradi kesim tag s nadm. vyskou}
procedure SetElevationTag;
var
  Lat,Lon :String;
  h       :String;
  i       :Integer;
begin
  if ErrFlag then Exit;
  if ErrCnt >= 3 then
  begin
    ShowMessage('Nemohu se pipojit k serveru Geonames.org.' + CRLF +
                'Zkus to prosm pozdji!');
    ErrFlag := true;
    Exit;
  end;
  Lat := GC.CorrectedLat;
  Lon := GC.CorrectedLon;
  h := Lat + ' ' + Lon;
  if GC.HaveFinal and (h <> (GC.Lat + ' ' + GC.Lon)) then
  begin
    if h <> GC.TagValues(TagElevcoord) then
    begin
      i := GetElevation(Lat,Lon);
      if i > -8000 then
      begin
        GC.TagReplace(TagElev,IntToStr(i));
        GC.TagReplace(TagElevcoord,h);
      end;
    end;
  end
  else
  if not GC.tagHavecategory(TagElev) then
  begin
    i := GetElevation(Lat,Lon);
    if i > -8000 then GC.TagAdd(TagElev,IntToStr(i));
  end;
end;

{funkce priradi kesim tag s krajem a okresem}
procedure SetPolygonTag;
var
  s :String;
begin
  if GC.Country <> ForCountry then Exit;
  {pokud ma final, prepis podle finalnich souradnic!}
  if GC.HaveFinal then
  begin
    s := CzKraje.FindPolygon(GC.CorrectedCoordXNum,GC.CorrectedCoordYNum);
    if s <> '' then GC.TagReplace(TagKraj,AnsiToUtf(s));
    s := CzOkresy.FindPolygon(GC.CorrectedCoordXNum,GC.CorrectedCoordYNum);
    if s <> '' then GC.TagReplace(TagOkres,AnsiToUtf(s));
  end;
  {Jinak dopln, pokud keska jeste nic prirazeno nema.}
  if not GC.tagHavecategory(TagKraj) then
  begin
    s := CzKraje.FindPolygon(GC.CoordXNum,GC.CoordYNum);
    if s <> '' then GC.TagAdd(TagKraj,AnsiToUtf(s));
  end;
  if not GC.tagHavecategory(TagOkres) then
  begin
    s := CzOkresy.FindPolygon(GC.CoordXNum,GC.CoordYNum);
    if s <> '' then GC.TagAdd(TagOkres,AnsiToUtf(s));
  end;
end;

{Hleda soubor v dadanem adresari (vcetne podslozek). vraci celou cestu k souboru}
function SearchFile(StartDir,Filename: String): String;
var
   Files,Queue : TStringList;
   n : Integer;
   q : String;
begin
  Result := 'Soubor nenalezen!';
  if not RegexFind('\$',StartDir) then StartDir := StartDir + '\';
  if DirectoryExists(StartDir) then
  begin
    Files := TStringList.Create;
    Queue := TStringList.Create;
    try
      Queue.Add(StartDir);
      while (Queue.Count > 0) do
      begin
        q := Queue[0];
        FileList(q,Files); Queue.Delete(0);
        for n := 0 to Files.Count-1 do
        begin
          if RegexFind('\\$',Files[n])
            then Queue.Add(Files[n])
            else
            begin
              if ReplaceString(Files[n],q,'') = Filename then
              begin
                Result := Files[n];
                Break;
              end;
            end;
        end;
        if Result <> ('Soubor nenalezen!') then Break;
      end;
    finally
      Queue.Free;
      Files.Free;
    end;
  end;
end;

{kontrola novych verzi}
procedure CheckUpdates(Sender: TObject);
var
  VerzeOnline :String;
begin
  try
    Options := TIniFile.Create(AutoStatPath + '\AutoStat.ini');
    if Options.ReadBool('AutoStat','CheckNewVersion',true) then
    begin
      {vrati verzi autostatu na webu ve formatu '2.39'}
      HttpAsk('GET','http://gc.mikrom.cz/autostat.php','','',VerzeOnline);
      {vyhodime tecku a porovname s aktualni verzi bez tecky (239 > 238)}
      if (StrToInt(ReplaceString(VerzeOnline,'.','')) > StrToInt(ReplaceString(Verze,'.',''))) then
      begin
        case MessBox('Upozornn: na webu je nov verze AutoStatu!' + CRLF +
                     'Vae verze: ' + Verze + CRLF +
                     'Verze na webu: ' + VerzeOnline + CRLF + CRLF +
                     'Chcete ji nyn sthnout?',
                     'Nov verze AutoStatu!',4) of
          6: begin
            RunShell('http://mikrom.cz/index.php?docs&file=92');
            RunShell('"' + AutoStatPath + '"');
            GeoAbort;
          end;
        end;
      end
      else if Sender = FormAbout_ButtonCheckUpdate then ShowMessage('dn novj verze nenalezena!');
    end;
  finally
    Options.Free;
  end;
end;

{ukaze okno 'O makru...'}
procedure ShowAbout(Sender: TObject);
begin
  {Peklad}
  if (Language <> 'Czech') then Translate(Language);
  FormAbout.ShowModal;
end;

{vyhazuje okno s chybou s moznosti sestrelit autostat}
procedure ShowErrorMessage(txt: String);
begin
  if (MessBox(txt + CRLF + CRLF + 'Pokraovat v exportu?','GeoGet',4) = 7) then GeoAbort;
end;

{vyhodi okno s popisem chyby geojarryho}
procedure ShowGeojarryError(id: Integer);
begin
  case id of
    3: ShowErrorMessage('GeoJarry chyba: Soubor nenalezen!');
    4: ShowErrorMessage('GeoJarry chyba: Staen neplatn soubor!');
    253: ShowErrorMessage('GeoJarry chyba: Nepodailo se pihlsit na geocaching.com!');
    254: ShowErrorMessage('GeoJarry chyba: Problm v HTTP komunikaci!');
    255: ShowErrorMessage('GeoJarry: Stornovno uivatelem!');
    else ShowErrorMessage('GeoJarry chyba!')
  end;
end;

{dialog pro ziskani domacich souradnic}
procedure SetHomeCoordinates(Sender: TObject);
var
  HomeLatInt, HomeLonInt: Extended;
begin
  HomeLatInt := StrToFl(FormAdvancedSettings_EditHomeLat.Text);
  HomeLonInt := StrToFl(FormAdvancedSettings_EditHomeLon.Text);
  if CoordEdit('Domc souadnice','Zde zadejte Vae domc souadnice',HomeLatInt,HomeLonInt) then
  begin
    if (HomeLatInt = 0) or (HomeLonInt = 0) then ShowMessage('Chyba: Neplatn souadnice!');
    FormAdvancedSettings_EditHomeLat.Text := FlToStr(HomeLatInt);
    FormAdvancedSettings_EditHomeLon.Text := FlToStr(HomeLonInt);
  end;
end;

{kontroluje uziv. jmeno, pokud obsahuje mezeru tak ho zabali do uvozovek}
function ValidateOwnerName(GEOGET_OWNER: String): String;
begin
  if Pos(' ',GEOGET_OWNER) = 0 then
    {pokud GEOGET_OWNER je bez mezery pouzijeme ho}
    Result := GEOGET_OWNER
  else if Pos('"',GEOGET_OWNER) <> 0 then
    {pokud GEOGET_OWNER obsahuje mezeru a je v uvozovkach pouzijeme ho}
    Result := GEOGET_OWNER
  else
    {pokud GEOGET_OWNER obsahuje mezeru a neni v uvozovkach dame ho do uvozovek}
    Result := QuoteStr(GEOGET_OWNER,'"');
end;

{kontroluje zda jsou zadane souradnice ve spravnem formatu (00.000000)}
procedure IsValidCoord(Sender: TObject);
begin
  if not RegexFind('^[0]?[0-9]{2}\.[0-9]{0,20}$',TEdit(Sender).Text) then
  begin
    {propusti jen 12.34567 nebo 0123.456789}
    ShowMessage('Chyba: Neplatn formt souadnic! Souadnice mus bt' + CRLF +
                'pouze v desetinnm formtu! Nap: 50.568708 a 15.313619');
    TEdit(Sender).Text := '';
  end;
end;

{kontroluje zda je zadane UID cislo, jen tak pro sichr}
procedure IsValidUid(Sender: TObject);
begin
  if not RegexFind('^[0-9]*$',TEdit(Sender).Text) then
  begin
    {propusti jen cislo}
    if MessBox('Chyba: UID mus bt slo!' + CRLF + 'Podvat se na frum jak ho zjistit?','GeoGet - Chyba',1) = 1 then
      RunShell('http://www.geocaching.cz/forum/viewthread.php?forum_id=28&thread_id=8091');
    TEdit(Sender).Text := '';
  end;
end;

{ziskame maximalni hodnotu progressbaru}
function GetFoundAndHidden: Integer;
begin
  {pocet nalezenych}
  Result := Geoget_DB.GetTableValue('SELECT count(*) FROM geocache WHERE dtfound > 0');
  {pocet zalozenych}
  Result := Result + Geoget_DB.GetTableValue('SELECT count(*) FROM geocache WHERE author = ''' + GEOGET_OWNER + '''');
end;

{funkce pro vycteni HOME souradnic}
function GetHomeCoordinates(coord: String): String;
var
  lat, lon: extended;
begin
  if RefPointGet('HOME',lat,lon) then
  begin
    case coord of
      'lat': Result := FlToStr(lat);
      'lon': Result := FlToStr(lon);
    end;
  end;
end;

{funkce pro ziskani hodnot ze staryho konfiguraku AutoStat.config.pas (neco jako cteni z *.ini)}
function GetVariableValue(FilePath,Variable: String): String;
var
  ValuePos  :Integer;
  Value     :String;
begin
  if RegexFind('\.config.pas$',FilePath) then
  begin
    FilePath := Trim(FileToString(FilePath));
    {pozice hodnoty (k pozici promenne pricteme jeji delku a 4 znaky)}
    ValuePos := Pos(Variable,FilePath) + Length(Variable) + 4;
    {od zacatku hodnoty si vemem treba 20 znaku}
    Value := Copy(FilePath,ValuePos,20);
    {a ty od prvni uvozovky dal odkrojime}
    Value := Copy(FilePath,ValuePos,Pos('''',Value) - 1);
    Result := Value;
  end;
end;

{povoluje a zakazuje nejaky nastaveni podle nastaveni jinych zatrzitek}
procedure EnablingOptions(Sender: TObject);
var
  tmp: Boolean;
begin
  {cachemapa a makra elevation a polygon}
  FormAdvancedSettings_CbUseElevationMacro.Enabled := FormAdvancedSettings_CbAddElevation.Checked;
  FormAdvancedSettings_CbUsePolygonMacro.Enabled := FormAdvancedSettings_CbDivideByPolygon.Checked;
  FormAdvancedSettings_CbUseCachemapMacro.Enabled := FormAdvancedSettings_CbGenerateCachemap.Checked;
  {nastaveni geocaching.cz bude povoleno pouze pokud bude potreba}
  tmp := FormAdvancedSettings_CbGenerateCachemap.Checked or FormAdvancedSettings_CbAddRank.Checked;
  FormAdvancedSettings_EditGcCzLogin.Enabled := tmp;
  FormAdvancedSettings_EditGcCzPassword.Enabled := tmp;
  FormAdvancedSettings_EditGcCzUID.Enabled := tmp;
  FormAdvancedSettings_EditGcCzTypMapy.Enabled := tmp and (FormAdvancedSettings_EditGcCzUID.Text <> '');
  FormAdvancedSettings_LabelGcCzLogin.Enabled := tmp;
  FormAdvancedSettings_LabelGcCzPassword.Enabled := tmp;
  FormAdvancedSettings_LabelGcCzUID.Enabled := tmp;
  FormAdvancedSettings_ButtonGcCzUID.Enabled := tmp;
  FormAdvancedSettings_LabelGcCzTypMapy.Enabled := tmp and (FormAdvancedSettings_EditGcCzUID.Text <> '');
  {paticka bude povolena pouze pokud je zaskrtnuta}
  FormAdvancedSettings_EditFooterText.Enabled := FormAdvancedSettings_CbGenerateFooter.Checked;
  {nastaveni FTP je povoleno pouze pokud je FTP zaskrtnuto}
  tmp := FormAdvancedSettings_RbFtp.Checked;
  FormAdvancedSettings_EditFtpUrl.Enabled := tmp;
  FormAdvancedSettings_EditFtpUser.Enabled := tmp;
  FormAdvancedSettings_EditFtpPassword.Enabled := tmp;
  FormAdvancedSettings_EditFtpDirectory.Enabled := tmp;
  FormAdvancedSettings_LabelFtpUrl.Enabled := tmp;
  FormAdvancedSettings_LabelFtpUser.Enabled := tmp;
  FormAdvancedSettings_LabelFtpPassword.Enabled := tmp;
  FormAdvancedSettings_LabelFtpDirectory.Enabled := tmp;
  {nastaveni GeoJarryho je povoleno pouze pokud bude GeoJarry potreba}
  tmp := FormAdvancedSettings_CbDownloadLogs.Checked or FormAdvancedSettings_CbDownloadOwnLogs.Checked or FormAdvancedSettings_RbProfile.Checked;
  FormAdvancedSettings_EditGjUsername.Enabled := tmp;
  FormAdvancedSettings_EditGjPassword.Enabled := tmp;
  FormAdvancedSettings_LabelGjUsername.Enabled := tmp;
  FormAdvancedSettings_LabelGjPassword.Enabled := tmp;
  {tlacitko pro otevreni template bude aktivni jen, pokud bude nejaky template vybrano}
  FormAdvancedSettings_ButtonOpenTemplate.Enabled := FormAdvancedSettings_EditTemplate.Text <> '';
  {vyber databaze}
  FormAdvancedSettings_EditDatabaseSelect.Enabled := not FormAdvancedSettings_CbUseCurrentDatabase.Checked;
  FormAdvancedSettings_EditDatabaseSelect.Text := Database;
end;

{smazani docasny slozky c:\documents and settings\[USER]\local settings\temp\par-[USER]}
procedure DeleteParFolder;
var
  Akce    :String;
  DelTemp :String;
begin
  GeoBusyKind('Mau sloku par-...');
  DelTemp := 'rmdir /s /q %TEMP%\par-%USERNAME%';
  Akce := GEOGET_DATADIR + '\DelTemp.bat';
  if not SilentMode then ShowErrorMessage('DelTemp.bat' + CRLF + CRLF + DelTemp);
  StringToFile(DelTemp,Akce);
  RunExec(Akce);
  if SilentMode then DeleteFile(Akce);
end;

{smazani docasnych a nepotrebnych souboru - DOCASNY}
procedure DeleteUselessFiles;
var
  tmp: String;
begin
  tmp := SearchFile(GEOGET_DATADIR,'AutoStat.options.txt');
  if ((tmp <> 'Soubor nenalezen!') and (FileExists(tmp))) then DeleteFile(tmp);
  tmp := SearchFile(GEOGET_DATADIR,'AutoStat-GgStat.ggp.pas');
  if ((tmp <> 'Soubor nenalezen!') and (FileExists(tmp))) then DeleteFile(tmp);
  tmp := SearchFile(GEOGET_DATADIR,'AutoStat.config.pas');
  if ((tmp <> 'Soubor nenalezen!') and (FileExists(tmp))) then DeleteFile(tmp);
  tmp := SearchFile(GEOGET_DATADIR,'AutoStat.default.pas');
  if ((tmp <> 'Soubor nenalezen!') and (FileExists(tmp))) then DeleteFile(tmp);
end;

{vytvorime AutoStat.FTP.bat}
procedure MakeBatFile;
var
  UploadBat :String;
begin
  try
    UploadBat := '@echo off' + CRLF;
    UploadBat := UploadBat + 'setlocal' + CRLF;
    UploadBat := UploadBat + 'set file=' + Statistics + CRLF;
    UploadBat := UploadBat + 'set f=log.txt' + CRLF;
    UploadBat := UploadBat + 'set web=' + FtpUrl + CRLF;
    UploadBat := UploadBat + 'set name=' + FtpName + CRLF;
    UploadBat := UploadBat + 'set password=' + FtpPassword + CRLF;
    UploadBat := UploadBat + 'echo open %web% > %f%' + CRLF;
    UploadBat := UploadBat + 'echo user %name% %password% >> %f%' + CRLF;
    UploadBat := UploadBat + 'echo binary >> %f%' + CRLF;
    UploadBat := UploadBat + 'echo cd ' + FtpDirectory + '>> %f%' + CRLF;
    UploadBat := UploadBat + 'echo put %file% >> %f%' + CRLF;
    UploadBat := UploadBat + 'echo bye >> %f%' + CRLF;
    UploadBat := UploadBat + 'ftp -n -d -s:%f%' + CRLF;
    UploadBat := UploadBat + 'del /f /q %f%' + CRLF;
    UploadBat := UploadBat + 'endlocal' + CRLF;
    UploadBat := UploadBat + 'exit' + CRLF;
    UploadBatFile := AutoStatPath + '\AutoStat.FTP.bat';
    if not SilentMode then ShowErrorMessage('AutoStat.FTP.bat' + CRLF + CRLF + UploadBat);
  finally
    StringToFile(UploadBat,UploadBatFile);
  end;
end;

{vytvoreni gjtemp.ini}
procedure MakeGeojarryIni;
var
  GjIni :String;
begin
  try
    GjIni := '[geojarry]' + CRLF;
    GjIni := GjIni + 'username='   + GjUsername + CRLF;
    GjIni := GjIni + 'password='   + GjPassword + CRLF;
    GjIni := GjIni + 'proxyip='    + GEOGET_PROXYHOST + CRLF;
    GjIni := GjIni + 'proxyport='  + GEOGET_PROXYPORT + CRLF;
    GjIni := GjIni + 'proxyuser='  + GEOGET_PROXYUSER + CRLF;
    GjIni := GjIni + 'proxypass='  + GEOGET_PROXYPASS + CRLF;
    GjIni := GjIni + 'sessionfile=gjsession.' + GjUsername + '.txt' + CRLF;
    Forcedirectories(GEOGET_DATADIR + '\gjtemp\');
    DeleteFiles(GEOGET_DATADIR + '\gjtemp\*.*');
    GjIni := GjIni + 'datadir=' + GEOGET_DATADIR + '\gjtemp\' + CRLF;
    GeojarryIni := GEOGET_DATADIR + '\gjtemp.ini';
    if not SilentMode then ShowErrorMessage('gjtemp.ini' + CRLF + CRLF + GjIni);
  finally
    StringTofile(GjIni,GeojarryIni);
  end;
end;

{implementovano makro geojarry-my.ggp.pas}
procedure GeojarryMy;
begin
  Akce := '"' + GeojarryExe + '" "' + GeojarryIni + '" list "ul=' + EncodeURLelement(GjUsername) + '"';
  if not SilentMode then ShowErrorMessage('Stahovn seznamu nalezench ke...' + CRLF + CRLF + Akce);
  GeojarryResult := RunExec(Akce);
  case GeojarryResult of
    0: begin
      GeoImportDir(GEOGET_DATADIR + '\gjtemp\');
      if SilentMode then DeleteFiles(GEOGET_DATADIR + '\gjtemp\*.*');
      {a ty pak oznacime jako nalezene}
      Akce := '"' + GeojarryExe + '" "' + GeojarryIni + '" raw "http://www.geocaching.com/my/logs.aspx?s=1"';
      if not SilentMode then ShowErrorMessage('Stahovn listing nalezench ke...' + CRLF + CRLF + Akce);
      GeojarryResult := RunExec(Akce);
      case GeojarryResult of
        0: begin
          GeoImportDir(GEOGET_DATADIR + '\gjtemp\');
          if SilentMode then DeleteFiles(GEOGET_DATADIR + '\gjtemp\*.*');
          //GeoImportEnd;
        end;
        else ShowGeojarryError(GeojarryResult);
      end;
    end;
    else ShowGeojarryError(GeojarryResult);
  end;
end;

{nacte nastaveni z ini, pozatmo z configu pokud jeste ini neni}
procedure ReadSettings;
var
  AutoStatConfigPas: String;
  tmp:               String;
begin
  if not FileExists(AutoStatPath + '\AutoStat.ini') then
  begin
    tmp := SearchFile(GEOGET_DATADIR,'AutoStat.config.pas');
    if ((tmp <> 'Soubor nenalezen!') and (FileExists(tmp))) then
    begin
      AutoStatConfigPas := tmp;
      {pokud neexistuje soubor AutoStat.ini, tak si vezmeme nastaveni z AutoStat.config.pas
      a ulozime si ho do AutoStat.ini}
      Options := TIniFile.Create(AutoStatPath + '\AutoStat.ini');
      try
        with Options do
        begin
          WriteString('AutoStat','Statistics',GetVariableValue(AutoStatConfigPas,'Statistics'));
          WriteString('AutoStat','Template',GetVariableValue(AutoStatConfigPas,'Template'));
          WriteString('AutoStat','HomeLat',GetVariableValue(AutoStatConfigPas,'HomeLat'));
          WriteString('AutoStat','HomeLon',GetVariableValue(AutoStatConfigPas,'HomeLon'));
          WriteBool('AutoStat','SilentMode',GetVariableValue(AutoStatConfigPas,'SilentMode') = 'yes');
          WriteBool('AutoStat','CheckNewVersion',GetVariableValue(AutoStatConfigPas,'CheckNewVersion') = 'yes');
          WriteBool('AutoStat','UseGgStatMacro',GetVariableValue(AutoStatConfigPas,'UseGgStatMacro') = 'yes');
          WriteBool('AutoStat','GenerateCachemap',GetVariableValue(AutoStatConfigPas,'GenerateCachemap') = 'yes');
          WriteBool('AutoStat','UseCachemapMacro',GetVariableValue(AutoStatConfigPas,'UseCachemapMacro') = 'yes');
          WriteString('AutoStat','GcCzLogin',GetVariableValue(AutoStatConfigPas,'GcCzLogin'));
          WriteString('AutoStat','GcCzPassword',GetVariableValue(AutoStatConfigPas,'GcCzPassword'));
          WriteString('AutoStat','GcCzUID',GetVariableValue(AutoStatConfigPas,'GcCzUID'));
          WriteString('AutoStat','GcCzTypMapy',GetVariableValue(AutoStatConfigPas,'GcCzTypMapy'));
          WriteBool('AutoStat','DownloadLogs',GetVariableValue(AutoStatConfigPas,'DownloadLogs') = 'yes');
          WriteBool('AutoStat','DownloadOwnLogs',GetVariableValue(AutoStatConfigPas,'DownloadOwnLogs') = 'yes');
          WriteBool('AutoStat','ImportAllFindsFromWeb',GetVariableValue(AutoStatConfigPas,'ImportAllFindsFromWeb') = 'yes');
          WriteBool('AutoStat','AddRank',GetVariableValue(AutoStatConfigPas,'AddRank') = 'yes');
          WriteBool('AutoStat','DivideByPolygon',GetVariableValue(AutoStatConfigPas,'DivideByPolygon') = 'yes');
          WriteBool('AutoStat','UsePolygonMacro',GetVariableValue(AutoStatConfigPas,'UsePolygonMacro') = 'yes');
          WriteBool('AutoStat','AddElevation',GetVariableValue(AutoStatConfigPas,'AddElevation') = 'yes');
          WriteBool('AutoStat','UseElevationMacro',GetVariableValue(AutoStatConfigPas,'UseElevationMacro') = 'yes');
          WriteBool('AutoStat','GeojarryForUpload',GetVariableValue(AutoStatConfigPas,'GeojarryForUpload') = 'yes');
          WriteString('AutoStat','FtpUrl',GetVariableValue(AutoStatConfigPas,'FtpUrl'));
          WriteString('AutoStat','FtpName',GetVariableValue(AutoStatConfigPas,'FtpName'));
          WriteString('AutoStat','FtpPassword',GetVariableValue(AutoStatConfigPas,'FtpPassword'));
          WriteString('AutoStat','FtpDirectory',GetVariableValue(AutoStatConfigPas,'FtpDirectory'));
          WriteBool('AutoStat','GenerateFTFindex',GetVariableValue(AutoStatConfigPas,'GenerateFTFindex') = 'yes');
          WriteBool('AutoStat','GenerateFooter',GetVariableValue(AutoStatConfigPas,'GenerateFooter') = 'yes');
        end;
      finally
        Options.Free;
      end;
    end;
  end
  else
  begin
    {nacteme si hodnoty z AutoStat.ini}
    Options := TIniFile.Create(AutoStatPath + '\AutoStat.ini');
    try
      Statistics             := Options.ReadString('AutoStat','Statistics','GgStats.html');
      Template               := Options.ReadString('AutoStat','Template','GgStatTemplate.cz');
      HomeLat                := Options.ReadString('AutoStat','HomeLat',GetHomeCoordinates('lat'));
      HomeLon                := Options.ReadString('AutoStat','HomeLon',GetHomeCoordinates('lon'));
      SilentMode             := Options.ReadBool('AutoStat','SilentMode',true);
      CheckNewVersion        := Options.ReadBool('AutoStat','CheckNewVersion',true);
      UseCurrentDatabase     := Options.ReadBool('AutoStat','UseCurrentDatabase',true);
      Database               := Options.ReadString('AutoStat','Database',GEOGET_DBNAME);
      UseGgStatMacro         := Options.ReadBool('AutoStat','UseGgStatMacro',false);
      GenerateCachemap       := Options.ReadBool('AutoStat','GenerateCachemap',true);
      UseCachemapMacro       := Options.ReadBool('AutoStat','UseCachemapMacro',false);
      GcCzLogin              := Options.ReadString('AutoStat','GcCzLogin',GetVariableValue(GeocachingCzConfig,'gcUsername'));
      GcCzPassword           := Options.ReadString('AutoStat','GcCzPassword',GetVariableValue(GeocachingCzConfig,'gcPassword'));
      GcCzUID                := Options.ReadString('AutoStat','GcCzUID','');
      GcCzTypMapy            := Options.ReadString('AutoStat','GcCzTypMapy','');
      DownloadLogs           := Options.ReadBool('AutoStat','DownloadLogs',true);
      DownloadOwnLogs        := Options.ReadBool('AutoStat','DownloadOwnLogs',true);
      ImportAllFindsFromWeb  := Options.ReadBool('AutoStat','ImportAllFindsFromWeb',false);
      AddRank                := Options.ReadBool('AutoStat','AddRank',true);
      DivideByPolygon        := Options.ReadBool('AutoStat','DivideByPolygon',false);
      UsePolygonMacro        := Options.ReadBool('AutoStat','UsePolygonMacro',false);
      AddElevation           := Options.ReadBool('AutoStat','AddElevation',false);
      UseElevationMacro      := Options.ReadBool('AutoStat','UseElevationMacro',false);
      GeojarryForUpload      := Options.ReadBool('AutoStat','GeojarryForUpload',false);
      FtpUrl                 := Options.ReadString('AutoStat','FtpUrl','');
      FtpName                := Options.ReadString('AutoStat','FtpName','');
      FtpPassword            := Options.ReadString('AutoStat','FtpPassword','');
      FtpDirectory           := Options.ReadString('AutoStat','FtpDirectory','');
      GjUsername             := Options.ReadString('AutoStat','GjUsername',GetVariableValue(GeojarryConfig,'gjUsername'));
      GjPassword             := Options.ReadString('AutoStat','GjPassword',GetVariableValue(GeojarryConfig,'gjPassword'));
      GenerateFtfIndex       := Options.ReadBool('AutoStat','GenerateFTFindex',false);
      GenerateFooter         := Options.ReadBool('AutoStat','GenerateFooter',true);
      FooterText             := Options.ReadString('AutoStat','FooterText','<div align="center" style="width: 100%; background-color: #FFFFFF; font-family: Verdana, Arial, sans-serif; font-size: 12px; color: 000000; margin: 1px; border: none;">Statistiky generovan %CURRENTDATE% | <a href="http://www.geocaching.com/profile/?u=mikrom">mikrom</a> | Lb? Koukni <a href="http://mikrom.cz/341-autostat">jak na n</a>!</div>');
      Language               := Options.ReadString('AutoStat','Language','Czech');
    finally
      Options.Free;
    end;
    if UseCurrentDatabase then Database := GEOGET_DBNAME;
  end;
end;

{zapise hodnoty do AutoStat.ini}
procedure SaveSettings;
begin
  Options := TIniFile.Create(AutoStatPath + '\AutoStat.ini');
  try
    with Options do
    begin
      WriteString('AutoStat','Statistics',FormAdvancedSettings_EditStatistics.Text);
      WriteString('AutoStat','Template',FormAdvancedSettings_EditTemplate.Text);
      WriteString('AutoStat','HomeLat',FormAdvancedSettings_EditHomeLat.Text);
      WriteString('AutoStat','HomeLon',FormAdvancedSettings_EditHomeLon.Text);
      WriteBool('AutoStat','SilentMode',FormAdvancedSettings_CbSilentMode.Checked);
      WriteBool('AutoStat','CheckNewVersion',FormAdvancedSettings_CbCheckNewVersion.Checked);
      WriteBool('AutoStat','UseCurrentDatabase',FormAdvancedSettings_CbUseCurrentDatabase.Checked);
      WriteString('AutoStat','Database',FormAdvancedSettings_EditDatabaseSelect.Text);
      WriteBool('AutoStat','UseGgStatMacro',FormAdvancedSettings_CbUseGgStatMacro.Checked);
      WriteBool('AutoStat','GenerateCachemap',FormAdvancedSettings_CbGenerateCachemap.Checked);
      WriteBool('AutoStat','UseCachemapMacro',FormAdvancedSettings_CbUseCachemapMacro.Checked);
      WriteString('AutoStat','GcCzLogin',FormAdvancedSettings_EditGcCzLogin.Text);
      WriteString('AutoStat','GcCzPassword',FormAdvancedSettings_EditGcCzPassword.Text);
      WriteString('AutoStat','GcCzUID',FormAdvancedSettings_EditGcCzUID.Text);
      WriteString('AutoStat','GcCzTypMapy',FormAdvancedSettings_EditGcCzTypMapy.Text);
      WriteBool('AutoStat','DownloadLogs',FormAdvancedSettings_CbDownloadLogs.Checked);
      WriteBool('AutoStat','DownloadOwnLogs',FormAdvancedSettings_CbDownloadOwnLogs.Checked);
      WriteBool('AutoStat','ImportAllFindsFromWeb',FormAdvancedSettings_CbImportAllFindsFromWeb.Checked);
      WriteBool('AutoStat','AddRank',FormAdvancedSettings_CbAddRank.Checked);
      WriteBool('AutoStat','DivideByPolygon',FormAdvancedSettings_CbDivideByPolygon.Checked);
      WriteBool('AutoStat','UsePolygonMacro',FormAdvancedSettings_CbUsePolygonMacro.Checked);
      WriteBool('AutoStat','AddElevation',FormAdvancedSettings_CbAddElevation.Checked);
      WriteBool('AutoStat','UseElevationMacro',FormAdvancedSettings_CbUseElevationMacro.Checked);
      WriteBool('AutoStat','GeojarryForUpload',FormAdvancedSettings_RbProfile.Checked);
      WriteString('AutoStat','FtpUrl',FormAdvancedSettings_EditFtpUrl.Text);
      WriteString('AutoStat','FtpName',FormAdvancedSettings_EditFtpUser.Text);
      WriteString('AutoStat','FtpPassword',FormAdvancedSettings_EditFtpPassword.Text);
      WriteString('AutoStat','FtpDirectory',FormAdvancedSettings_EditFtpDirectory.Text);
      WriteString('AutoStat','GjUsername',FormAdvancedSettings_EditGjUsername.Text);
      WriteString('AutoStat','GjPassword',FormAdvancedSettings_EditGjPassword.Text);
      WriteBool('AutoStat','GenerateFTFindex',FormAdvancedSettings_CbGenerateFtfIndex.Checked);
      WriteBool('AutoStat','GenerateFooter',FormAdvancedSettings_CbGenerateFooter.Checked);
      WriteString('AutoStat','FooterText',FormAdvancedSettings_EditFooterText.Text);
    end;
  finally
    Options.Free;
  end;
end;

{generovani pres Autostat, kterej si sam zavola GgStat.exe}
procedure MakeStats;
begin
  GeoBusyProgress(0,0);
  GeoBusyCaption('Generovn statistik...');
  GeoBusyKind('GgStat...');

  {orig prikaz}
  {RunExec('"' + GgStat + '" -d "' + GEOGET_DATADIR + '/geoget.db3" -o "' + Statistics + '" -t "' + Template + '" -x ' + Geoget_RefX + ' -y ' + Geoget_RefY + ' -c ' + GEOGET_OWNER);}
  {prikaz pro zavolani GgStat.exe}
  Akce := 'script\GgStat\GgStat.exe' +
          ' -d ' + Database + '.db3' +
          ' -o ' + Statistics +
          ' -t ' + Template +
          ' -x ' + HomeLat +
          ' -y ' + HomeLon +
          ' -c ' + ValidateOwnerName(GEOGET_OWNER);
          {no a v pripade vypnutyho silentmodu pridame '-q' aby se ukazoval prubeh ggstatu v okynku}
          if SilentMode then Akce := Akce + ' -q';

  if not SilentMode then ShowErrorMessage('Generovn statistik pomoc GgStat.exe...' + CRLF + CRLF + Akce);

  {vytvorime BATak AutoStat.GgStat.bat}
  GgStatBat := GEOGET_DATADIR + '\AutoStat.GgStat.bat';
  StringTofile(Akce,GgStatBat);
  RunExec(GgStatBat);
  if SilentMode then DeleteFile(GEOGET_DATADIR + '\AutoStat.GgStat.bat');
end;

{otevre instalacni adresar AutoStatu}
procedure OpenAutostatFolder(Sender: TObject);
begin
  RunShell(AutoStatPath);
end;

{otevre soubor se sablonou}
procedure OpenTemplate(Sender: TObject);
begin
  try
    RunExec('notepad ' + Template);
  //except
    //ShowErrorMessage('Chyba "OpenTemplate": Nepodailo se otevt soubor ' + Template + ' pomoc programu notepad');
  finally
    FormAdvancedSettings.Close;
  end;
end;

{otevre dialog pro otevreni souboru Template}
procedure OpenTemplateFile(Sender: TObject);
begin
  if OpenDlg('Vbr ablony (Template) pro GgStat',GEOGET_DATADIR,'ofFileMustExist','Soubory template (*.cz, *.en)|*.cz;*.en|Vechny soubory (*.*)|*.*',Template) then
  begin
    {odmazeme cestu a nechame jen nazev souboru 'ExtractFileName()'}
    Template := RegexReplace('^.*\\',Template,'',false);
    {a aktualizujeme nazev v policku}
    FormAdvancedSettings_EditTemplate.Text := Template;
  end;
end;

{otevre dokumentaci GgStatu pokud je dostupna}
procedure OpenReadme(Sender: TObject);
//var
  //tmp: String;
begin
  if FileExists(GEOGET_DATADIR + '\GgStatDoc\index.html') then
    RunShell(GEOGET_DATADIR + '\GgStatDoc\index.html');
end;

{prime spusteni GgStatu}
procedure RunGgStat(Sender: TObject);
begin
  DeleteParFolder;
  MakeStats;
  RunShell(Statistics);
end;

{odkaz na stranku gGgStatu}
procedure GotoUrlGgStat(Sender: TObject);
begin
  RunShell('http://geoget.ararat.cz/doku.php/doc:user:ggstat');
end;

{odkaz na muj blog}
procedure GotoUrlMikromcz(Sender: TObject);
begin
  RunShell('http://mikrom.cz');
end;

{odkaz na forum do sekce AutoStat}
procedure GotoUrlForumAutoStat(Sender: TObject);
begin
  RunShell('http://www.geocaching.cz/forum/viewthread.php?forum_id=20&thread_id=10901');
end;

{odkaz na forum do sekce UID}
procedure GotoUrlForumUid(Sender: TObject);
begin
  RunShell('http://www.geocaching.cz/forum/viewthread.php?forum_id=28&thread_id=8091');
end;

{nastavi formularum vse potrebny}
procedure SetActions;
begin
  EnablingOptions(nil);
  {FormSettings}
  FormSettings.Caption := 'AutoStat ' + Verze;
  FormSettings_CbSilentMode.Checked := SilentMode;
  FormSettings_CbGenerateCachemap.Checked := GenerateCachemap;
  FormSettings_CbDownloadLogs.Checked := DownloadLogs;
  FormSettings_CbDownloadOwnLogs.Checked := DownloadOwnLogs;
  FormSettings_CbImportAllFindsFromWeb.Checked := ImportAllFindsFromWeb;
  FormSettings_CbAddRank.Checked := AddRank;
  FormSettings_CbDivideByPolygon.Checked := DivideByPolygon;
  FormSettings_CbAddElevation.Checked := AddElevation;
  FormSettings_LabelDatabaseName.Caption := Database + '.db3';
  {FormAdvancedSettings}
  FormAdvancedSettings.Caption := 'AutoStat ' + Verze + ' - Pokroil nastaven';
  FormAdvancedSettings_CbSilentMode.Checked := SilentMode;
  FormAdvancedSettings_CbCheckNewVersion.Checked := CheckNewVersion;
  FormAdvancedSettings_CbUseCurrentDatabase.Checked := UseCurrentDatabase;
  FormAdvancedSettings_CbUseCurrentDatabase.OnClick := @EnablingOptions;
  if UseCurrentDatabase then FormAdvancedSettings_EditDatabaseSelect.Text := GEOGET_DBNAME;
  GeoDBNames(FormAdvancedSettings_EditDatabaseSelect.Items);
  FormAdvancedSettings_EditHomeLat.Text := HomeLat;
  FormAdvancedSettings_EditHomeLat.OnExit := @IsValidCoord;
  FormAdvancedSettings_EditHomeLon.Text := HomeLon;
  FormAdvancedSettings_EditHomeLon.OnExit := @IsValidCoord;
  FormAdvancedSettings_ButtonCoordinates.OnClick := @SetHomeCoordinates;
  FormAdvancedSettings_EditStatistics.Text := Statistics;
  FormAdvancedSettings_EditTemplate.Text := Template;
  FormAdvancedSettings_EditTemplate.OnChange := @EnablingOptions;
  FormAdvancedSettings_ButtonTemplate.Hint := 'Vyberte soubor se ablonou.' + CRLF + 'Pouze v adresi:' + CRLF + GEOGET_DATADIR;
  FormAdvancedSettings_ButtonTemplate.OnClick := @OpenTemplateFile;
  FormAdvancedSettings_CbUseGgStatMacro.Checked := UseGgStatMacro;
  FormAdvancedSettings_CbGenerateCachemap.Checked := GenerateCachemap;
  FormAdvancedSettings_CbGenerateCachemap.OnClick := @EnablingOptions;
  FormAdvancedSettings_CbUseCachemapMacro.Checked := UseCachemapMacro;
  FormAdvancedSettings_CbDownloadLogs.Checked := DownloadLogs;
  FormAdvancedSettings_CbDownloadLogs.OnClick := @EnablingOptions;
  FormAdvancedSettings_CbDownloadOwnLogs.Checked := DownloadOwnLogs;
  FormAdvancedSettings_CbDownloadOwnLogs.OnClick := @EnablingOptions;
  FormAdvancedSettings_CbImportAllFindsFromWeb.Checked := ImportAllFindsFromWeb;
  FormAdvancedSettings_CbAddRank.Checked := AddRank;
  FormAdvancedSettings_CbAddRank.OnClick := @EnablingOptions;
  FormAdvancedSettings_CbDivideByPolygon.Checked := DivideByPolygon;
  FormAdvancedSettings_CbDivideByPolygon.OnClick := @EnablingOptions;
  FormAdvancedSettings_CbUsePolygonMacro.Enabled := FormAdvancedSettings_CbDivideByPolygon.Checked;
  FormAdvancedSettings_CbUsePolygonMacro.Checked := UsePolygonMacro;
  FormAdvancedSettings_CbAddElevation.Checked := AddElevation;
  FormAdvancedSettings_CbAddElevation.OnClick := @EnablingOptions;
  FormAdvancedSettings_CbUseElevationMacro.Enabled := FormAdvancedSettings_CbAddElevation.Checked;
  FormAdvancedSettings_CbUseElevationMacro.Checked := UseElevationMacro;
  FormAdvancedSettings_CbGenerateFtfIndex.Checked := GenerateFtfIndex;
  FormAdvancedSettings_CbGenerateFooter.Checked := GenerateFooter;
  FormAdvancedSettings_CbGenerateFooter.OnClick := @EnablingOptions;
  FormAdvancedSettings_ButtonOpenTemplate.Hint := 'Oteve soubor "' + Template + '" pro pravy';
  FormAdvancedSettings_ButtonOpenTemplate.Enabled := FormAdvancedSettings_EditTemplate.Text <> '';
  FormAdvancedSettings_ButtonOpenTemplate.OnClick := @OpenTemplate;
  FormAdvancedSettings_ButtonOpenReadme.OnClick := @OpenReadme;
  FormAdvancedSettings_ButtonRunGgstat.OnClick := @RunGgStat;
  FormAdvancedSettings_ButtonURLGgstat.OnClick := @GotoUrlGgStat;
  FormAdvancedSettings_EditFooterText.Text := FooterText;
  FormAdvancedSettings_EditFooterText.Enabled := FormAdvancedSettings_CbGenerateFooter.Checked;
  FormAdvancedSettings_EditGcCzLogin.Text := GcCzLogin;
  FormAdvancedSettings_EditGcCzLogin.Enabled := FormAdvancedSettings_CbGenerateCachemap.Checked;
  FormAdvancedSettings_EditGcCzPassword.Text := GcCzPassword;
  FormAdvancedSettings_EditGcCzPassword.Enabled := FormAdvancedSettings_CbGenerateCachemap.Checked;
  FormAdvancedSettings_EditGcCzUID.Text := GcCzUID;
  FormAdvancedSettings_EditGcCzUID.Enabled := FormAdvancedSettings_CbGenerateCachemap.Checked;
  FormAdvancedSettings_EditGcCzUID.OnChange := @EnablingOptions;
  FormAdvancedSettings_EditGcCzUID.OnExit := @IsValidUid;
  FormAdvancedSettings_ButtonGcCzUID.OnClick := @GotoUrlForumUid;
  FormAdvancedSettings_EditGcCzTypMapy.Text := GcCzTypMapy;
  FormAdvancedSettings_LabelGcCzTypMapy.Enabled := FormAdvancedSettings_CbGenerateCachemap.Checked and (FormAdvancedSettings_EditGcCzUID.Text <> '');
  FormAdvancedSettings_EditGcCzTypMapy.Enabled := FormAdvancedSettings_LabelGcCzTypMapy.Enabled;
  FormAdvancedSettings_EditGjUsername.Text := GjUsername;
  FormAdvancedSettings_EditGjUsername.Enabled := GeojarryForUpload or DownloadLogs or DownloadOwnLogs;
  FormAdvancedSettings_EditGjPassword.Text := GjPassword;
  FormAdvancedSettings_EditGjPassword.Enabled := GeojarryForUpload or DownloadLogs or DownloadOwnLogs;
  FormAdvancedSettings_RbProfile.Checked := GeojarryForUpload;
  FormAdvancedSettings_RbProfile.OnClick := @EnablingOptions;
  FormAdvancedSettings_RbFtp.Checked := not GeojarryForUpload;
  FormAdvancedSettings_RbFtp.OnClick := @EnablingOptions;
  FormAdvancedSettings_LabelFtpUrl.Enabled := not GeojarryForUpload;
  FormAdvancedSettings_EditFtpUrl.Enabled := FormAdvancedSettings_LabelFtpUrl.Enabled
  FormAdvancedSettings_EditFtpUrl.Text := FtpUrl;
  FormAdvancedSettings_EditFtpUrl.Enabled := not GeojarryForUpload;
  FormAdvancedSettings_LabelFtpUser.Enabled := not GeojarryForUpload;
  FormAdvancedSettings_EditFtpUser.Enabled := FormAdvancedSettings_LabelFtpUser.Enabled;
  FormAdvancedSettings_EditFtpUser.Text := FtpName;
  FormAdvancedSettings_LabelFtpPassword.Enabled := not GeojarryForUpload;
  FormAdvancedSettings_EditFtpPassword.Enabled := FormAdvancedSettings_LabelFtpPassword.Enabled;
  FormAdvancedSettings_EditFtpPassword.Text := FtpPassword;
  FormAdvancedSettings_EditFtpPassword.Enabled := not GeojarryForUpload;
  FormAdvancedSettings_LabelFtpDirectory.Enabled := not GeojarryForUpload;
  FormAdvancedSettings_LabelFtpDirectory.Hint := 'Adres na FTP serveru kam se soubor "' + Statistics + '" nahraje';
  FormAdvancedSettings_EditFtpDirectory.Enabled := FormAdvancedSettings_LabelFtpDirectory.Enabled;
  FormAdvancedSettings_EditFtpDirectory.Hint := FormAdvancedSettings_LabelFtpDirectory.Hint;
  FormAdvancedSettings_EditFtpDirectory.Text := FtpDirectory;
  FormAdvancedSettings_ButtonAbout.OnClick := @ShowAbout;
  {FormAbout}
  FormAbout.Caption := 'AutoStat ' + Verze + ' - O makru...';
  FormAbout_About.TabIndex := 0;
  FormAbout_LabelURLmikrom.OnClick := @GotoUrlMikromcz;
  FormAbout_LabelURLforum.OnClick := @GotoUrlForumAutoStat;
  FormAbout_ButtonCheckUpdate.OnClick := @CheckUpdates;
  FormAbout_ButtonOpenAutostatFolder.OnClick := @OpenAutostatFolder;
end;

{maly okynko s nastavenim}
function GetOptions: Integer;
begin
  {nacteme si nastaveni z ini}
  ReadSettings;
  {pripravime formular vyplnenim hodnot a tak..}
  SetActions;
  {Peklad}
  if (Language <> 'Czech') then Translate(Language);
  
  Result := -1;
  Result := FormSettings.ShowModal;
  if ((Result = 1) or (Result = 6)) then
  begin
    {zapiseme hodnoty do AutoStat.ini}
    Options := TIniFile.Create(AutoStatPath + '\AutoStat.ini');
    try
      with Options do
      begin
        WriteBool('AutoStat','SilentMode',FormSettings_CbSilentMode.Checked);
        WriteBool('AutoStat','GenerateCachemap',FormSettings_CbGenerateCachemap.Checked);
        WriteBool('AutoStat','DownloadLogs',FormSettings_CbDownloadLogs.Checked);
        WriteBool('AutoStat','DownloadOwnLogs',FormSettings_CbDownloadOwnLogs.Checked);
        WriteBool('AutoStat','ImportAllFindsFromWeb',FormSettings_CbImportAllFindsFromWeb.Checked);
        WriteBool('AutoStat','AddRank',FormSettings_CbAddRank.Checked);
        WriteBool('AutoStat','DivideByPolygon',FormSettings_CbDivideByPolygon.Checked);
        WriteBool('AutoStat','AddElevation',FormSettings_CbAddElevation.Checked);
      end;
    finally
      Options.Free;
    end;
  end;
  FormSettings.Close;
end;

{velky okno s pokrocilym nastavenim}
function GetMoreOptions: Integer;
begin
  {nacteme si nastaveni z ini}
  ReadSettings;
  {pripravime formular vyplnenim hodnot a tak..}
  SetActions;
  {Peklad}
  if (Language <> 'Czech') then Translate(Language);
  
  Result := -1;
  Result := FormAdvancedSettings.ShowModal;
  if Result = 1 then SaveSettings;
  FormAdvancedSettings.Close;
end;

{PLUGINSTOP - nahrani na FTP}
procedure UploadOnFtp;
begin
  GeoBusyCaption('Generovn statistik...');
  GeoBusyKind('Nahrvn na Ftp...');
  
  {zavolame pripravenej BAT soubor}
  Akce := AutoStatPath + '\AutoStat.FTP.bat';
  if not SilentMode then ShowErrorMessage('Upload statistik bakem...' + CRLF + CRLF + Akce);
  RunExec(Akce);
  if SilentMode then DeleteFile(Akce);
end;

procedure UploadOnProfile;
begin
  GeoBusyProgress(0,0);
  GeoBusyCaption('Generovn statistik...');
  GeoBusyKind('Nahrvn na profil...');
  
  {prikaz pro zavolani geojarryho}
  Akce := '"' + GeojarryExe + '" "' + GeojarryIni + '" profile "' + GEOGET_DATADIR + '\' + Statistics + '"';
  if not SilentMode then ShowErrorMessage('Upload statistik GeoJarrym...' + CRLF + CRLF + Akce);
  {upload na profil pres geojarry}
  GeojarryResult := RunExec(Akce);
  case GeojarryResult of
    0: begin
      RunShell('http://www.geocaching.com/profile/?u=' + EncodeURLelement(GjUsername));
      if SilentMode then DeleteFile(GeojarryIni);
    end;
    else ShowGeojarryError(GeojarryResult);
  end;
end;

{PLUGINSTART - inicialuzace, hledani configu a tak}
procedure AutoStatInit;
var
  tmp: String;
begin
  {osetreni pokud bude AutoStat ve slozce datadir\script\AutoStat\ misto jen v datadir}
  AutoStatPath := Copy(GEOGET_SCRIPTFULLNAME,0,Length(GEOGET_SCRIPTFULLNAME) - Length(GEOGET_SCRIPTNAME) - 1);

  {zjisteni, kde ze je geojarry.config.pas a geocaching-cz.config.pas a dystak nacteni jeich cest}
  if not FileExists(AutoStatPath + '\AutoStat.ini') then
  begin
    tmp := SearchFile(GEOGET_DATADIR,'geocaching-cz.config.pas');
    if ((tmp <> 'Soubor nenalezen!') and (FileExists(tmp))) then GeocachingCzConfig := tmp;
    tmp := SearchFile(GEOGET_DATADIR,'geojarry.config.pas');
    if ((tmp <> 'Soubor nenalezen!') and (FileExists(tmp))) then GeojarryConfig := tmp
    else
    begin
      tmp := SearchFile(GEOGET_DATADIR,'gj2.config.pas');
      if ((tmp <> 'Soubor nenalezen!') and (FileExists(tmp))) then GeojarryConfig := tmp;
    end;
  end;
end;

{PLUGINSTART - start AutoStatu, vynulovani promennych, kontrola nastaveni}
procedure AutoStatStart;
{var
  tmp: String;}
begin
  {nacteme nastaveni z ini}
  ReadSettings;

  {pustime busy dialog, at to neco dela a nevypada, ze to zatuhlo}
  GeoBusyStart;
  GeoBusyProgress(0,0);
  GeoBusyCaption('Inicializace...');
  GeoBusyKind('Kontroluji nastaven a soubory...');
  
  {zkontrolujeme zda je pritomen geojarry}
  if GeojarryForUpload or DownloadLogs or DownloadOwnLogs then
  begin
    if not FileExists(GEOGET_DATADIR + '\script\geojarry\geojarryw.exe')then
    begin
      if MessBox('Chyba: V datovm adresi GeoGetu chyb GeoJarry!' + CRLF + 'Export se nyn ukon.' + CRLF + 'Chcete se podvat na internetu po geojarym?','GeoGet - Chyba',1) = 1 then
        RunShell('http://www.google.cz/search?q=geojarry');
      GeoAbort;
    end
    else
      GeojarryExe := GEOGET_DATADIR + '\script\geojarry\geojarryw.exe';

    if (GjUsername = '') or (GjPassword = '') then
    begin
      ShowMessage('Chyba: Vypl prosm potebn daje v nastaven GeoJarry!'); // + CRLF +
    end;

    {pohledame kde je geojarry.exe nebo geojarryw.exe a ulozime do GeojarryExe}
    //tmp := SearchFile(GEOGET_DATADIR,'geojarryw.exe');
    //if ((tmp <> 'Soubor nenalezen!') and (FileExists(tmp))) then GeojarryExe := tmp
    //else
    //begin
      //tmp := SearchFile(GEOGET_DATADIR,'geojarry.exe');
      //if ((tmp <> 'Soubor nenalezen!') and (FileExists(tmp))) then GeojarryExe := tmp
      //else ShowErrorMessage('Chyba: "geojarry.exe" ani "geojarryw.exe" nenalezen!');
    //end;
  end;

  {kontrola, zda je pritomen GgStat pac si porad lidi pletou AutoStat, GgStat, GgStat2.. chjo}
  if not FileExists(GEOGET_DATADIR + '\script\GgStat\GgStat.exe') then
  begin
    if MessBox('Chyba: V datovm adresi GeoGetu chyb soubor GgStat.exe!' + CRLF + 'Export se nyn ukon.' + CRLF + 'Pejt na strnku programu GgStat?','GeoGet - Chyba',1) = 1 then
      RunShell('http://geoget.ararat.cz/doku.php/doc:user:ggstat');
    GeoAbort;
  end;

  {koukneme zda uzivatel vyplnil domaci souradnice}
  if (HomeLat = '') or (HomeLon = '') then
  begin
    ShowErrorMessage('Chyba: V nastaven vypl Tvoje domc souadnice' + CRLF +
                     'v desetinnm formtu! Nap: 50.568708 a 15.313619');
  end;

  {kontrola, zda je vyplneno UID na gecaching.cz}
  if GenerateCachemap then
  begin
    Finds := '';
    if GcCzUID = '' then
      if MessBox('Chyba: Nen vyplnno UID!' + CRLF + 'Podvat se na frum jak ho zjistit?','GeoGet - Chyba',1) = 1 then
        RunShell('http://www.geocaching.cz/forum/viewthread.php?forum_id=28&thread_id=8091');
  end;

  {vynulujeme promenny pro generovani FTF indexu}
  if GenerateFtfIndex then
  begin
    Found := 0;
    FTF   := 0;
  end;

  {trideni do kraju pomoci AutoStat}
  if DivideByPolygon and not UsePolygonMacro then
  begin
    CzKraje := TGeoPolyList.create;
    CzKraje.init(PolyKraj);
    CzOkresy := TGeoPolyList.create;
    CzOkresy.init(PolyOkres);
  end;

  {vynulujeme promenny pro prirazovani nadmorsky vysky}
  if AddElevation and not UseElevationMacro then
  begin
    ErrCnt  := 0;
    ErrFlag := false;
  end;

  {smazani slozky par-}
  DeleteParFolder;
  {smazani docasnejch souboru v geoget_datadir\gjtemp\*}
  DeleteFiles(GEOGET_DATADIR + '\gjtemp\*.*');
  Counter   := 0;
  GjCounter := 0;
  GjData    := '';
  Akce      := '';

  {obsluha busy dialogu}
  GeoBusyProgress(0,0);
  GeoBusyCaption('Shromaovn informac...');
  GeoBusyKind('Prosm ekejte.');

  if GeojarryForUpload or DownloadLogs or DownloadOwnLogs then
    {pokud budeme pouzivat geojarryho, tak mu vytvorime gjtemp.ini}
    MakeGeojarryIni
  else
    {pokud se bude nahravat na FTP tak vytvorime AutoStat.FTP.bat}
    MakeBatFile;

  {stazeni logu co sou na webu}
  if ImportAllFindsFromWeb and not DownloadOwnLogs then
  begin
    {stahneme geojarrym uzivatelem nalezene kese}
    GeojarryMy;
  end
  else
  if DownloadOwnLogs then
  begin
    GeoBusyKind('Hledm na webu nov logy...');

    {stahneme a naimportujeme seznam uzivatelem nalezenych kesi, to oznaci kese co jsou v geogetu jako nalezene}
    Akce := '"' + GeojarryExe + '" "' + GeojarryIni + '" raw "http://www.geocaching.com/my/logs.aspx?s=1"';
    GeojarryResult := RunExec(Akce);
    case GeojarryResult of
      0: begin
        if not SilentMode then GeoImportBegin;
        GeoImportDir(GEOGET_DATADIR + '\gjtemp\');
        if not SilentMode then
        begin
          GeoImportEnd;
          DeleteFiles(GEOGET_DATADIR + '\gjtemp\*.*');
        end;
      end;
      else ShowGeojarryError(GeojarryResult);
    end;
  end;

  GeoBusyProgress(0,GetFoundAndHidden);
end;

{PLUGINWORK - provede se pro jednotlivy kese}
procedure AutoStatWork;
begin
  {dokud uzivatel nezmackne tlacitko Storno tak delej...}
  if not GeoBusyTest then
  begin
    if GC.IsFound or GC.IsOwner then
    begin
      {obsluha busy dialogu}
      Inc(Counter);
      GeoBusyProgress(Counter,GetFoundAndHidden);
      GeoBusyCaption('Shromaovn informac...');
      GeoBusyKind(UtfToAscii(GC.Name));

      {generovn seznamu nalezu pro gc.cz pro mapku}
      if GenerateCachemap and not UseCachemapMacro then
        Finds := Finds + GC.ID + ';' + FormatDateTime('yyyy"-"mm"-"dd',GC.Found) + ';' + GC.Lat + ';' + GC.Lon + '|';

      {pocitani FTF pro FTF index}
      if GenerateFtfIndex then
      begin
        Inc(Found);
        if GC.TagHaveCategory('FTF') and (GC.TagValues('FTF') = 'FTF') then Inc(FTF);
      end;

      {rozdeleni do polygonu}
      if DivideByPolygon and not UsePolygonMacro then SetPolygonTag;

      {doplneni tagu s nadmorskou vyskou}
      if AddElevation and not UseElevationMacro then SetElevationTag;

      {stazeni logu. pro statistiky vlastnich kesi. stahne cely listing kese a pak ho importuje}
      if DownloadLogs and GC.IsOwner then
      begin
        {priprava davky pro geojarry, ktery pak stahne cele listingy vsech vlastnich kesi}
        GjData := GjData + GC.SimpleURL + '&log=y' + CRLF;
        Inc(GjCounter);
      end;

      {stazeni vlastnich logu na nalezenych kesich}
      if DownloadOwnLogs and not GC.IsOwner then
      begin
        if not (Geoget_DB.GetTableValue('SELECT count(*),id,type,finder FROM geolog WHERE id = ''' + GC.ID + ''' AND finder = ''' + GEOGET_OWNER + ''' AND (type = ''Found it'' OR type = ''Attended'' OR type = ''Webcam Photo Taken'')') >= 1) then
        begin
          {priprava davky pro geojarry, ktery pak stahne cele listingy vsech nalezenych kesi
          u kterych neni pritomen uzivateluv 'Found it'/'Attended'/'Webcam Photo Taken' log}
          GjData := GjData + GC.simpleURL + '&log=y' + CRLF;
          Inc(GjCounter);
          Exit; // pro zdvojene found it... logy ??
        end;
      end;

    end;
  end;
end;

{PLUGINSTOP - finalni vypocty, generovani statistik, nahrani na web}
procedure AutoStatStop;
var
  FtfIndex            :Single;
  GgStatIncludeCR     :String;
  Download            :String;
  GjDataFile          :String;
  tmp: String;
begin
  if not GeoBusyTest then
  begin
    {rozdeleni do polygonu}
    if DivideByPolygon then
    begin
      if UsePolygonMacro then
      begin
        if not SilentMode then ShowErrorMessage('Rozdlen do polygon makrem "czdivide.ggp.pas"');
        tmp := SearchFile(GEOGET_DATADIR,'czdivide.ggp.pas');
        if ((tmp <> 'Soubor nenalezen!') and (FileExists(tmp))) then GeoCallGGP(tmp)
        else ShowErrorMessage('Chyba: Makro "czdivide.ggp.pas" nenalezeno!');
      end
      else
      begin
        CzOkresy.Free;
        CzKraje.Free;
      end;
    end;

    {doplneni tagu s nadmorskou vyskou}
    if AddElevation and UseElevationMacro then
    begin
      if not SilentMode then ShowErrorMessage('Oznaen nadmosk vky makrem "elevation.ggp.pas"');
      tmp := SearchFile(GEOGET_DATADIR,'elevation.ggp.pas');
      if ((tmp <> 'Soubor nenalezen!') and (FileExists(tmp))) then GeoCallGGP(tmp)
      else ShowErrorMessage('Chyba: Makro "elevation.ggp.pas" nenalezeno!');
    end;

    {oznamkovani kesi podle geocaching.cz}
    if AddRank then
    begin
      if not SilentMode then ShowErrorMessage('Oznmkovn ke makrem "czgcgetrank.ggp.pas"');
      tmp:= SearchFile(GEOGET_DATADIR,'czgcgetrank.ggp.pas');
      if ((tmp <> 'Soubor nenalezen!') and (FileExists(tmp))) then GeoCallGGP(tmp)
      else ShowErrorMessage('Chyba: Makro "czgcgetrank.ggp.pas" nenalezeno!');
    end;

    {nahrani nalezu na server geocaching.cz}
    if GenerateCachemap then
    begin
      GeoBusyCaption('Generovn statistik...');
      GeoBusyKind('Nlezy na geocaching.cz...');

      {bud tak jak to delalo predtim, nebo zavolanim makra gcczmap.ggp.pas}
      if not UseCachemapMacro then
      begin
        if not SilentMode then ShowErrorMessage('Nahrvn nlez na geocaching.cz' + CRLF + 'makrem AutoStat.');
        {upload nalezu pro cachemapu na geocaching.cz}
        HttpAsk('POST','http://www.geocaching.cz/api.php','application/x-www-form-urlencoded','a=nalezy&u=' + GcCzLogin + '&p=' + GcCzPassword + '&d=' + Finds,Download);
        if not SilentMode then ShowErrorMessage('Upload statistik pro cachemapu:' + CRLF + CRLF + Download);
      end
      else
      begin
        {v pripade, ze pouzijeme makro z distribude GeoGetu}
        if not SilentMode then ShowErrorMessage('Nahrvn nlez makrem "gcczmap.ggp.pas"');
        tmp := SearchFile(GEOGET_DATADIR,'czgcmap.ggp.pas');
        if ((tmp <> 'Soubor nenalezen!') and (FileExists(tmp))) then GeoCallGGP(tmp)
        else ShowErrorMessage('Chyba: Makro "czgcmap.ggp.pas" nenalezeno!');
      end;

      {mapa do profilu, spubor pro INCLUDE}
      GgStatIncludeCR := '<img src="http://www.geocaching.cz/mapacr.php?uid=' + GcCzUID + '&typ=' + GcCzTypMapy + '" alt="mapa" />' + CRLF + '<br />' + CRLF + '<br />';
      if not SilentMode then ShowErrorMessage('Mapa nlez:' + CRLF + CRLF + GgStatIncludeCR);
      StringToFile(GgStatIncludeCR,GEOGET_DATADIR + '\GgStatIncludeCR.html');
    end;

    {vypocet FTFindexu a vygenerovani souboru pro INCLUDE}
    if GenerateFtfIndex then
    begin
      if (Found >= 200) then
      begin
        GeoBusyCaption('Generovn statistik...');
        GeoBusyKind('FTF index...');

        FtfIndex := FTF / Found * 100;
        GgStatIncludeFTF := '<span style="font-size:9px; margin:0; padding:0;">FTF celkem: ' + IntToStr(FTF) +
                            ', <a href=http://www.ftf-index.cz>FTF index</a>: ' + FormatFloat('#.0',FtfIndex) + '%</span>' + CRLF + '<br />' + CRLF + '<br />';
        if not SilentMode then ShowErrorMessage('FTF index:' + CRLF + CRLF + GgStatIncludeFTF);
        StringToFile(GgStatIncludeFTF,GEOGET_DATADIR + '\GgStatIncludeFTFi.html');
      end;
    end;

    {paticka, soubor pro INCLUDE}
    if GenerateFooter then
    begin
      GeoBusyCaption('Generovn statistik...');
      GeoBusyKind('Patika...');

      if not SilentMode then ShowErrorMessage('Patika:' + CRLF + CRLF + FooterText);
      StringToFile(FooterText,GEOGET_DATADIR + '\GgStatIncludeFooter.html');
    end;

    {stazeni a import logu na vlastnich a nalezench kesich}
    if DownloadLogs or DownloadOwnLogs then
    begin
      GeoBusyProgress(GjCounter,GjCounter);
      GeoBusyCaption('Generovn statistik...');
      GeoBusyKind('Stahovn log na vlastnch a nalezench kech...');

      GjDataFile := GEOGET_DATADIR + '\gjdata.txt';
      StringTofile(GjData,GjDataFile);

      {prikaz pro zavolani geojarryho}
      Akce := '"' + GeojarryExe + '" "' + GeojarryIni + '" rawbatch "' + GjDataFile + '"';
      if not SilentMode then ShowErrorMessage('Stahovn log na vlastnch a nalezench kech...' + CRLF + CRLF + Akce);

      GeojarryResult := RunExec(Akce);
      case GeojarryResult of
        0: begin
          if not SilentMode then
          begin
            ShowErrorMessage('Importovn log z vlastnch a nalezench kech...' + CRLF + CRLF + GjData);
            GeoImportBegin;
          end;
          GeoImportDir(GEOGET_DATADIR + '\gjtemp\');
          if not SilentMode then
            GeoImportEnd
          else
          begin
            DeleteFiles(GEOGET_DATADIR + '\gjtemp\*.*');
            DeleteFile(GjDataFile); // gjdata.txt
          end;
        end;
        else ShowGeojarryError(GeojarryResult);
      end;
    end;

    {generovani statistik}
    if UseGgStatMacro then
    begin
      GeoBusyKind('Generovn pes "GgStat.ggp.pas"...');

      {generovani zavolanim originalniho makra GgStat.ggp.pas}
      if not SilentMode then ShowErrorMessage('Generovn statistik makrem "GgStat.ggp.pas"');
      {koukneme se kde je GgStat.ggp.pas, pokud ho najdeme, tak ho pustime}
      
      tmp := SearchFile(GEOGET_DATADIR,'GgStat.ggp.pas');
      if ((tmp <> 'Soubor nenalezen!') and (FileExists(tmp))) then GeoCallGGP(tmp)
      else ShowErrorMessage('Chyba: Makro "GgStat.ggp.pas" nenalezeno!');
    end
    else
      MakeStats;
      
    if GenerateFtfIndex then DeleteFile(GEOGET_DATADIR + '\GgStatIncludeFTFi.html');
    if GenerateCachemap then DeleteFile(GEOGET_DATADIR + '\GgStatIncludeCR.html');
    if GenerateFooter   then DeleteFile(GEOGET_DATADIR + '\GgStatIncludeFooter.html');

    {nahrani statistik na web}
    if GeojarryForUpload then
      UploadOnProfile
    else
      UploadOnFtp;

    {smazeme stary a nepotrebny soubory - DOCASNY}
    DeleteUselessFiles;

    GeoBusyKind('Hotovo!');
  end
  else
    ShowMessage('Stornovno uivatelem.');
end;
