uses
  AutoStatFormLogin;

{$INCLUDE groundspeak.config.pas}
{$INCLUDE geocaching-cz.config.pas}

{pokud soubor existuje, tak ho smaze}
procedure DeleteThisFile(co: String);
begin
  if FileExists(co) then DeleteFile(co);
end;

{pokud soubor existuje, tak ho zkopiruje jinam a smaze}
procedure MoveThisFile(co,kam: String);
begin
  if FileExists(co) then if CopyFile(co,kam) then DeleteFile(co);
end;

{vycte hodnotu promenne z configu}
function GetValue(co,kde: String): String;
begin
  Result := RegexExtract('\s+'+co+'\s\=\s\''([\.^\'']*)\''.*',kde);
end;

{funkce pro vycteni HOME souradnic}
function GetHomeCoordinates(coord: String): String;
var
  lat, lon: Extended;
  refPoints: TStringList;
begin
  {a pokud ne, tak vezmeme hned ten prvni}
  refPoints := TStringList.Create;
  try
    RefPointNames(refPoints);
    if RefPointGet(refPoints[0],lat,lon) then
    begin
      case coord of
        'lat': Result := FlToStr(lat);
        'lon': Result := FlToStr(lon);
      end;
    end;
  finally
    refPoints.Free;
  end;
end;

function InstallWork: String;
var
  config,templatePath,s: String;
  ini :TIniFile;
begin
  Result := '';

  {vytvorime pokud neni}
  if not DirectoryExists(GEOGET_SCRIPTDIR+'\AutoStat\templates\') then ForceDirectories(GEOGET_SCRIPTDIR+'\AutoStat\templates\');
  if not DirectoryExists(GEOGET_SCRIPTDIR+'\AutoStat\last\') then ForceDirectories(GEOGET_SCRIPTDIR+'\AutoStat\last\');

  {pokud neexistuje soubor AutoStat.ini}
  if not FileExists(GEOGET_SCRIPTDIR+'\AutoStat\AutoStat.ini') then
  begin
    {tak si vezmeme nastaveni z GgStat2.config.pas a ulozime si ho do AutoStat.ini}
    if FileExists(GEOGET_DATADIR+'\GgStat2.config.pas') or FileExists(GEOGET_SCRIPTDIR+'\GgStat2.config.pas') then
    begin
      if FileExists(GEOGET_DATADIR+'\GgStat2.config.pas') then config := GEOGET_DATADIR+'\GgStat2.config.pas'
      else if FileExists(GEOGET_SCRIPTDIR+'\GgStat2.config.pas') then config := GEOGET_SCRIPTDIR+'\GgStat2.config.pas';
        
      ini := TIniFile.Create(GEOGET_SCRIPTDIR+'\AutoStat\AutoStat.ini');
      try
        with ini do
        begin
          WriteString('AutoStat','Statistics',GetValue('Statistics',config));
          WriteString('AutoStat','Template',GetValue('Template',config));
          WriteString('AutoStat','HomeLat',GetValue('HomeLat',config));
          WriteString('AutoStat','HomeLon',GetValue('HomeLon',config));
          WriteBool('AutoStat','GenerateCachemap',GetValue('GenerateCachemap',config) = 'yes');
          WriteString('AutoStat','GcCzUID',GetValue('GcCzUID',config));
          WriteString('AutoStat','GcCzTypMapy',GetValue('GcCzTypMapy',config));
          WriteBool('AutoStat','GenerateFTFindex',GetValue('GenerateFTFindex',config) = 'yes');
          WriteBool('AutoStat','GeojarryForUpload',GetValue('GeojarryForUpload',config) = 'yes');
          WriteString('AutoStat','FtpUrl',GetValue('FtpUrl',config));
          WriteString('AutoStat','FtpName',GetValue('FtpName',config));
          WriteString('AutoStat','FtpPassword',GetValue('FtpPassword',config));
          WriteString('AutoStat','FtpDirectory',GetValue('FtpDirectory',config));
          WriteBool('AutoStat','DownloadLogs',GetValue('DownloadLogs',config) = 'yes');
          WriteBool('AutoStat','DivideByPolygon',GetValue('DivideByPolygon',config) = 'yes');
          WriteBool('AutoStat','AddElevation',GetValue('AddElevation',config) = 'yes');
          WriteBool('AutoStat','DebugMode',GetValue('SilentMode',config) = 'yes');
        end;
      finally
        ini.Free;
        DeleteThisFile(GEOGET_DATADIR+'\GgStat2.ggp.pas');
        DeleteThisFile(GEOGET_DATADIR+'\GgStat2.config.pas');
        DeleteThisFile(GEOGET_DATADIR+'\GgStat2.default.pas');
        DeleteThisFile(GEOGET_DATADIR+'\GgStats.html');
        DeleteThisFile(GEOGET_DATADIR+'\Cti mne.txt');
        DeleteThisFile(GEOGET_DATADIR+'\GgStatManual.html');
        DeleteThisFile(GEOGET_SCRIPTDIR+'\GgStat2.ggp.pas');
        DeleteThisFile(GEOGET_SCRIPTDIR+'\GgStat2.config.pas');
        DeleteThisFile(GEOGET_SCRIPTDIR+'\GgStat2.default.pas');
        DeleteThisFile(GEOGET_SCRIPTDIR+'\GgStats.html');
        DeleteThisFile(GEOGET_SCRIPTDIR+'\Cti mne.txt');
        DeleteThisFile(GEOGET_SCRIPTDIR+'\GgStatManual.html');
      end;
    end
    {nebo si vezmeme nastaveni z AutoStat.config.pas a ulozime si ho do AutoStat.ini}
    else if FileExists(GEOGET_DATADIR+'\AutoStat.config.pas') or FileExists(GEOGET_SCRIPTDIR+'\AutoStat.config.pas') or FileExists(GEOGET_SCRIPTDIR+'\AutoStat\AutoStat.config.pas') then
    begin
      if FileExists(GEOGET_DATADIR+'\AutoStat.config.pas') then config := GEOGET_DATADIR+'\AutoStat.config.pas'
      else if FileExists(GEOGET_SCRIPTDIR+'\AutoStat.config.pas') then config := GEOGET_SCRIPTDIR+'\AutoStat.config.pas'
      else if FileExists(GEOGET_SCRIPTDIR+'\AutoStat\AutoStat.config.pas') then config := GEOGET_SCRIPTDIR+'\AutoStat\AutoStat.config.pas';

      ini := TIniFile.Create(GEOGET_SCRIPTDIR+'\AutoStat\AutoStat.ini');
      try
        with ini do
        begin
          WriteString('AutoStat','Statistics',GetValue('Statistics',config));
          WriteString('AutoStat','Template',GetValue('Template',config));
          WriteString('AutoStat','HomeLat',GetValue('HomeLat',config));
          WriteString('AutoStat','HomeLon',GetValue('HomeLon',config));
          WriteBool('AutoStat','DebugMode',GetValue('SilentMode',config) = 'yes');
          WriteBool('AutoStat','CheckNewVersion',GetValue('CheckNewVersion',config) = 'yes');
          WriteBool('AutoStat','UseGgStatMacro',GetValue('UseGgStatMacro',config) = 'yes');
          WriteBool('AutoStat','GenerateCachemap',GetValue('GenerateCachemap',config) = 'yes');
          WriteBool('AutoStat','UseCachemapMacro',GetValue('UseCachemapMacro',config) = 'yes');
          WriteString('AutoStat','GcCzUID',GetValue('GcCzUID',config));
          WriteString('AutoStat','GcCzTypMapy',GetValue('GcCzTypMapy',config));
          WriteBool('AutoStat','DownloadLogs',GetValue('DownloadLogs',config) = 'yes');
          WriteBool('AutoStat','DownloadOwnLogs',GetValue('DownloadOwnLogs',config) = 'yes');
          WriteBool('AutoStat','ImportAllFindsFromWeb',GetValue('ImportAllFindsFromWeb',config) = 'yes');
          WriteBool('AutoStat','AddRank',GetValue('AddRank',config) = 'yes');
          WriteBool('AutoStat','DivideByPolygon',GetValue('DivideByPolygon',config) = 'yes');
          WriteBool('AutoStat','AddElevation',GetValue('AddElevation',config) = 'yes');
          WriteBool('AutoStat','UseElevationMacro',GetValue('UseElevationMacro',config) = 'yes');
          WriteBool('AutoStat','GeojarryForUpload',GetValue('GeojarryForUpload',config) = 'yes');
          WriteString('AutoStat','FtpUrl',GetValue('FtpUrl',config));
          WriteString('AutoStat','FtpName',GetValue('FtpName',config));
          WriteString('AutoStat','FtpPassword',GetValue('FtpPassword',config));
          WriteString('AutoStat','FtpDirectory',GetValue('FtpDirectory',config));
          WriteBool('AutoStat','GenerateFTFindex',GetValue('GenerateFTFindex',config) = 'yes');
          WriteBool('AutoStat','GenerateFooter',GetValue('GenerateFooter',config) = 'yes');
        end;
      finally
        ini.Free;
        DeleteThisFile(GEOGET_DATADIR+'\AutoStat.ggp.pas');
        DeleteThisFile(GEOGET_DATADIR+'\AutoStat.config.pas');
        DeleteThisFile(GEOGET_DATADIR+'\AutoStat.default.pas');
        DeleteThisFile(GEOGET_DATADIR+'\AutoStat.options.txt');
        DeleteThisFile(GEOGET_DATADIR+'\AutoStat-GgStat.ggp.pas');
        DeleteThisFile(GEOGET_DATADIR+'\popis z fora.txt');
        DeleteThisFile(GEOGET_DATADIR+'\Cti mne.txt');
        DeleteThisFile(GEOGET_DATADIR+'\GgStatManual.html');
        DeleteThisFile(GEOGET_SCRIPTDIR+'\AutoStat.ggp.pas');
        DeleteThisFile(GEOGET_SCRIPTDIR+'\AutoStat.config.pas');
        DeleteThisFile(GEOGET_SCRIPTDIR+'\AutoStat.default.pas');
        DeleteThisFile(GEOGET_SCRIPTDIR+'\AutoStat.options.txt');
        DeleteThisFile(GEOGET_SCRIPTDIR+'\AutoStat-GgStat.ggp.pas');
        DeleteThisFile(GEOGET_SCRIPTDIR+'\popis z fora.txt');
        DeleteThisFile(GEOGET_SCRIPTDIR+'\Cti mne.txt');
        DeleteThisFile(GEOGET_SCRIPTDIR+'\GgStatManual.html');
        DeleteThisFile(GEOGET_SCRIPTDIR+'\AutoStat\AutoStat.config.pas');
        DeleteThisFile(GEOGET_SCRIPTDIR+'\AutoStat\AutoStat.default.pas');
        DeleteThisFile(GEOGET_SCRIPTDIR+'\AutoStat\AutoStat.options.txt');
        DeleteThisFile(GEOGET_SCRIPTDIR+'\AutoStat\AutoStat-GgStat.ggp.pas');
        DeleteThisFile(GEOGET_SCRIPTDIR+'\AutoStat\popis z fora.txt');
        DeleteThisFile(GEOGET_SCRIPTDIR+'\AutoStat\Cti mne.txt');
        DeleteThisFile(GEOGET_SCRIPTDIR+'\AutoStat\GgStatManual.html');
        DeleteThisFile(GEOGET_SCRIPTDIR+'\AutoStat\English.lng');
      end;
    end
    else
    {a pokud ani to ne, tak neco vykouzlime ze zbytku}
    begin
      ini := TIniFile.Create(GEOGET_SCRIPTDIR+'\AutoStat\AutoStat.ini');
      try
        ini.WriteString('AutoStat','homeLat',GetHomeCoordinates('lat'));
        ini.WriteString('AutoStat','homeLon',GetHomeCoordinates('lon'));
        ini.WriteString('AutoStat','database',GEOGET_DBNAME);
        //ini.WriteBool('AutoStat','deleteParFolder',true);
      finally
        ini.Free;
      end;
    end;
  end
  else
  {a pokud AutoStat.ini existuje}
  begin
    {pokud se jmeno a heslo shoduje s udaji v configach, tak je vymazeme z ini}
    ini := TIniFile.Create(GEOGET_SCRIPTDIR+'\Autostat\AutoStat.ini');
    try
      if ini.ReadBool('AutoStat','firstRun',true) then
      begin
        {loginy}
        if gsUsername <> ini.ReadString('AutoStat','GjUsername','') then ini.WriteString('AutoStat','GjUsername',gsUsername)
        else ini.DeleteKey('AutoStat','GjUsername');
        if gsPassword <> ini.ReadString('AutoStat','GjPassword','') then ini.WriteString('AutoStat','GjPassword',gsPassword)
        else ini.DeleteKey('AutoStat','GjPassword');
        if gcUsername <> ini.ReadString('AutoStat','GcCzLogin','') then ini.WriteString('AutoStat','GcCzLogin',gcUsername)
        else ini.DeleteKey('AutoStat','GcCzLogin');
        if gcPassword <> ini.ReadString('AutoStat','GcCzPassword','') then ini.WriteString('AutoStat','GcCzPassword',gcPassword)
        else ini.DeleteKey('AutoStat','GcCzPassword');

        {silenmode -> debugmode}
        if ini.ReadBool('AutoStat','SilentMode',true) then
        begin
          ini.WriteBool('AutoStat','DebugMode',false);
          ini.DeleteKey('AutoStat','SilentMode');
        end;

        {nejaky dalsi stary veci}
        ini.DeleteKey('AutoStat','importAllFindsFromWeb');
        ini.DeleteKey('AutoStat','checkNewVersion');
        ini.DeleteKey('AutoStat','useGgStatMacro');

        {smazani zbytecnosti}
        DeleteThisFile(GEOGET_DATADIR+'\gjsession.'+gsUsername+'.txt');
        DeleteThisFile(GEOGET_DATADIR+'\GgStatIncludeFTFi.html');
        DeleteThisFile(GEOGET_DATADIR+'\GgStatIncludeCR.html');
        DeleteThisFile(GEOGET_DATADIR+'\GgStatIncludeFooter.html');
        DelTree(GEOGET_SCRIPTDIR+'\AutoStat\doc');
				DeleteThisFile(GEOGET_SCRIPTDIR+'\AutoStat\AutoStatLibGcCz.pas');

        {template !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!}
        //templatePath := ini.ReadString('AutoStat','Template','');

        MoveThisFile(GEOGET_DATADIR+'\GgStatIncludeAboutMe.html',GEOGET_SCRIPTDIR+'\AutoStat\templates\GgStatIncludeAboutMe.html');
        MoveThisFile(GEOGET_DATADIR+'\GgStatIncludeFriends.html',GEOGET_SCRIPTDIR+'\AutoStat\templates\GgStatIncludeFriends.html');
        MoveThisFile(GEOGET_DATADIR+'\GgStatTemplate.cz',GEOGET_SCRIPTDIR+'\AutoStat\templates\GgStatTemplate.cz');

        if FileExists(GEOGET_SCRIPTDIR+'\AutoStat\templates\GgStatTemplate.cz') then
        begin
          ini.WriteString('AutoStat','Template','script\AutoStat\templates\GgStatTemplate.cz');
          {zaloha puvodniho template}
          CopyFile(GEOGET_SCRIPTDIR+'\AutoStat\templates\GgStatTemplate.cz',GEOGET_SCRIPTDIR+'\AutoStat\templates\GgStatTemplate.cz.old');
          {uprava cest k includovanym HTML souborum}
          s := FileToString(GEOGET_SCRIPTDIR+'\AutoStat\templates\GgStatTemplate.cz');
          s := ReplaceString(s,'INCLUDE GgStatIncludeFriends.html','INCLUDE .\script\AutoStat\templates\GgStatIncludeFriends.html');
          s := ReplaceString(s,'INCLUDE GgStatIncludeAboutMe.html','INCLUDE .\script\AutoStat\templates\GgStatIncludeAboutMe.html');
          s := ReplaceString(s,'INCLUDE GgStatIncludeFTFi.html','INCLUDE .\script\AutoStat\last\GgStatIncludeFTFi.html');
          s := ReplaceString(s,'INCLUDE GgStatIncludeCR.html','INCLUDE .\script\AutoStat\last\GgStatIncludeCR.html');
          s := ReplaceString(s,'INCLUDE GgStatIncludeFooter.html','INCLUDE .\script\AutoStat\last\GgStatIncludeFooter.html');
          StringToFile(s,GEOGET_SCRIPTDIR+'\AutoStat\templates\GgStatTemplate.cz');
        end
        else
          CopyFile(GEOGET_SCRIPTDIR+'\AutoStat\templates_bundled\GgStatTemplate.cz',GEOGET_SCRIPTDIR+'\AutoStat\templates\GgStatTemplate.cz');

       {ukazeme changelog}
        if FileExists(GEOGET_SCRIPTDIR+'\AutoStat\AutoStat.readme.txt')then
          ShowLongMessage(_('Read me'),FileToString(GEOGET_SCRIPTDIR+'\AutoStat\AutoStat.readme.txt'));
      end;
    finally
      ini.Free;
    end;
  end;
end;
