{
  AutoStat, knihovna funkci a procedur
  Zde se nachz funkce a procedury nezbytn pro chod makra AutoStat
  
  GeoGet, http://geoget.ararat.cz
  HaLuMa, MaFa, LudekV, mikrom
  Icons based on Fudge Icons <http://p.yusukekamiyamane.com>

  
  Skript je mozno dale sirit a libovolne upravovat. Jedinou podminkkou je
  uvedeni odkazu na puvodni skript.
  
  ToDo/Bugs:
  - znamky makrem stahovat jen pro vlastni, prip. nalezeny kese
}

{minimalni verze GeoGetu}
{$V 2.5.8}

uses
  AutoStatFormSettings, AutoStatFormAdvancedSettings, AutoStatFormAbout, AutoStatFormLogin;

{$INCLUDE AutoStatLibCommon.pas}
{$INCLUDE AutoStatLibGgStat.pas}
{$INCLUDE AutoStatLibForms.pas}
{$INCLUDE AutoStatLibDB.pas}

var
  gjResult,max,Counter: integer;

{PLUGINSTART - start AutoStatu, vynulovani promennych, kontrola nastaveni}
procedure AutoStatStart;
begin
  ReadSettings;

  {pustime busy dialog, at to neco dela a nevypada, ze to zatuhlo}
  GeoBusyProgress(0,0);
  GeoBusyCaption(_('Initializing'));
  GeoBusyKind(_('Checking settings and files...'));
  
  {pokud je vybrana jina databaze nez "geoget"}
  if not useCurrentDatabase then GeoDBSelect(database);
  
  {zkontrolujeme zda je pritomen geojarry}
  if geojarryForUpload or downloadLogs or downloadOwnLogs then
  begin
    if not FileExists(GEOGET_SCRIPTDIR+'\geojarry\geojarryw.exe')then
    begin
	    ShowErrorMessage(_('Error: "geojarryw.exe" is missing!'));
      GeoAbort;
    end;

    if (gsUsername = '') or (gsPassword = '') then ShowMessage(_('Error: Fill your name and password to geocaching.com in "groundspeak.config.pas"!'));
  end;

  {kontrola, zda je pritomen GgStat pac si porad lidi pletou AutoStat, GgStat, GgStat2.. chjo}
  if not FileExists(GEOGET_SCRIPTDIR+'\GgStat\GgStat.exe') then
  begin
    if MessBox(ReplaceVariable(_('Error: GgStat is missing!%CRLF%Action will be cancelled.%CRLF%Launch GgStat webpage?')),_('GeoGet error!'),1) = 1 then
      BrowseURL('http://geoget.ararat.cz/doku.php/user:skript:ggstat');
    GeoAbort;
  end;

  {vytvorime pokud neni}
  if not DirectoryExists(GEOGET_SCRIPTDIR+'\AutoStat\last\') then ForceDirectories(GEOGET_SCRIPTDIR+'\AutoStat\last\');

  {smazani docasnejch souboru v geoget_datadir\gjtemp\*}
  DeleteFiles(GEOGET_SCRIPTDIR+'\Autostat\last\gjtemp\*.*');

  {pokud budeme pouzivat geojarryho, tak mu vytvorime gjini.txt}
  if geojarryForUpload or downloadLogs or downloadOwnLogs then MakeGjIni;

  {stazeni logu co sou na webu}
  if downloadLogs then //downloadOwnLogs
  begin
    GeoBusyKind(_('Looking for new logs...'));

    {stahneme a naimportujeme seznam uzivatelem nalezenych kesi, to oznaci kese co jsou v geogetu jako nalezene}
    akce := '"'+GEOGET_SCRIPTDIR+'\geojarry\geojarryw.exe" "'+GEOGET_SCRIPTDIR+'\AutoStat\last\gjini.txt" raw "http://www.geocaching.com/my/logs.aspx?s=1"';
    gjResult := RunExec(akce);
    case gjResult of
      0: begin
        if debugMode then GeoImportBegin;
        GeoImportDir(GEOGET_SCRIPTDIR+'\Autostat\last\gjtemp\');
        if debugMode then
        begin
          GeoImportEnd;
          DeleteFiles(GEOGET_SCRIPTDIR+'\Autostat\last\gjtemp\*.*');
        end;
      end;
      else ShowGeojarryError(gjResult);
    end;
  end;

  GeoBusyCaption(_('Collecting informations'));
  max := GetFoundAndHidden;
  GeoBusyProgress(0,max);
end;

{PLUGINWORK - provede se pro jednotlivy kese}
procedure AutoStatWork;
begin
  if not GeoBusyTest then
  begin
    if (GC.IsFound or GC.IsOwner) and IsValidGC(GC.ID) then
    begin
      {obsluha busy dialogu}
      Inc(Counter);
      GeoBusyProgress(counter,max);
      GeoBusyKind(UtfToAscii(GC.Name));
    end;
  end;
end;

{PLUGINSTOP - finalni vypocty, generovani statistik, nahrani na web}
procedure AutoStatStop;
var
  ftfi, found, ftf: single;
  includeFTFi: string;
  gjData: string;
  idlist: TStringList;
  n: integer;
begin
  if not GeoBusyTest then
  begin
    GeoBusyCaption(_('Finishing'));
    GeoBusyProgress(0,12);

    {nahrani nalezu na server geocaching.cz}
    if generateCachemap then
    begin
      GeoBusyKind(_('Uploading finds on the server...'));
      GeoBusyProgress(1,12);
      CallScript(_('Upload finds on geocaching.cz by'),'czgcmap.ggp.pas','\gc.cz\czgcmap.ggp.pas');

      {pokud neni, tak vytvorime ggStatIncludeCR.html, neni treba ho delat pokazdy}
      if not FileExists(GEOGET_SCRIPTDIR+'\Autostat\last\ggStatIncludeCR.html') then MakeGgstatIncludeCR(nil);
    end;
    
    {rozdeleni do polygonu}
    if divideByPolygon then
    begin
      GeoBusyKind('Adding polygon tags...');
      GeoBusyProgress(2,12);
      CallScript(_('Add polygon Tags by'),'divide.ggp.pas','\Divide\divide.ggp.pas');
    end;

    {doplneni tagu s nadmorskou vyskou}
    if addElevation then
    begin
      GeoBusyKind('Adding elevation tag...');
      GeoBusyProgress(3,12);
      CallScript(_('Add elevation Tag by'),'elevation.ggp.pas','\elevation\elevation.ggp.pas');
    end;

    {oznamkovani kesi podle geocaching.cz}
    if addRank then
    begin
      GeoBusyKind('Adding rank tags...');
      GeoBusyProgress(4,12);
      CallScript(_('Add rank Tag by'),'czgcgetrank.ggp.pas','\gc.cz\czgcgetrank.ggp.pas');
    end;

    {vypocet ftfIndexu a vygenerovani souboru pro INCLUDE}
    if generateFtfIndex then
    begin
      GeoBusyKind('Generating FTF index...');
      GeoBusyProgress(5,12);
      found := GetFoundCount;
      if found >= 200 then
      begin
        ftf := GetFtfCount;
        ftfi := (ftf / found) * 100;
        includeFTFi := '<span style="font-size:9px; margin:0; padding:0;">FTF celkem: '+FormatFloat('#',ftf)+', <a href=http://www.ftf-index.cz>FTF index</a>: '+FormatFloat('#.0',ftfi)+'%</span>' + CRLF + '<br />' + CRLF + '<br />';
        if debugMode then ShowErrorMessage(_('FTF index')+':' + CRLF + CRLF + includeFTFi);
        StringToFile(includeFTFi,GEOGET_SCRIPTDIR+'\Autostat\last\ggStatIncludeFTFi.html');
      end;
    end;

    {paticka, soubor pro INCLUDE}
    if generateFooter then
    begin
      GeoBusyKind(_('Generating footer...'));
      GeoBusyProgress(6,12);
      if debugMode then ShowErrorMessage(_('Footer code:') + CRLF + CRLF + footerText);
      StringToFile(footerText,GEOGET_SCRIPTDIR+'\Autostat\last\GgStatIncludeFooter.html');
    end;

    {stazeni a import logu na vlastnich a nalezench kesich}
    if downloadLogs or downloadOwnLogs then
    begin
      GeoBusyKind(_('Downloading logs from found and owned caches...'));

      {seznam vlastnich kesi}
      if downloadOwnLogs then
      begin
        GeoBusyProgress(7,12);
        if FileExists(GEOGET_SCRIPTDIR+'\GeoJarry\gj2.exec.Kee-Zaloen(vechny,VechnyLogy).query.plugin.ggp.pas') then
          CallScript(_('Downloading ALL logs on owned caches.'),'gj2.exec.Kee-Zaloen(vechny,VechnyLogy).query.plugin.ggp.pas','\GeoJarry\gj2.exec.Kee-Zaloen(vechny,VechnyLogy).query.plugin.ggp.pas')
        else
          CallScript(_('Downloading ALL logs on owned caches.'),'gj2.exec.GeocachesIOwn(all,AllLogs).query.plugin.ggp.pas','\GeoJarry\gj2.exec.GeocachesIOwn(all,AllLogs).query.plugin.ggp.pas');
      end;
      
      {seznam nalezenych kesi bez found logu}
      if downloadLogs then
      begin
        GeoBusyProgress(8,12);
        idlist := TStringList.Create;
        try
          idlist := GetFoundCachesWithoutLogList;
          if idlist.Count > 200 then ShowErrorMessage(_('Warning: You want to download more than 200 (Exactly: ')+IntToStr(idlist.Count)+_(') listings, are You sure? If You will download a lot amout of data You can be banned by Groundspeak Inc.'));
          for n := 0 to idlist.Count-1 do
            gjData := gjData + 'http://www.geocaching.com/seek/cache_details.aspx?wp=' + idlist[n] + '&log=y' + CRLF;
        finally
          idlist.Free;
        end;
      end;
      
      StringToFile(gjData,GEOGET_SCRIPTDIR+'\Autostat\last\gjdata.txt');

      {prikaz pro zavolani geojarryho}
      if gjData <> '' then
      begin
        GeoBusyProgress(9,12);
        akce := '"'+GEOGET_SCRIPTDIR+'\geojarry\geojarryw.exe" "'+GEOGET_SCRIPTDIR+'\AutoStat\last\gjini.txt" rawbatch "'+GEOGET_SCRIPTDIR+'\Autostat\last\gjdata.txt"';
        if debugMode then ShowErrorMessage(_('Download logs from found and owned caches:') + CRLF + CRLF + akce);
        if debugMode then ShowErrorMessage(_('File gjdata.txt:') + CRLF + CRLF + gjData);
        
        gjResult := RunExec(akce);
        case gjResult of
          0: begin
            if debugMode then
            begin
              ShowErrorMessage(_('Import logs from found and owned caches:') + CRLF + CRLF + gjData);
              GeoImportBegin;
            end;
            GeoImportDir(GEOGET_SCRIPTDIR+'\Autostat\last\gjtemp\');
            if debugMode then GeoImportEnd
            else DeleteFiles(GEOGET_SCRIPTDIR+'\Autostat\last\gjtemp\*.*');
          end;
          else ShowGeojarryError(gjResult);
        end;
      end;
    end;
    
    {generovani statistik}
    GeoBusyProgress(10,12);
    RunGgStat;

    {nahrani statistik na web}
    GeoBusyProgress(11,12);
    if geojarryForUpload then
      UploadOnProfile(nil)
    else
      UploadOnFtp(nil);

    GeoBusyKind(_('Done!'));
    GeoBusyProgress(12,12);
  end
  else
    ShowMessage(_('Canceled by user.'));
end;
