{vyhodi okno s popisem chyby GgStatu}
procedure ShowGgstatError(id: integer);
begin
  case id of
    1: ShowErrorMessage(_('GgStat error: Output file is not defined!'));
    2: ShowErrorMessage(_('GgStat error: Database is not defined!'));
    3: ShowErrorMessage(_('GgStat error: Could not make output file!'));
    4: ShowErrorMessage(_('GgStat error: Database file not exists!'));
    5: ShowErrorMessage(_('GgStat error: Could not open database file!'));
    6: ShowErrorMessage(_('GgStat error: Database error!'));
    7: ShowErrorMessage(_('GgStat error: Could not open template file!'));
  end;
end;

{otevre soubor se sablonou}
procedure OpenTemplate(sender: TObject);
begin
  if (notepadExe <> 'notepad') and (FileExists(notepadExe)) then
    RunExecNoWait(notepadExe+' "'+GEOGET_DATADIR+'\'+FormAdvancedSettings_EditTemplate.Text+'"')
  else
    RunExecNoWait('notepad "'+GEOGET_DATADIR+'\'+FormAdvancedSettings_EditTemplate.Text+'"');
end;

{otevre dialog pro otevreni souboru Template}
procedure OpenTemplateFile(sender: TObject);
begin
  if OpenDlg(_('Select template for GgStat'),GEOGET_SCRIPTDIR,'ofFileMustExist,ofHideReadOnly,ofNoChangeDir',_('Template files (*.cz, *.en)|*.cz;*.en|All files (*.*)|*.*'),template) then
    FormAdvancedSettings_EditTemplate.Text := ReplaceString(template,GEOGET_DATADIR+'\','');
end;

{otevre dokumentaci GgStatu pokud je dostupna}
procedure OpenReadme(sender: TObject);
begin
  if FileExists(GEOGET_SCRIPTDIR+'\GgStat\GgStatHelp.ggp.pas') then GeoCallGGP(GEOGET_SCRIPTDIR+'\GgStat\GgStatHelp.ggp.pas');
end;

{vyrobi soubor ggStatIncludeCR.html}
procedure MakeGgstatIncludeCR(sender: TObject);
var
  s :string;
begin
  if gcCzUID = '' then
    if MessBox(ReplaceVariable(_('Error: UID is empty!%CRLF%Look at forum what is it?')),_('GeoGet error!'),1) = 1 then OpenUrlForumUid(nil);

  s := '<img src="http://www.geocaching.cz/mapacr.php?uid='+gcCzUID+'&typ='+gcCzTypMapy+'" alt="mapa" />' + CRLF + '<br />' + CRLF + '<br />';
  if debugMode then ShowErrorMessage(_('Cachemap (with red dots) code:') + CRLF + CRLF + s);
  StringToFile(s,GEOGET_SCRIPTDIR+'\Autostat\last\ggStatIncludeCR.html');
end;

{generovani pres Autostat, kterej si sam zavola GgStat.exe}
procedure RunGgStat;
begin
  GeoBusyCaption(_('Generating stats'));

  {mazani par-%username%}
  if deleteParFolder then
  begin
    GeoBusyKind(_('Deleting par folder...'));
    if debugMode then ShowErrorMessage(_('Delete folder par-%USERNAME%:') + CRLF + CRLF + 'DelTree(' + ExpandEnvir('%TEMP%\par-%USERNAME%') + ')');
    DelTree(ExpandEnvir('%TEMP%\par-%USERNAME%'));
  end;

  {poustime GgStat.exe}
  GeoBusyKind(_('Run GgStat...'));

  {kontrola zda je vse vyplneno}
  if template = '' then ShowErrorMessage(_('Error: Template name is empty!'));
  if not FileExists(RelToAbsFilename(template,GEOGET_DATADIR))then ShowErrorMessage(_('Error: Template file not found!'));
  if (homeLat = '') or (homeLon = '') then ShowErrorMessage(_('Error: Home coordinates are empty!'));
  if database = '' then ShowErrorMessage(_('Error: Database name is empty!'));
  if statistics = '' then ShowErrorMessage(_('Error: Statistics name is empty!'));
  if GEOGET_OWNER = '' then ShowErrorMessage(_('Error: Your nickname in GeoGet settings is empty!'));

  {prikaz pro zavolani GgStat.exe}
  //RunExec('"'+GgStat+'" -d "'+GEOGET_DATADIR+'/geoget.db3" -o "'+statistics+'" -t "'+template+'" -x '+Geoget_RefX+' -y '+Geoget_RefY+' -c '+GEOGET_OWNER);
  akce := '"script\GgStat\GgStat.exe'+
          '" -d "'+database+'.db3"'+
           ' -o "script\AutoStat\last\'+statistics+'"'+
           ' -t "'+template+'"'+
           ' -x '+homeLat+
           ' -y '+homeLon+
           ' -c "'+GEOGET_OWNER+'"';

  {no a v pripade zapnutyho debugmodu pridame '-q' at nas ggstat nerusi okynkem, ktere se pak musi odkliknout}
  if not debugMode then
    akce := akce + ' -q';

  if debugMode then ShowErrorMessage(_('Run GgStat with these parameters:') + CRLF + CRLF + akce);

  ShowGgStatError(RunExec(akce));

  {mazani par-%username%}
//   if deleteParFolder then
//   begin
//     GeoBusyKind(_('Deleting par folder...'));
//     if debugMode then ShowErrorMessage(_('Delete folder par-%USERNAME%:') + CRLF + CRLF + 'DelTree(' + ExpandEnvir('%TEMP%\par-%USERNAME%') + ')');
//     DelTree(ExpandEnvir('%TEMP%\par-%USERNAME%'));
//   end;
end;

{prime spusteni GgStatu}
procedure RunGgStatPreview(sender: TObject);
begin
  SaveSettings;
  ReadSettings;
  RunGgStat;
  BrowseURL(GEOGET_SCRIPTDIR+'\AutoStat\last\'+statistics);
end;
