{$INCLUDE RelToAbsPath.lib.pas}
{$INCLUDE groundspeak.config.pas}
{$INCLUDE geocaching-cz.config.pas}

const
  {pro kontrolu velikosti vyst. souboru, v Bytech}
  minStatsSize  = '1024'; // v Bytech
  
var
  {vsechny dulezity promenny z nastaveni}
  ini                 :TIniFile;
  template            :string;
  homeLat, homeLon    :string;
  debugMode           :boolean;
  useCurrentDatabase  :boolean;
  database            :string;
  generateCachemap    :boolean;
  gcCzUID             :string;
  gcCzTypMapy         :string;
  statistics          :string;
  downloadLogs        :boolean;
  downloadOwnLogs     :boolean;
  addRank             :boolean;
  divideByPolygon     :boolean;
  addElevation        :boolean;
  generateFtfIndex    :boolean;
  generateFooter      :boolean;
  footerText          :string;
  geojarryForUpload   :boolean;
  ftpUrl              :string;
  ftpName             :string;
  ftpPassword         :string;
  ftpDirectory        :string;
  notepadExe          :string;
  deleteParFolder     :boolean;

{nacte nastaveni z ini, pozatmo z configu pokud jeste ini neni}
procedure ReadSettings;
begin
  {nacteme si hodnoty z AutoStat.ini}
  ini := TIniFile.Create(GEOGET_SCRIPTDIR+'\Autostat\AutoStat.ini');
  try
    statistics          := ini.ReadString('AutoStat','statistics','GgStats.html');
    template            := ini.ReadString('AutoStat','template',RelToAbsFilename('script\AutoStat\templates\GgStatTemplate.cz',GEOGET_DATADIR));
    homeLat             := ini.ReadString('AutoStat','homeLat','');
    homeLon             := ini.ReadString('AutoStat','homeLon','');
    debugMode           := ini.ReadBool('AutoStat','debugMode',false);
    useCurrentDatabase  := ini.ReadBool('AutoStat','useCurrentDatabase',true);
    database            := ini.ReadString('AutoStat','database',GEOGET_DBNAME);
    generateCachemap    := ini.ReadBool('AutoStat','generateCachemap',true);
    gcCzUID             := ini.ReadString('AutoStat','gcCzUID','');
    gcCzTypMapy         := ini.ReadString('AutoStat','gcCzTypMapy','');
    downloadLogs        := ini.ReadBool('AutoStat','downloadLogs',true);
    downloadOwnLogs     := ini.ReadBool('AutoStat','downloadOwnLogs',true);
    addRank             := ini.ReadBool('AutoStat','addRank',true);
    divideByPolygon     := ini.ReadBool('AutoStat','divideByPolygon',false);
    addElevation        := ini.ReadBool('AutoStat','addElevation',false);
    geojarryForUpload   := ini.ReadBool('AutoStat','geojarryForUpload',true);
    ftpUrl              := ini.ReadString('AutoStat','ftpUrl','');
    ftpName             := ini.ReadString('AutoStat','ftpName','');
    ftpPassword         := ini.ReadString('AutoStat','ftpPassword','');
    ftpDirectory        := ini.ReadString('AutoStat','ftpDirectory','');
    generateFtfIndex    := ini.ReadBool('AutoStat','generateFtfIndex',false);
    generateFooter      := ini.ReadBool('AutoStat','generateFooter',true);
    footerText          := ini.ReadString('AutoStat','footerText','<div align="center" style="width: 100%; background-color: #FFFFFF; font-family: Verdana, Arial, sans-serif; font-size: 12px; color: 000000; margin: 1px; border: none;">Statistiky generovan %CURRENTDATE% | <a href="http://www.geocaching.com/profile/?u=mikrom">mikrom</a> | Lb? Koukni <a href="http://geoget.ararat.cz/doku.php/user:skript:autostat">jak na n</a>!</div>');
    notepadExe          := ini.ReadString('AutoStat','notepadExe','notepad');
    deleteParFolder     := ini.ReadBool('AutoStat','deleteParFolder',true);
  finally
    ini.Free;
  end;

  if useCurrentDatabase then database := GEOGET_DBNAME;
end;

{zapise hodnoty do AutoStat.ini}
procedure SaveSettings;
begin
  ini := TIniFile.Create(GEOGET_SCRIPTDIR+'\Autostat\AutoStat.ini');
  try
    with ini do
    begin
      WriteString('AutoStat','statistics',FormAdvancedSettings_EditStatistics.Text);
      WriteString('AutoStat','template',FormAdvancedSettings_EditTemplate.Text);
      WriteString('AutoStat','homeLat',FormAdvancedSettings_EditHomeLat.Text);
      WriteString('AutoStat','homeLon',FormAdvancedSettings_EditHomeLon.Text);
      WriteBool('AutoStat','debugMode',FormAdvancedSettings_CbDebugMode.Checked);
      WriteBool('AutoStat','useCurrentDatabase',FormAdvancedSettings_CbUseCurrentDatabase.Checked);
      WriteString('AutoStat','database',FormAdvancedSettings_EditDatabaseSelect.Text);
      WriteBool('AutoStat','generateCachemap',FormAdvancedSettings_CbGenerateCachemap.Checked);
      WriteString('AutoStat','gcCzUID',FormAdvancedSettings_EditGcCzUID.Text);
      WriteString('AutoStat','gcCzTypMapy',FormAdvancedSettings_EditGcCzTypMapy.Text);
      WriteBool('AutoStat','downloadLogs',FormAdvancedSettings_CbDownloadLogs.Checked);
      WriteBool('AutoStat','downloadOwnLogs',FormAdvancedSettings_CbDownloadOwnLogs.Checked);
      WriteBool('AutoStat','addRank',FormAdvancedSettings_CbAddRank.Checked);
      WriteBool('AutoStat','divideByPolygon',FormAdvancedSettings_CbDivideByPolygon.Checked);
      WriteBool('AutoStat','addElevation',FormAdvancedSettings_CbAddElevation.Checked);
      WriteBool('AutoStat','geojarryForUpload',FormAdvancedSettings_RbProfile.Checked);
      WriteString('AutoStat','ftpUrl',FormAdvancedSettings_EditFtpUrl.Text);
      WriteString('AutoStat','ftpName',FormAdvancedSettings_EditFtpUser.Text);
      WriteString('AutoStat','ftpPassword',FormAdvancedSettings_EditFtpPassword.Text);
      WriteString('AutoStat','ftpDirectory',FormAdvancedSettings_EditFtpDirectory.Text);
      WriteBool('AutoStat','generateFtfIndex',FormAdvancedSettings_CbGenerateFtfIndex.Checked);
      WriteBool('AutoStat','generateFooter',FormAdvancedSettings_CbGenerateFooter.Checked);
      WriteString('AutoStat','footerText',FormAdvancedSettings_EditFooterText.Text);
      WriteBool('AutoStat','deleteParFolder',FormAdvancedSettings_CbDeleteParFolder.Checked);
    end;
  finally
    ini.Free;
  end;
end;
