//GeoGet 2

function ExportExtension: string;
begin
  result := 'MP';
end;

function ExportDescription: string;
begin
  result := 'Polish format for Garmin GPS map';
end;

function ExportHint: string;
begin
  result := 'Creating of transparent POI map for GARMIn GPS. (Source file for cGPSmapper compiler.)';
  if copy(GetCurrentLanguage, 1, 2) = 'cs' then
    result := 'Vytvo transparetn POI mapu pro GPS Garmin. (Zdrojov soubor pro peklada cGPSmapper.)';
end;

function ExportHeader: string;
begin
  Result := '[IMG ID]' + CRLF;
  Result := Result + 'ID=42000422' + CRLF;
  Result := Result + 'Name=Geocache' + CRLF;
  Result := Result + 'Preprocess=F' + CRLF;
  Result := Result + 'TreSize=100' + CRLF;
  Result := Result + 'TreMargin=0.00000' + CRLF;
  Result := Result + 'RgnLimit=500' + CRLF;
  Result := Result + 'Transparent=Y' + CRLF;
  Result := Result + 'POIIndex=Y' + CRLF;
  Result := Result + 'Levels=2' + CRLF;
  Result := Result + 'Level0=24' + CRLF;
  Result := Result + 'Level1=17' + CRLF;
  Result := Result + 'Zoom0=0' + CRLF;
  Result := Result + 'Zoom1=1' + CRLF;
  Result := Result + '[END-IMG ID]' + CRLF + CRLF;
end;

function ExportFooter: string;
begin
  result := '';
end;

function ExportPoint: string;
var
  s: string;
  n: integer;
begin
  Result := '';
  //geocache
  if GC.IsListed then
  begin
    Result := Result + '[POI]' + CRLF;
    Result := Result + 'Type=0x6608' + CRLF;
    s := GC.ID;
    if length(s) > 2 then
    begin
      //replace first char by '-' if cache is inactive
      if GC.IsDisabled then
        s[1] := '-';
      //replace first char by '\' if cache is found
      if GC.IsFound then  
        s[1] := '\';
    end;
    Result := Result + 'Label=' + s + ' ' + GC.IDTag + ' ' + UtfToGps(GC.Name) + CRLF; 
    if (GC.Hint <> '') then
    begin
      s := UtfToGps(GC.Hint);
      if length(s) > 40 then
        s := copy(s, 1, 39) + '%';
      Result := Result + 'StreetDesc=' + s + CRLF;  
    end;
    Result := Result + 'Data0=(' + GC.Lat + ',' + GC.Lon + ')' + CRLF;
    Result := Result + '[END]' + CRLF + CRLF;
  end;
  //waypoints
  for n := 0 to GC.Waypoints.Count - 1 do
    if GC.Waypoints[n].IsListed then
    begin
      Result := Result + '[POI]' + CRLF;
      Result := Result + 'Type=0x6608' + CRLF;
      s := GC.Waypoints[n].ID;
      if length(s) > 2 then
      begin
        //replace first char by '-' if cache is inactive
        if GC.IsDisabled then
          s[1] := '-';
        //replace first char by '\' if cache is found
        if GC.IsFound then  
          s[1] := '\';
      end;
      if GC.Waypoints[n].IsFinal then
      begin 
        Result := Result + 'Label=' + s + ' ' + GC.Waypoints[n].TypeID + ' ' + GC.IDTag + ' ' + UtfToGps(GC.Waypoints[n].FullName) + CRLF; 
        if (GC.Hint <> '') then
        begin
          s := UtfToGps(GC.Hint);
          if length(s) > 40 then
            s := copy(s, 1, 39) + '%';
          Result := Result + 'StreetDesc=' + s + CRLF;  
        end;
      end
      else
        Result := Result + 'Label=' + s + ' ' + GC.Waypoints[n].TypeID + ' ' + UtfToGps(GC.Waypoints[n].FullName) + CRLF; 
      Result := Result + 'Data0=(' + GC.Waypoints[n].Lat + ',' + GC.Waypoints[n].Lon + ')' + CRLF;
      Result := Result + '[END]' + CRLF + CRLF;
    end;
end;

function ExportAfter(value: string): string;
begin
  Result := '';
//  RunExec('cgpsmapper.exe ac ' + value);
end;