//GeoGet 2

function ExportExtension: string;
begin
  result := 'GPX';
end;

function ExportDescription: string;
begin
  result := 'POI simple GPX';
end;

function ExportHint: string;
begin
  result := 'Simple export as a Custom POI (Garmin POI loader)';
  if copy(GetCurrentLanguage, 1, 2) = 'cs' then
    result := 'Jednoduch export jako uivatelsk body zjmu (Garmin POI loader)';
end;

function ExportHeader: string;
begin
  Result := '<?xml version="1.0" encoding="utf-8"?>' + CRLF;
  Result := Result + '<gpx xmlns:xsd="http://www.w3.org/2001/XMLSchema"'
    + ' xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.0"'
    + ' creator="Groundspeak Pocket Query"'
    + ' xsi:schemaLocation="http://www.topografix.com/GPX/1/0 http://www.topografix.com/GPX/1/0/gpx.xsd'
    + ' http://www.groundspeak.com/cache/1/0 http://www.groundspeak.com/cache/1/0/cache.xsd"'
    + ' xmlns="http://www.topografix.com/GPX/1/0">' + CRLF;
  Result := Result + ' <desc>Geocache file</desc>' + CRLF;
  Result := Result + ' <author>' + Geoget_Version + '</author>' + CRLF;
  Result := Result + ' <time>' + formatdatetime('yyyy"-"mm"-"dd"T"hh":"nn":"ss"."zzz', now) + '</time>' + CRLF;
  Result := Result + ' <keywords>cache, geocache, groundspeak</keywords>' + CRLF + CRLF;
end;

function ExportFooter: string;
begin
  result := '</gpx>' + CRLF;
end;

function ExportPoint: string;
var
  n: integer;
  s: string;
begin
  result := '';
  //Export for Geocaches
  if gc.islisted then
  begin
    s := GC.ID;
    if GC.IsDisabled then
      s := '-' + s;
    if GC.IsFound then  
      s := '\' + s;
    Result := Result + ' <wpt lat="' + GC.Lat + '" lon="' + GC.Lon + '">' + CRLF;
    Result := Result + '  <time>'
      + formatdatetime('yyyy"-"mm"-"dd"T"hh":"nn":"ss"."zzz', GC.Hidden) + '</time>' + CRLF;
    Result := Result + '  <name>' + cdata(utftoascii(s + ' ' + GC.IDTag + ' ' + GC.Name)) + '</name>' + CRLF;
    s := '(' + GC.Author + ')';
    if GC.Comment <> '' then
      S := s + ' N:' + GC.Comment;
    if GC.Hint <> '' then
      S := s + ' H:' + GC.Hint;
    Result := Result + '  <cmt>' + cdata(utftoascii(s)) +'</cmt>' + CRLF;
    Result := Result + '  <desc></desc>' + CRLF;
    Result := Result + ' </wpt>' + CRLF + CRLF;
  end;
  //Export for Waypoints
  for n := 0 to GC.Waypoints.Count - 1 do
    if GC.Waypoints[n].IsListed then
    begin
      s := GC.Waypoints[n].ID;
      if GC.IsDisabled then
        s := '-' + s;
      if GC.IsFound then  
        s := '\' + s;
      Result := Result + ' <wpt lat="' + GC.Waypoints[n].Lat + '" lon="' + GC.Waypoints[n].Lon + '">' + CRLF;
      Result := Result + '  <time>'
        + formatdatetime('yyyy"-"mm"-"dd"T"hh":"nn":"ss"."zzz', GC.Hidden) + '</time>' + CRLF;
      Result := Result + '  <name>' + cdata(utftoascii(s + ' ' + GC.Waypoints[n].TypeID + ' ' + GC.Waypoints[n].FullName)) +'</name>' + CRLF;
      s := GC.Waypoints[n].Description;
      if GC.Waypoints[n].Comment <> '' then
        s := s + ' N:' + GC.Waypoints[n].Comment; 
      if GC.Waypoints[n].IsFinal then
        s := ' ' + GC.IDTag + ' H:' + GC.Hint;
      Result := Result + '  <cmt>' + cdata(utftoascii(s)) +'</cmt>' + CRLF;
      Result := Result + '  <desc></desc>' + CRLF;
      Result := Result + ' </wpt>' + CRLF + CRLF;
    end;
end;
