//General Plugin Script
  
function PluginCaption: string;
begin
  // Name of plugin
  Result := _('Import GGT');
end;

function PluginHint: string;
begin
  // What will be displayed as hint in case of icon on the toolbar?
  Result := _('Import caches from a GGT file by Geocaching Live');
end;

function PluginIcon: string;
begin
  // Icon data.
  Result := '';
end;

function PluginFlags: string;
begin
  // How Geoget can handle this plugin?
  Result := 'nowork';
end;

procedure PluginStart;
begin
  // Called when plugin is started
end;

procedure PluginWork;
begin
  // Called for each processed point
end;

procedure PluginStop;
var
  ggtfile: string;
  l: tstringlist;
begin
  ggtfile := '';
  if OpenDlg(_('Select a GGT file'), geoget_datadir, '', 'GGT file(*.ggt)|*.ggt', ggtfile) then
  begin
    l := tstringlist.create;
    try
      GeoBusyStart;
      l.loadfromfile(ggtfile);
      GeoImportBegin;
      GcLiveUpdateListing(l.text, true);
      GeoImportEnd;
    finally
      l.free;
    end;
  end;
end;
