{$INCLUDE gj2.lib.uses.pas}
{$INCLUDE gj2.lib.pas}

var 
  containedOldFilterQuery,containedOldIncompatibleQuery,containedOldIncompatibleBatch,containedBasicInfoQuery,removedExe : boolean;
  oldFilterQueryList,basicInfoQueryList : TStrings;
  
function LANG_SPECIFIC_DIR() : String; //Directory, where presaved batches, queries and other language-dependent files reside
begin Result := GEOJARRY_DIR + 'lang_specific\'; end;

{Update batch to the newest file format}
procedure UpdateBatch(file : String);
var content,ver, verregex : String;
begin
   verregex := '(?s)# GEOJARRY_VERSION = ''([\d\.]+)''';
   
   content := FileToString(file);
   ver := RegexSubstitute(verregex,content,'$1');
   if CompareVer('2.2.0', ver) then
   begin
     StringToFile(content,file + '.old');
     
     content := ReplaceString(content,CRLF + 'Clear GeoGet window',CRLF + 'GgClearWindow');
     content := ReplaceString(content,CRLF + 'Import downloaded queries',CRLF + 'GgImport');
     content := ReplaceString(content,CRLF + 'Pending list - download + all logs',CRLF + 'PendDownAll');
     content := ReplaceString(content,CRLF + 'Pending list - download',CRLF + 'PendDown');
     content := ReplaceString(content,CRLF + 'Geocaching.com - get dates of my finds',CRLF + 'GcGetFinds');
     content := ReplaceString(content,CRLF + 'Run GeoGet GGP script',CRLF + 'GgRunGGP');
     content := ReplaceString(content,CRLF + 'Pending list - save as GGT list',CRLF + 'PendSave');
     content := ReplaceString(content,CRLF + 'Set reference point',CRLF + 'GgSetRefPoint');
     content := ReplaceString(content,CRLF + 'Pending list - filter out found/owned',CRLF + 'PendOutFndOwn');
     content := ReplaceString(content,CRLF + 'Pending list - filter out database',CRLF + 'PendOutDb');
     content := ReplaceString(content,CRLF + 'Pending list - clear',CRLF + 'PendClear');
     content := ReplaceString(content,CRLF + 'Pending list - load to GeoGet window',CRLF + 'PendLoadWindow');
     content := ReplaceString(content,CRLF + 'Pending list - subtract from GeoGet window',CRLF + 'PendSub');
     content := ReplaceString(content,CRLF + 'Groundspeak - change login',CRLF + 'GsLoginChange');
     content := ReplaceString(content,CRLF + 'Groundspeak - reset login',CRLF + 'GsLoginReset');
     content := ReplaceString(content,CRLF + 'Change GeoGet database',CRLF + 'GgDbChange');
     content := ReplaceString(content,CRLF + 'Hide next import results',CRLF +'GgHideImport');
     content := ReplaceString(content,CRLF + 'Add|',CRLF +'QueryAdd|');
     content := ReplaceString(content,CRLF + 'Download|',CRLF +'QueryDown|');
     content := ReplaceString(content,CRLF + 'Subtract|',CRLF +'QuerySub|');
     
     content := RegexReplace(verregex, content, '# GEOJARRY_VERSION = '''+ GEOJARRY_VERSION +'''', false);
     
     containedOldIncompatibleBatch := true;
     StringToFile(content,file);
   end
end;

{Update query to the newest file format}
procedure UpdateQuery(file : String);
var content,ver,verregex,ggpFile : String;
    save : boolean;
begin
   verregex := '(?s)Version=([\d\.]+)';
   save := true;
   
   content := FileToString(file);
   ver := RegexSubstitute(verregex,content,'$1');
   if CompareVer('2.2.0', ver) then
   begin
     StringToFile(content,file + '.old');
     
     content := ReplaceString(content,CRLF + 'QueryType=Coordinates' + CRLF,CRLF + 'QueryType=CoordTab' + CRLF);
     content := ReplaceString(content,CRLF + 'QueryType=Country' + CRLF,CRLF + 'QueryType=CountryTab' + CRLF);
     content := ReplaceString(content,CRLF + 'QueryType=User' + CRLF,CRLF + 'QueryType=UserTab' + CRLF);
     content := ReplaceString(content,CRLF + 'QueryType=Route' + CRLF,CRLF + 'QueryType=RouteTab' + CRLF);
     content := ReplaceString(content,CRLF + 'QueryType=Name' + CRLF,CRLF + 'QueryType=NameTab' + CRLF);
     content := ReplaceString(content,CRLF + 'QueryType=GC code' + CRLF,CRLF + 'QueryType=CodeTab' + CRLF);
     content := ReplaceString(content,CRLF + 'QueryType=PQ' + CRLF,CRLF + 'QueryType=PqTab' + CRLF);
     content := ReplaceString(content,CRLF + 'QueryType=Filter' + CRLF,CRLF + 'QueryType=FilterTab' + CRLF);
     content := ReplaceString(content,CRLF + 'QueryType=Current list' + CRLF,CRLF + 'QueryType=CurrentTab' + CRLF);
     content := ReplaceString(content,CRLF + 'QueryType=List' + CRLF,CRLF + 'QueryType=ListTab' + CRLF);
     content := ReplaceString(content,CRLF + 'QueryType=SQL' + CRLF,CRLF + 'QueryType=SqlTab' + CRLF);
     
     content := ReplaceString(content,CRLF + 'GeocacheType=All geocache types' + CRLF,CRLF + 'GeocacheType=--' + CRLF);
     
     
     if (RegexFind('QueryType=FilterTab',content) and (StrToInt(RegexSubstitute('FilterMethod=(\d+)',content,'$1')) > 0)) then
     begin //GeoGet database filter query with incompatible filtering options
        containedOldFilterQuery := true;
        oldFilterQueryList.add(GetQueryName(file));
        DeleteFile(file);
        ggpFile := PluginFileFromName(GetQueryName(file), QUERY_PLUGINSUFFIX);
        if FileExists(ggpFile) then DeleteFile(ggpFile);
        save := false;
     end;
      
     if (RegexFind('DownloadListings=0',content) and RegexFind('QueryBase=web',content)) then
     begin //Geocaching.com query set to download basic info
        containedBasicInfoQuery := true;
        basicInfoQueryList.add(GetQueryName(file));
        content := RegexReplace('DownloadListings=0\s*',content,'',false);
     end;    
     
     if save then
     begin
        containedOldIncompatibleQuery := true;
        content := RegexReplace(verregex, content, 'Version=' + GEOJARRY_VERSION, false);
        StringToFile(content,file);
     end;
   end;
  end;
  
procedure GjInstallShowMessage(str : String);
begin
    if not GEOGET_SILENTINSTALL then ShowMessage(str);
end;

procedure UpdateFolder(folder : String);
var 
  n : Integer;
  list : TStringList;
  s : String;
begin
  list := TStringList.Create;
  try
     containedOldIncompatibleQuery := false;
     containedOldIncompatibleBatch := false;
     containedOldFilterQuery := false;
     containedBasicInfoQuery := false;
     
     FileList(folder,list);
     for n := 0 to list.count-1 do
     begin
         if RegexFind('gjb$',list[n]) then UpdateBatch(list[n]) else
         if RegexFind('gjq$',list[n]) then UpdateQuery(list[n]);
     end;

     if containedOldFilterQuery then 
     begin
       s := _('Some of the saved GeoGet database filter queries are no longer compatible with new GeoJarry. Since GeoGet filters were improved, there is no longer the need to modify filters in GeoJarry (last date of update, presence of listing in database). Previous functionality can be achieved via sole GeoGet filters.' + CRLF + CRLF + 'List of incompatible queries:' + CRLF + '%QUERYLIST%' + CRLF + 'Backups of the incompatible queries can still be found in GeoJarry query directory:' + CRLF + '%QUERYDIR%.');
       s := ReplaceString(s,'%QUERYDIR%',QUERY_DIR);
       s := ReplaceString(s,'%QUERYLIST%',OldFilterQueryList.text);
       GjInstallShowMessage(s) 
     end;
     
     if containedBasicInfoQuery then
     begin
       s := _('Behaviour of some of the saved Geocaching.com queries was changed. Since it is no longer possible to download only basic info from Geocaching.com servers, queries were automatically set to download listings.' + CRLF + CRLF + 'List of changed queries:' + CRLF + '%QUERYLIST%' + CRLF + 'Backups of the original queries can still be found in GeoJarry query directory:' + CRLF + '%QUERYDIR%.');
       s := ReplaceString(s,'%QUERYDIR%',QUERY_DIR);
       s := ReplaceString(s,'%QUERYLIST%',BasicInfoQueryList.text);
       GjInstallShowMessage(s) 
     end;
           
     if containedOldIncompatibleQuery then
     begin
       s := _('Some of the saved queries were incompatible with new GeoJarry. They were automatically updated to ensure the full compatibility. ' + CRLF + 'Backups of old queries can be found in %QUERYDIR%.');
       s := ReplaceString(s,'%QUERYDIR%',QUERY_DIR);
       GjInstallShowMessage(s);
       containedOldIncompatibleQuery := false;
     end;
     
     if containedOldIncompatibleBatch then
     begin
       s := _('Some of the saved batches were incompatible with new GeoJarry. They were automatically updated to ensure the full compatibility. ' + CRLF + 'Backups of old batches can be found in %BATCHDIR%.');
       s := ReplaceString(s,'%BATCHDIR%',BATCH_DIR);
       GjInstallShowMessage(s);
       containedOldIncompatibleBatch := false;
     end;
  finally
     list.Free;
  end;
end;

procedure AddGgpToGroupAndToolbar;
var list : TStringList;
    n : Integer;
begin
    list := GetRegexFileList(GEOJARRY_DIR, 'gj2\.exec\..*ggp\.pas$');
    try          
        for n := 0 to list.count-1 do 
        begin
          if (GeoGetPluginGroup(list[n]) = GeoGetDefaultGroup) then
          begin
            GeoSetPluginGroup(list[n],GEOJARRY_PLUGINGROUP);
            GeoSetToolbar(list[n],true);
          end;
        end;
    finally
        list.Free;
    end;
end;

procedure CopyPresavedExecutables(folderFrom, folderTo : String);
var list : TStrings;
    n : Integer;
begin
    list := GetRegexFileList(folderFrom, 'gj2\.exec\..*ggp\.pas$');
    try
       for n := 0 to list.count-1 do
       begin
           CopyFile(list[n],ReplaceString(list[n],folderFrom,folderTo));
       end;
    finally
      list.Free;
    end;
end;

function SafelyRemoveFile(filename : String) : boolean;
begin
   Result := false;
   if FileExists(filename) then Result := DeleteFile(filename);
end;

function SafelyCopyFile(source,destination : String) : boolean;
begin
   Result := false;
   if ((FileExists(source)) and (not FileExists(destination)))then Result := CopyFile(source,destination);
end;

function SafelyRewriteFile(source,destination : String) : boolean;
begin
   Result := false;
   if FileExists(source)then Result := CopyFile(source,destination);
end;

procedure InstallInit;
begin
    oldFilterQueryList := TStringList.Create;
    basicInfoQueryList := TStringList.Create;
end;

procedure InstallCleanup;
begin
    oldFilterQueryList.Free;
    basicInfoQueryList.Free;
end;

function InstallWork: String;
var lang,langdir,s,ver: String;
begin
  //Init
  Result := '';
  removedExe := false;
  InstallInit;
  
  ver := GeoGetPackagePreviousVersion('geojarry');

  //Remove old config file. New version is not compatible with the old config  
  if ((ver = '') or CompareVer('2.2.0',ver)) then
  begin
    SafelyRemoveFile(GEOGET_SCRIPTDIR + '\' + GEOJARRY_CONFIG);
    SafelyRemoveFile(GEOGET_SCRIPTDIR + '\gj2.default.pas');  
  end;
  

  //Delete GeoJarry executables from datadir
  if SafelyRemoveFile(GEOGET_DATADIR + '\geojarryw.exe') then removedExe := true;
  if SafelyRemoveFile(GEOGET_DATADIR + '\geojarry.exe') then removedexe := true;
  if removedExe then GjInstallShowMessage(_('GeoJarry deleted executable placed directly in GeoGet datadir. It is no longer recommended to save executables in datadir. If any of your scripts stops working after this installation, search for updates of the script compatible with new version of GeoJarry.'));

  //Copy lang_specific data
  lang := copy(GetCurrentLanguage,1,2);
  langdir := LANG_SPECIFIC_DIR + lang + '\';
  if (not DirectoryExists(langdir)) then langdir := LANG_SPECIFIC_DIR + 'en\';
  
  //Advice users upgrading from versions < 2.2.0 that they should delete their old queries. Delete them if they agree
  if (((ver = '') or CompareVer('2.2.0',ver)) and (not ((DirIsEmpty(QUERY_DIR)) and (DirIsEmpty(BATCH_DIR))))) then
  begin
      s := _('GeoJarry found out, that you are upgrading from version older than 2.2.0. There were several changes introduced in version 2.2.0 and it is recommended to delete any previously created batches and queries.' + CRLF + CRLF + 'If you choose not to delete the old objects, they will be automatically updated to meet the current requirements. Some of the functionality might be broken and you will not get the new localised versions of queries and batches.' + CRLF + CRLF + 'If you choose to delete the old objects, GeoJarry will autmatically copy new, localised and fully compatible queries and batches from the new installation package.  Any changes you might have done to the preinstalled queries or batches WILL BE DELETED! Any user-created queries or batches WILL BE DELETED!' + CRLF + CRLF + CRLF + 'Would you like to delete your old queries and batches?');
      if (MessBox(s, _('GeoJarry'),4) = 6) then
      begin
          DelTree(QUERY_DIR);
          DeleteFiles(GEOJARRY_DIR + '*.' + QUERY_PLUGINSUFFIX);
          
          DelTree(BATCH_DIR);
          DeleteFiles(GEOJARRY_DIR + '*.' + BATCH_PLUGINSUFFIX);
      end;
  end;
  
  //Update old incompatible batches and queries
  if not (DirIsEmpty(QUERY_DIR)) then UpdateFolder(QUERY_DIR);
  if not (DirIsEmpty(BATCH_DIR)) then UpdateFolder(BATCH_DIR);
  
  //Copy queries and batches (and presaved executables), if QUERY_DIR and BATCH_DIR are empty
  if (DirIsEmpty(QUERY_DIR) and DirIsEmpty(BATCH_DIR)) then
  begin
      CopyTree(langdir + 'query',QUERY_DIR);
      CopyTree(langdir + 'batch',BATCH_DIR);
      //Copy presaved executables
      CopyPresavedExecutables(langdir,GEOJARRY_DIR);
  end;
  
  //Copy Bookmark file
  SafelyCopyFile(langdir + 'bookmarks.txt',GEOJARRY_DIR + 'bookmarks.txt');
  
  //Save executable macros to GeoJarry plugin group and toolbar
  //Only do it when installing geojarry for the first time (not on the updates)
  if (ver = '') then AddGgpToGroupAndToolbar;

  //Copy Readme file
  SafelyRewriteFile(langdir + 'readme.txt',GEOJARRY_DIR + 'readme.txt');

  //Remove lang-specific directory
  DelTree(LANG_SPECIFIC_DIR);

  //Cleanup
  InstallCleanup;    
  
  //Show Readme & Changelog
  s := GEOJARRY_DIR + 'readme.txt';
  
  if not GEOGET_SILENTINSTALL then
  begin
    if (FileExists(s) and (MessBox(_('Would you like to view the readme file?' + CRLF + 'The file also includes the list of changes in the last version.'), _('GeoJarry'),4) = 6)) 
      then ShowLongMessage(_('GeoJarry readme file'),FileToString(s));
  end;
end;