const
   SEARCH_URL = 'http://maps.google.com/maps/geo?q=$KEYWORD&output=csv'; //URL with search $KEYWORD
   VIEW_URL = 'http://maps.google.com/maps?&q=$LATITUDE,$LONGITUDE'; //URL with search $LATITUDE and $LONGITUDE
var
   Lat, Lon : Extended;

procedure ShowButtonAction(Sender :TObject);
var
   url : String;
begin
   url := ReplaceString(VIEW_URL,'$LATITUDE',FloatToStr(Lat));
   url := ReplaceString(url,'$LONGITUDE',FloatToStr(Lon));
   RunShell(url);
end;

{Translate Google result code into human-readable format}
function ProcessRescode(Rescode : String) : boolean;
var
   r : String;
begin
   Result := (Rescode = '200');
   if Result
      then gj2geocoding_ResultLabel.Font.Color := clGreen
      else gj2geocoding_ResultLabel.Font.Color := clRed;
   if rescode = '200' then r := _('Search successfully processed') else
   if rescode = '400' then r := _('Bad request') else
   if rescode = '500' then r := _('Server error') else
   if rescode = '601' then r := _('No keyword specified') else
   if rescode = '602' then r := _('No place found, try another keyword') else
   if rescode = '603' then r := _('Search results could not be returned due to legal or contractual reasons') else
   if rescode = '610' then r := _('Google API key error. Try searching again.') else
   if rescode = '620' then r := _('Too many requests in last 24 hours') else
   ShowMessage(_('Error while processing result code!'));
   gj2geocoding_ResultLabel.Caption := r;

end;

{Translate Google result accuracy code into human-readable format}
procedure ProcessAccuracy(accuracy : String);
var
   a : String;
begin
  if accuracy = '0' then a := _('Unknown accuracy') else
  if accuracy = '1' then a := _('Country level accuracy') else
  if accuracy = '2' then a := _('Region (state, province, etc.) level accuracy') else
  if accuracy = '3' then a := _('Sub-region (county, municipality, etc.) level accuracy') else
  if accuracy = '4' then a := _('Town (city, village) level accuracy') else
  if accuracy = '5' then a := _('Post code (zip code) level accuracy') else
  if accuracy = '6' then a := _('Street level accuracy') else
  if accuracy = '7' then a := _('Intersection level accuracy') else
  if accuracy = '8' then a := _('Address level accuracy') else
  if accuracy = '9' then a := _('Premise (building, property, shopping center, etc.) level accuracy')  else
  ShowMessage(_('Error while processing accuracy code!'));
  gj2geocoding_AccuracyLabel.Caption := a;
end;

procedure ProcessCoordinates(Lat, Lon : Extended);
begin
  gj2geocoding_CoordinatesLabel.Caption := FormatCoordNum(Lat, Lon);
end;

procedure ClearResultBox;
begin
   gj2geocoding_ShowButton.Enabled := false;
   gj2geocoding_SetButton.Enabled := false;
   gj2geocoding_CoordinatesLabel.Caption := '';
   gj2geocoding_AccuracyLabel.Caption := '';
   
end;

procedure SearchButtonAction(Sender :TObject);
var
   keyword,res,url: String;
begin
   keyword := EncodeUrlElement(AnsiToUtf(gj2geocoding_SearchEdit.Text));
   url := ReplaceString(SEARCH_URL, '$KEYWORD' , keyword);
   HttpAsk('GET', url, '', '', res);
   gj2geocoding_ResultBox.Caption := gj2geocoding_SearchEdit.Text;
   ClearResultBox;
   if ProcessRescode(Fetch(res,',')) then
   begin
      ProcessAccuracy(Fetch(res,','));
      gj2geocoding_CoordinatesLabel.Caption := res;
      Lat := StrToFloat(Fetch(res,','));
      Lon := StrToFloat(Fetch(res,','));
      ProcessCoordinates(Lat, Lon);
      gj2geocoding_ShowButton.Enabled := true;
      gj2geocoding_SetButton.Enabled := true;

   end;

   gj2geocoding_HintTextLabel.Visible := false;
   gj2geocoding_ResultBox.Visible := true;
end;

procedure SearchEditOnKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
    if (Key = 13) then //Enter
    begin
      Key := 0;
      SearchButtonAction(Sender);
    end;
end;

procedure GeocodingSetActions;
begin
  gj2geocoding.Caption := _('GeoJarry %VERSION% - Google search for coordinates');
  gj2geocoding.Caption := ReplaceString(gj2geocoding.Caption,'%VERSION%',GEOJARRY_VERSION);  

  gj2geocoding_SearchButton.OnClick := @SearchButtonAction;
  gj2geocoding_ShowButton.OnClick := @ShowButtonAction;
  gj2geocoding_SearchEdit.OnKeyDown := @SearchEditOnKeyDown;
end;

{Use this form only with this function}
function CoordSearch(var x, y: extended): boolean; 
begin
   result := false;
   if gj2geocoding.showmodal = 45 then
   begin
      x := Lat;
      y := Lon;
      Result := true;
   end;
end;

