procedure BatchListBoxOnClick(Sender :TObject);
begin
   if (gj2main_BatchListBox.ItemIndex <> -1) then
   begin
      gj2main_BatchButtonEdit.Enabled := true;
      gj2main_BatchButtonDelete.Enabled := true;
      gj2main_BatchButtonRun.Enabled := true;
      gj2main_BatchButtonPlugin.Enabled := true;
      gj2main_BatchListBox.Hint := gj2main_BatchListBox.Items[gj2main_BatchListBox.ItemIndex];
      if FileExists(PluginFileFromName(gj2main_BatchListBox.Items[gj2main_BatchListBox.ItemIndex], BATCH_PLUGINSUFFIX)) 
        then gj2main_BatchButtonPlugin.Font.Style := [fsBold]
        else gj2main_BatchButtonPlugin.Font.Style := [];
      gj2main_BatchLabelAbout.Caption := GeoJarrybatchInfo(GetBatchFile(gj2main_BatchListBox.Items[gj2main_BatchListBox.ItemIndex]));
   end
   else
   begin
      gj2main_BatchButtonEdit.Enabled := false;
      gj2main_BatchButtonDelete.Enabled := false;
      gj2main_BatchButtonRun.Enabled := false;
      gj2main_BatchButtonPlugin.Enabled := false;
      gj2main_BatchListBox.Hint := _('List of available batches');
      gj2main_BatchButtonPlugin.Font.Style := [];
      gj2main_BatchLabelAbout.Caption := _('Select a batch, please.' + CRLF + CRLF + 'Batch is a sequence of commands for GeoJarry engine. Batch can download, import and process all data you need with only one click of your mouse.');   
   end;
end;

procedure SetDefaults;
begin
    GeoJarrywebSetDefaults;
    GeoJarrydbSetDefaults;
    GeoJarrywmSetDefaults;
end;

procedure BatchListBoxOnDblClick(Sender :TObject);
var
    batchfile,res : String;
begin
  if (gj2main_BatchListBox.ItemIndex <> -1) then
    begin
       gj2main.hide;
       batchfile := GetBatchFile(gj2main_BatchListBox.Items[gj2main_BatchListBox.ItemIndex]);
       res := RunBatch(batchfile)
       if res <> RESULT_VALID then
       begin
          ShowMessage(res);
          gj2main.show;
       end
       else gj2main.close;
    end; 
end;

procedure BatchListBoxOnKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
    if (Key = 13) then //enter
    begin
      BatchListBoxOnDblClick(Sender);
    end;
end;  

procedure QueryListBoxOnClick(Sender :TObject);
begin
   if (gj2main_QueryListBox.ItemIndex <> -1) then
   begin
      gj2main_QueryButtonEdit.Enabled := true;
      gj2main_QueryButtonDelete.Enabled := true;
      gj2main_QueryButtonRun.Enabled := true;
      gj2main_QueryButtonPlugin.Enabled := true;
      gj2main_QueryListBox.Hint := gj2main_QueryListBox.Items[gj2main_QueryListBox.ItemIndex];
      if FileExists(PluginFileFromName(gj2main_QueryListBox.Items[gj2main_QueryListBox.ItemIndex], QUERY_PLUGINSUFFIX)) 
        then gj2main_QueryButtonPlugin.Font.Style := [fsBold]
        else gj2main_QueryButtonPlugin.Font.Style := [];
      gj2main_QueryLabelAbout.Caption := QueryInfo(GetQueryFile(gj2main_QueryListBox.Items[gj2main_QueryListBox.ItemIndex]));
   end
   else
   begin
      gj2main_QueryButtonEdit.Enabled := false;
      gj2main_QueryButtonDelete.Enabled := false;
      gj2main_QueryButtonRun.Enabled := false;
      gj2main_QueryButtonPlugin.Enabled := false;
      gj2main_BatchListBox.Hint := _('List of available queries');
      gj2main_QueryButtonPlugin.Font.Style := [];
      gj2main_QueryLabelAbout.Caption := _('Select a query, please.' + CRLF + CRLF + 'Query is a simple command for GeoJarry engine. You can combine queries into more complicated batches.');
   end; 
end;

procedure BatchListBoxRefresh;
var
   selected : String;
begin
   selected := '';
   if gj2main_BatchListBox.ItemIndex <> -1 then selected := gj2main_BatchListBox.Items[gj2main_BatchListBox.ItemIndex];
   gj2main_BatchListBox.Items := GetFilteredFileList(BATCH_DIR, BATCH_SUFFIX);
   gj2main_BatchListBox.ItemIndex := gj2main_BatchListBox.Items.indexOf(selected);
   BatchListBoxOnClick(nil);
end;

procedure QueryListBoxRefresh;
var
   selected :  String;
begin
   selected := '';
   if gj2main_QueryListBox.ItemIndex <> -1 then selected := gj2main_QueryListBox.Items[gj2main_QueryListBox.ItemIndex];
   gj2main_QueryListBox.Items := GetFilteredFileList(QUERY_DIR, QUERY_SUFFIX);
   gj2main_QueryListBox.ItemIndex := gj2main_QueryListBox.Items.indexOf(selected);
   QueryListBoxOnClick(nil);
end;

procedure QueryListBoxOnDblClick(Sender :TObject);
var
  res,q: String;
begin
  if (gj2main_QueryListBox.ItemIndex <> -1) then
  begin
    q := GetQueryFile(gj2main_QueryListBox.Items[gj2main_QueryListBox.ItemIndex]);
    gj2main.hide;
    res := RunQuery(q);
    if res <> RESULT_VALID then 
    begin
       ShowMessage(res);
       QueryListBoxRefresh;
       gj2main.show;
    end
    else
       gj2main.close;
  end;
end;

procedure QueryListBoxOnKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
    if (Key = 13) then //enter
    begin
      QueryListBoxOnDblClick(Sender);
    end;
end; 

procedure QueryButtonEditOnClick(Sender :TObject);
var
  res: String;
begin
    gj2main.hide;
    SetDefaults;
    res := LoadQueryAndShow(GetQueryFile(gj2main_QueryListBox.Items[gj2main_QueryListBox.ItemIndex]));
    if res <> RESULT_DOWNLOADED then 
    begin
       if res <> '' then ShowMessage(res);
       QueryListBoxRefresh;
       gj2main.show;
    end
    else
       gj2main.close;
end;

procedure MainBatchButtonAddOnClick(Sender :TObject);
begin
    gj2main.hide;
    GeoJarrybatchSetDefaults;
    GeoJarrybatchShow;
    BatchListBoxRefresh; 
    gj2main.show;
end;

procedure BatchButtonEditOnClick(Sender :TObject);
var
    res : String;
begin
    gj2main.hide;
    GeoJarrybatchSetDefaults;
    res := GeoJarrybatchLoadAndShow(GetBatchFile(gj2main_BatchListBox.Items[gj2main_BatchListBox.ItemIndex]));
    BatchListBoxRefresh; 
    gj2main.show;
end;

procedure BatchButtonDeleteOnClick(Sender :TObject);
var
    name, file, res,s : String;
begin
    name := gj2main_BatchListBox.Items[gj2main_BatchListBox.ItemIndex]; 
    res := BatchSafeToDelete(name);
    if (res = RESULT_VALID) then
    begin
      s := _('Do you really want to delete batch %NAME%?');
      s := ReplaceString(s,'%NAME%',name);
      if (MessBox(s, _('Delete batch'),4) = 6) then 
      begin
          file := GetBatchFile(name);
          DeleteFile(file);
          BatchListBoxRefresh;
      end;
    end else ShowMessage(res);
end;

procedure QueryButtonDeleteOnClick(Sender :TObject);
var
    name, file, res,s : String;
begin
    name := gj2main_QueryListBox.Items[gj2main_QueryListBox.ItemIndex]; 
    res := QuerySafeToDelete(name);
    if (res = RESULT_VALID) then
    begin
      s := _('Do you really want to delete query %NAME%?');
      s := ReplaceString(s,'%NAME%',name);
      if (MessBox(s, _('Delete query'),4) = 6) then 
      begin
          file := GetQueryFile(name);
          DeleteFile(file);
          QueryListBoxRefresh;
      end;
    end else ShowMessage(res);
end;

procedure AllButtonGeoJarrydbQueryOnClick(Sender :TObject);
var
  res: String;
begin
    gj2main.hide;
    GeoJarrydbSetDefaults;
    res := GeoJarrydbShow;
    if res <> RESULT_DOWNLOADED then 
    begin
       QueryListBoxRefresh;
       gj2main.show;
    end
    else
       gj2main.close;
end;

procedure AllButtonGeoJarrywmQueryOnClick(Sender : TObject);
var
  res: String;
begin
    gj2main.hide;
    GeoJarrywmSetDefaults;
    res := GeoJarrywmShow;
    if res <> RESULT_DOWNLOADED then 
    begin
       QueryListBoxRefresh;
       gj2main.show;
    end
    else
       gj2main.close;
end;

procedure AllButtonGeoJarrywebQueryOnClick(Sender :TObject);
var
  res: String;
begin
    gj2main.hide;
    GeoJarrywebSetDefaults;
    res := GeoJarrywebShow;
    if res <> RESULT_DOWNLOADED then 
    begin
       QueryListBoxRefresh;
       gj2main.show;
    end
    else
       gj2main.close;
end;

procedure AllPageControlOnChange(Sender : TObject);
begin
   case gj2main_AllPageControl.TabIndex of
     0: BatchListBoxRefresh;
     1: QueryListBoxRefresh;
   end;
end;

procedure AllButtonSettingsOnClick(Sender : TObject);
begin
   GeoJarrysettingsShow;
   QueryListBoxRefresh; BatchListBoxRefresh;
end;

procedure QueryButtonPluginOnClick(Sender: TObject);
var
  file : String;
begin
  if (gj2main_QueryListBox.ItemIndex <> -1) then
  begin 
    file := GetQueryFile(gj2main_QueryListBox.Items[gj2main_QueryListBox.ItemIndex]);
    GeoJarrypluginShow(file);
    QueryListBoxRefresh;
  end;
end;    

procedure BatchButtonPluginOnClick(Sender: TObject);
begin
  if (gj2main_BatchListBox.ItemIndex <> -1) then
  begin 
    GeoJarrypluginShow(GetBatchFile(gj2main_BatchListBox.Items[gj2main_BatchListBox.ItemIndex]));
    BatchListBoxRefresh;
  end;
end;

procedure AllLabelWarning3OnClick(Sender: TObject);
begin
  RunShell('http://www.waymarking.com/guidelines/termsofuse.aspx');
  RunShell('http://www.geocaching.com/about/termsofuse.aspx');
end;

procedure GeoJarrymainSetActions;
begin
   gj2main.Caption := _('GeoJarry %VERSION% - universal geocache and waymark downloading tool');
   gj2main.Caption := ReplaceString(gj2main.Caption,'%VERSION%',GEOJARRY_VERSION);
   gj2main_AllButtonGeoJarrywebQuery.OnClick := @AllButtonGeoJarrywebQueryOnClick;
   gj2main_AllButtonGeoJarrywmQuery.OnClick := @AllButtonGeoJarrywmQueryOnClick;
   gj2main_AllButtonGeoJarrydbQuery.OnClick := @AllButtonGeoJarrydbQueryOnClick;
      
   gj2main_AllButtonSettings.OnClick := @AllButtonSettingsOnClick;
   gj2main_AllPageControl.OnChange := @AllPageControlOnChange;
   gj2main_AllLabelWarning3.OnClick := @AllLabelWarning3OnClick;
   
   gj2main_BatchListBox.OnClick := @BatchListBoxOnClick;
   gj2main_BatchListBox.OnDblClick := @BatchListBoxOnDblClick;
   gj2main_BatchListBox.OnKeyDown := @BatchListBoxOnKeyDown;
   gj2main_BatchButtonAdd.OnClick := @MainBatchButtonAddOnClick;
   gj2main_BatchButtonDelete.OnClick := @BatchButtonDeleteOnClick;
   gj2main_BatchButtonEdit.OnClick := @BatchButtonEditOnClick;
   gj2main_BatchButtonRun.OnClick := @BatchListBoxOnDblClick;
   gj2main_BatchButtonPlugin.OnClick := @BatchButtonPluginOnClick;
   
   gj2main_QueryListBox.OnClick := @QueryListBoxOnClick;
   gj2main_QueryListBox.OnDblClick := @QueryListBoxOnDblClick;
   gj2main_QueryListBox.OnKeyDown := @QueryListBoxOnKeyDown;
   gj2main_QueryButtonAddWeb.OnClick := @AllButtonGeoJarrywebQueryOnClick;
   gj2main_QueryButtonAddWmWeb.OnClick := @AllButtonGeoJarrywmQueryOnClick;
   gj2main_QueryButtonAddDb.OnClick := @AllButtonGeoJarrydbQueryOnClick;
   gj2main_QueryButtonDelete.OnClick := @QueryButtonDeleteOnClick;
   gj2main_QueryButtonEdit.OnClick := @QueryButtonEditOnClick;
   gj2main_QueryButtonRun.OnClick := @QueryListBoxOnDblClick;
   gj2main_QueryButtonPlugin.OnClick := @QueryButtonPluginOnClick;
   
   BatchListBoxRefresh;
   QueryListBoxRefresh;
end;
