procedure GeoJarrysettingsUserComboBoxCountryOnChange(Sender :TObject);
begin
       gj2settings_UserComboBoxState.enabled := false;
       gj2settings_UserSButtonState.visible := false;
       if gj2settings_UserComboBoxCountry.ItemIndex <> -1 then
       begin
         GetStateList(gj2settings_UserComboBoxCountry.Text, gj2settings_UserComboBoxState.Items);
         if gj2settings_UserComboBoxState.Items.Count > 1 then gj2settings_UserComboBoxState.enabled := true;
       end;
end;

procedure GeoJarrysettingsUserComboBoxStateOnChange(Sender :TObject);
begin
       gj2settings_UserSButtonState.visible := gj2settings_UserComboBoxState.Text <> '';
end;

procedure GeoJarrysettingsUserSButtonStateOnClick(Sender :Tobject);
begin
    gj2settings_UserSButtonState.visible := false;
    gj2settings_UserComboBoxState.ItemIndex := -1;
end;

{Load settings from variables to form}
procedure GeoJarrysettingsLoad;
begin
   gj2settings_UserEditUsername.Text := gUsername;
   gj2settings_UserEditPassword.Text := gPassword;
   gj2settings_UserComboBoxCountry.ItemIndex := gj2settings_UserComboBoxCountry.Items.IndexOf(gHomeCountryName);
   GeoJarrysettingsUserComboBoxCountryOnChange(nil);
   gj2settings_UserComboBoxState.ItemIndex := gj2settings_UserComboBoxState.Items.IndexOf(gHomeStateName);
   GeoJarrysettingsUserComboBoxStateOnChange(nil);
   
   gj2settings_AdvancedCheckBoxWarning.Checked := (StringBoolToBool(gWarning));
   gj2settings_AdvancedCheckBoxLog.Checked := (StringBoolToBool(gLog));
   gj2settings_AdvancedComboBoxDefaultTab.ItemIndex := StrToInt(gDefaultTab);
   gj2settings_AdvancedComboBoxUnits.ItemIndex := gj2settings_AdvancedComboBoxUnits.Items.IndexOf(gDistanceUnit);
   gj2settings_AdvancedComboBoxDelay.ItemIndex := gj2settings_AdvancedComboBoxDelay.Items.IndexOf(gDelay);
   gj2settings_AdvancedComboBoxLog.ItemIndex := gj2settings_AdvancedComboBoxLog.Items.IndexOf(gLogMaxsize);
end;

{Save settings from form to variables}
procedure GeoJarrysettingsSave;
begin
   gUsername := gj2settings_UserEditUsername.Text;
   gPassword := gj2settings_UserEditPassword.Text;
   gHomeCountryName := gj2settings_UserComboBoxCountry.Text;
   gHomeStateName := gj2settings_UserComboBoxState.Text;      
   
   gWarning := BoolToStringBool(gj2settings_AdvancedCheckBoxWarning.Checked);
   SetWarning(StringBoolToBool(gWarning));
   
   gLog := BoolToStringBool(gj2settings_AdvancedCheckBoxLog.Checked);
   gj2settings_AdvancedComboBoxLog.Enabled := StringBoolToBool(gLog);
   
   if gj2settings_AdvancedComboBoxDefaultTab.ItemIndex <> -1 
     then gDefaultTab := IntToStr(gj2settings_AdvancedComboBoxDefaultTab.ItemIndex);
     
   if gj2settings_AdvancedComboBoxUnits.ItemIndex <> -1 
     then gDistanceUnit := gj2settings_AdvancedComboBoxUnits.Text;
     
   if gj2settings_AdvancedComboBoxDelay.ItemIndex <> -1 
     then gDelay := gj2settings_AdvancedComboBoxDelay.Text;
     
   if gj2settings_AdvancedComboBoxLog.ItemIndex <> -1 
     then gLogMaxsize := gj2settings_AdvancedComboBoxLog.Text;
end;

procedure GeoJarrysettingsSetDefaults;
begin     
   gj2settings_PageControl.TabIndex := 0;
   gj2settings_UserComboBoxCountry.ItemIndex := -1;
   gj2settings_UserComboBoxState.ItemIndex := -1;
   gj2settings_UserComboBoxState.enabled := false;
   gj2settings_UserSButtonState.Visible := false;
   gj2settings_AdvancedComboBoxLog.enabled := false;
end;

procedure GeoJarrysettingsButtonSaveOnClick(Sender: TObject);
begin
  If ((gj2settings_UserEditUsername.Text <> '') and (gj2settings_UserEditPassword.Text <> ''))
    then gj2settings.ModalResult := 1
    else ShowMessage(_('You must enter username and password.'));
end;

procedure GeoJarrysettingsEnter(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
    if (Key = 13) then //Enter
    begin
      Key := 0;
      GeoJarrysettingsButtonSaveOnClick(Sender);
    end;
end;

procedure GeoJarrysettingsAdvancedCheckBoxWarningOnClick(Sender: TObject);
begin
   if not gj2settings_AdvancedCheckBoxWarning.Checked 
      then if (MessBox(_('Groundspeak Inc. might consider use of this program to be against the Terms of Use. GeoJarry is not intended to use for downloading large amounts of data. Always keep in mind that excessive usage will lead to banning or deleting of your Groundspeak account.' + CRLF + CRLF + 'Are you aware of all the risks and possible consequences?'), _('Warning'),4) <> 6) 
        then gj2settings_AdvancedCheckBoxWarning.Checked := true; 
end;

procedure GeojarrysettingsUserLabelMembershipOnClick(Sender: TObject);
begin
    RunShell('http://www.geocaching.com/Membership/default.aspx');
end;

procedure GeoJarrysettingsAdvancedCheckBoxLogOnClick(Sender: TObject);
begin
    gj2settings_AdvancedComboBoxLog.Enabled := gj2settings_AdvancedCheckBoxLog.Checked; 
end;

procedure GeoJarrysettingsSetActions;
begin
   gj2settings.Caption := _('GeoJarry %VERSION% - settings');
   gj2settings.Caption := ReplaceString(gj2settings.Caption,'%VERSION%',GEOJARRY_VERSION);
   
   GetCountryList(gj2settings_UserComboBoxCountry.Items);

   gj2settings_ButtonSave.OnClick := @GeoJarrysettingsButtonSaveOnClick;
   gj2settings_UserLabelMembership.OnClick := @GeojarrysettingsUserLabelMembershipOnClick;
   gj2settings_UserComboBoxCountry.OnChange := @GeoJarrysettingsUserComboBoxCountryOnChange;
   gj2settings_UserComboBoxState.OnChange := @GeoJarrysettingsUserComboBoxStateOnChange;
   gj2settings_UserSButtonState.OnClick := @GeoJarrysettingsUserSButtonStateOnClick;
   gj2settings_AdvancedCheckBoxWarning.OnClick := @GeoJarrysettingsAdvancedCheckBoxWarningOnClick;
   gj2settings_AdvancedCheckBoxLog.OnClick := @GeoJarrysettingsAdvancedCheckBoxLogOnClick;
   gj2settings_UserEditPassword.OnKeyDown := @GeoJarrysettingsEnter;
   gj2settings_UserEditUsername.OnKeyDown := @GeoJarrysettingsEnter;
end;

procedure GeoJarrysettingsShow;
var
  res : String;
begin
   GeoJarrysettingsSetDefaults;
   GeoJarrysettingsLoad;
   
   if (gj2settings.showmodal = 1) then //commited
     begin
        GeoJarrysettingsSave; //save to variables
        res := SettingsWrite; //write to config file
        if res <> RESULT_VALID then ShowMessage(res);
     end;
end;