{Fetch geocache codes from form}
function GetCodeList : TStringList;
var
    s,p : String;
begin
    Result := TStringList.Create;
    Result.sorted := true;
    Result.duplicates := dupIgnore;
    s := gj2web_CodeMemoCode.Text;
    while length(s) > 0 do
    begin
        p := ReplaceString(UpperCase(Fetch(s, ';')),CRLF,'');
        if p <> '' then Result.Add(p);
    end;
end; 

function GeoJarrywebCodeValidate : String;
var
    s : String;
begin
    Result := '';
    s := gj2web_CodeMemoCode.Text;
    if s = '' 
       then Result := Result + _('You have to enter a GC code. (No "Cache codes" found)') + CRLF
       else Result := GcCodeListValidate(GetCodeList);
end;

function GeoJarrywebCodeLoadSettings(file: String) : String;
var
  iniF: TIniFile;
begin
  Result := '';
  if FileExists(file) then
  begin
    iniF := TIniFile.Create(file);
    try
      gj2web_CodeMemoCode.Text   := UnwrapCRLF(iniF.readString('Query', 'Codes', ''));
      Result := GeoJarrywebCodeValidate;
    finally
      iniF.Free;
    end;
  end;
end;

function GeoJarrywebCodeSaveSettings(file: String) : String;
var
  iniF: TIniFile;
begin
  Result := GeoJarrywebCodeValidate;
  if Result = RESULT_VALID then
  begin
    iniF := TIniFile.Create(file);
    try
      GeoJarrywebAllSaveQuery(file);
      iniF.writeString('Query', 'Codes', WrapCRLF(gj2web_CodeMemoCode.Text));
      Result := RESULT_VALID;
    finally
      iniF.Free;
    end;
  end;
end;

{Get stringlist of geocache codes}
function GeoJarrywebCodeGetCacheList(var list: TStringList) : String;
begin
  list := GetCodeList;
  Result := GcCodeListValidate(list);
end;

{Download geocaches}
function GeoJarrywebCodeDownload : String;
var
  list : TStringList;
begin
  list := TStringList.Create;
  try
    Result := GeoJarrywebCodeGetCacheList(list);
    if Result = RESULT_VALID then Result := DownloadWaypointListings(list, true);
  finally
    list.free;
  end;
end;

function GeoJarrywebCodeGetInfo : String;
begin
    Result := _('This query will search Geocaching.com webpage for geocaches specified by the code(s).') + ' ';
end;

procedure GeoJarrywebCodeSetDefaults;
begin
     gj2web_CodeMemoCode.Text := '';
end;

procedure CodeMemoCodeOnExit(sender : TObject);
begin
    gj2web_CodeMemoCode.Text := UpperCase(gj2web_CodeMemoCode.Text);
end;

procedure GeoJarrywebCodeSetActions;
begin
    gj2web_CodeMemoCode.onExit := @CodeMemoCodeOnExit;
end; 