var
   GjLat, GjLon : Extended; //latitude and longitude
   
{Save coordinates into form}  
procedure SaveCoordinates;
begin
   if ((GjLat <> 0) or (GjLon <> 0)) 
   then 
     begin
        gj2web_CoordLabelCoord.Caption := FormatCoordNum(GjLat, GjLon);
        gj2web_CoordSButtonShowMap.Visible := true;
        gj2web_CoordSButtonSaveReference.Visible := true;
        gj2web_CoordSButtonRemoveCoordinates.Visible := true;
     end
   else 
     begin
        gj2web_CoordLabelCoord.Caption := _('No coordinates selected.'+ CRLF + 'GeoJarry will use current GeoGet reference point.');
        gj2web_CoordSButtonShowMap.Visible := false;
        gj2web_CoordSButtonSaveReference.Visible := false;
        gj2web_CoordSButtonRemoveCoordinates.Visible := false;
     end;
end;

procedure CoordButtonChangeOnClick(Sender :TObject);
begin
   if CoordEdit(_('Select coordinates'), _('Coordinates are used as the central point for your search'), GjLat, GjLon) then SaveCoordinates;
end;

procedure CoordSButtonShowMapOnClick(Sender :TObject);
var
   url : String;
begin
   begin
      url := ReplaceString(MAP_VIEW_URL,'$LATITUDE',FloatToStr(GjLat));
      url := ReplaceString(url,'$LONGITUDE',FloatToStr(GjLon));
      RunShell(url);
   end;
end;

procedure CoordSButtonSaveReferenceOnClick(Sender :TObject);
var
   names : TStringList;
   name : String;
begin
   names := TStringList.Create;
   try
    RefPointNames(names);
    if InputComboBox(_('Reference point'), _('Select a name for new reference point'), '',names,true,name) then RefPointSet(name, GjLat, GjLon);
   finally
    names.free;
   end;
end;

procedure CoordSButtonRemoveCoordinatesOnClick(Sender :TObject);
begin
   GjLat := 0; GjLon := 0;
   SaveCoordinates;   
end;

procedure CoordButtonGoogleSearchOnClick(Sender :Tobject);
begin
   if CoordSearch(GjLat, GjLon) then SaveCoordinates;
end;

procedure CoordButtonLoadRefOnClick(Sender :Tobject);
var
   names : TStringList;
   name : String;
begin
  names := TStringList.Create;
  try
    RefPointNames(names);
    if InputComboBox(_('Reference point'), _('Select reference point for your search'), names[0],names,false,name) and RefPointGet(name, GjLat, GjLon) then SaveCoordinates;
  finally
    names.free;
  end;
end;

procedure CoordRGroupOnClick(Sender :Tobject);
begin
  Case gj2web_CoordRGroup.ItemIndex of
 -1 : Begin
        gj2web_CoordEditNumber.Enabled := false;
        gj2web_CoordEditDistance.Enabled := false;
        gj2web_CoordComboBoxUnit.Enabled := false; 
      End;
  0 : Begin
        gj2web_CoordEditNumber.Enabled := false;
        gj2web_CoordEditDistance.Enabled := true;
        gj2web_CoordComboBoxUnit.Enabled := true;
      End;
  1 : Begin
        gj2web_CoordEditNumber.Enabled := true;
        gj2web_CoordEditDistance.Enabled := false;
        gj2web_CoordComboBoxUnit.Enabled := false;
      End;        
  Else ShowMessage(_('Problem in CoordRGroup.ItemIndex'));
  end; 
end;

procedure CoordEditDistanceOnExit(Sender: Tobject);
begin
    if (gj2web_CoordEditDistance.Text <> '') then
    if (not RegexFind('^0*[1-9]\d*$',gj2web_CoordEditDistance.Text)) then
    begin
      ShowMessage(_('You must enter only positive integers!'));
      gj2web_CoordEditDistance.setfocus;
    end; 
end;

procedure CoordEditNumberOnExit(Sender: Tobject);
begin
    if (gj2web_CoordEditNumber.Text <> '') then
    if (not RegexFind('^0*[1-9]\d*$',gj2web_CoordEditNumber.Text)) then
    begin
      ShowMessage(_('You must enter only positive integers!'));
      gj2web_CoordEditNumber.setfocus;
    end; 
end;

function GeoJarrywebCoordValidate : String;
var
  gjwebResult : String;
begin
  Result := '';
  if (gj2web_CoordRGroup.ItemIndex = -1) then Result := Result + _('You have to select when the downloading should stop. (Unknown "Stop the download when" option)') + CRLF;  
  if ((gj2web_CoordRGroup.ItemIndex = 0) And not ((gj2web_CoordEditDistance.Text <> '') And (RegexFind('^0*[1-9]\d*$',gj2web_CoordEditDistance.Text))))then Result := Result + _('You have to set the distance limit. (Unknown distance limit, has to be positive integer)') + CRLF; 
  if ((gj2web_CoordRGroup.ItemIndex = 0) And not (gj2web_CoordComboBoxUnit.Text <> '' )) then Result := Result + _('You have to select the units. (No "Units" selected)') + CRLF;
  if ((gj2web_CoordRGroup.ItemIndex = 1) And not ((gj2web_CoordEditNumber.Text <> '') And (RegexFind('^0*[1-9]\d*$',gj2web_CoordEditNumber.Text)))) then Result := Result + _('You have to set the maximum number of caches. (Unknown maximum number of caches, has to be positive integer)') + CRLF;
  
  gjwebResult := GeoJarrywebAllValidate;
  if gjwebResult <> RESULT_VALID then Result := Result + gjwebResult;
  if Result <> '' Then 
      Result := Result + RESULT_INVALID 
  else Result := RESULT_VALID;
end;

function GeoJarrywebCoordLoadSettings(file: String) : String;
var
  iniF: TIniFile;
begin
  Result := GeoJarrywebAllLoadDownloadSettings(file)
  if FileExists(file) and (Result = RESULT_VALID) then
  begin
    iniF := TIniFile.Create(file);
    try
      GjLat                                    := iniF.readFloat('Query', 'Latitude', 0);
      GjLon                                    := iniF.readFloat('Query', 'Longitude', 0);
      gj2web_CoordRGroup.ItemIndex        := iniF.readInteger('Query', 'Quantity', DEFAULT_RGROUP);
      gj2web_CoordEditDistance.Text       := iniF.readString('Query', 'Distance', '');
      gj2web_CoordEditNumber.Text         := iniF.readString('Query', 'CacheCount', '');
      gj2web_CoordComboBoxUnit.ItemIndex  := gj2web_CoordComboBoxUnit.Items.indexOf(iniF.readString('Query', 'DistanceUnit', gDistanceUnit));
      
      Result := GeoJarrywebCoordValidate;
      if Result = RESULT_VALID then SaveCoordinates;
    finally
      iniF.Free;
    end;
  end;
end;

function GeoJarrywebCoordSaveSettings(file: String) : String;
var
  iniF: TIniFile;
begin
  Result := GeoJarrywebCoordValidate;
  if Result = RESULT_VALID then
  begin
    iniF := TIniFile.Create(file);
    try
      GeoJarrywebAllSaveQuery(file);
      if Gjlat <> 0 then iniF.writeFloat('Query', 'Latitude', GjLat);
      if Gjlon <> 0 then iniF.writeFloat('Query', 'Longitude', GjLon);
      iniF.writeInteger('Query', 'Quantity', gj2web_CoordRGroup.ItemIndex);
      if gj2web_CoordRGroup.ItemIndex = 0 then 
      begin
        iniF.writeString('Query', 'Distance', gj2web_CoordEditDistance.Text);
        iniF.writeString('Query', 'DistanceUnit', gj2web_CoordComboBoxUnit.Text);
      end;
      if gj2web_CoordRGroup.ItemIndex = 1 then iniF.writeString('Query', 'CacheCount', gj2web_CoordEditNumber.Text);     
      
      Result := GeoJarrywebAllSaveDownloadSettings(file);
    finally
      iniF.Free;
    end;
  end;
end;

procedure GeoJarrywebCoordPrepareIniFile;
var
  IniBody, IniFile : String;
begin
  IniFile := GetIniFile;
  IniBody := GetIniHeader;
  if (gj2web_CoordRGroup.ItemIndex = 1) then IniBody := IniBody + 'maxcount=' + GetNumOfPages(gj2web_CoordEditNumber.Text, PERPAGE_CACHES) + CRLF;
  StringToFile(IniBody, IniFile);
end;

function GeoJarrywebCoordPrepareCommand(subcommand : String) : String;
var
  ctype,lat,lon,dist : String;
begin
  Result := '"' + GetGeoJarryExe + '" "' + GetIniFile + '"';
  
  if ((GjLat = 0) And (GjLon = 0)) 
    then begin lat := GEOGET_RefX; lon := GEOGET_RefY; end
    else begin lat := FloatToStr(GjLat); lon := FloatToStr(GjLon); end;
  Result := Result + ' '+ subcommand + ' "lat=' + lat + '&lon=' + lon;  
  
  if (gj2web_AllRGroupFound.ItemIndex = 1) then Result := Result + '&f=1';
  ctype := CacheTypeToUID(gj2web_AllComboBoxType.Text);
  
  if (ctype <> RESULT_INVALID) then Result := Result + '&tx=' + ctype;
  
  if (gj2web_CoordRGroup.ItemIndex = 0) then
  begin
    case gj2web_CoordComboBoxUnit.Text of
    'km': begin dist := fltostr(StrToInt(gj2web_CoordEditDistance.Text)/MILE); end;
    'mi': begin dist := fltostr(StrToInt(gj2web_CoordEditDistance.Text)); end;
    else ShowMessage(_('Could not determine distance unit!'));
    end;
    if dist <> '' then Result := Result + '&dist=' + dist;
  end;
 
  Result := Result + '"';
end;

{Get stringlist of geocache codes}
function GeoJarrywebCoordGetCacheList(var list: TStringList) : String;
var
  cachecount : Integer;
begin
    //IniFile
    GeoJarrywebCoordPrepareIniFile;
    
    //Download whole list
    Result := GeoJarryResultToString(GeoJarryRunExec(GeoJarrywebCoordPrepareCommand('gclist')));
    
    //Load list from file and cut number of caches 
    if (gj2web_CoordRGroup.ItemIndex = 1) then cachecount := StrToInt(gj2web_CoordEditNumber.Text) else cachecount := -1;
    if Result = RESULT_VALID then list := GetDownloadedList(GetDownloadedGcListFile,cachecount);
end;

{Download geocaches }
function GeoJarrywebCoordDownload : String;
var
  list : TStringList;
begin
  Result := '';
  GeoJarrywebCoordPrepareIniFile;
  list := TStringList.Create;
  try
   Result := GeoJarrywebCoordGetCacheList(list);
   if Result = RESULT_VALID then Result := DownloadWaypointListings(list, false); //download now
  finally
   list.Free;
  end;
end;

function GeoJarrywebCoordGetInfo : String;
var
    s : String;
begin
    if ((GjLat = 0) and (GjLon = 0)) 
      then s := _('current reference point')
      else s := _('coordinates') + ' ' + FormatCoordNum(GjLat, GjLon);
    Result := _('This query will search Geocaching.com webpage for geocaches around') + ' ' + s + ' ';
    if (gj2web_CoordRGroup.ItemIndex = 0) 
      then s := '(' + _('max distance') + ': ' + gj2web_CoordEditDistance.Text + gj2web_CoordComboBoxUnit.Text + ')'
      else if (gj2web_CoordRGroup.ItemIndex = 1) then s := '(' + gj2web_CoordEditNumber.Text + ' ' + _('closest');
    Result := Result + s + '. ';
end;

procedure GeoJarrywebCoordSetDefaults;
begin
     GjLat := 0;
     GjLon := 0;
     gj2web_CoordLabelCoord.Caption := _('No coordinates selected.'+ CRLF + 'GeoJarry will use current GeoGet reference point.');
     gj2web_CoordSButtonShowMap.Visible := false;
     gj2web_CoordSButtonSaveReference.Visible := false;
     gj2web_CoordSButtonRemoveCoordinates.Visible := false;

     gj2web_CoordComboBoxUnit.ItemIndex := gj2web_CoordComboBoxUnit.Items.indexOf(gDistanceUnit);      
     gj2web_CoordComboBoxUnit.Enabled := true; 
     gj2web_CoordEditNumber.Text := '';
     gj2web_CoordEditDistance.Text := '10';
     gj2web_CoordEditDistance.Enabled := true;
     gj2web_CoordRGroup.ItemIndex := 0;
end;

procedure GeoJarrywebCoordSetActions;
begin
  gj2web_CoordButtonChange.OnClick := @CoordButtonChangeOnClick;
  gj2web_CoordSButtonShowMap.OnClick := @CoordSButtonShowMapOnClick;
  gj2web_CoordSButtonSaveReference.OnClick := @CoordSButtonSaveReferenceOnClick;
  gj2web_CoordSButtonRemoveCoordinates.OnClick := @CoordSButtonRemoveCoordinatesOnClick;
  gj2web_CoordButtonGoogleSearch.OnClick := @CoordButtonGoogleSearchOnClick;
  gj2web_CoordButtonLoadRef.onClick := @CoordButtonLoadRefOnClick;
  gj2web_CoordRGroup.onClick := @CoordRGroupOnClick;
  gj2web_CoordEditDistance.onExit := @CoordEditDistanceOnExit;
  gj2web_CoordEditNumber.onExit := @CoordEditNumberOnExit;
end;
