procedure CountryComboBoxCountryOnChange(Sender :TObject);
begin
       gj2web_CountryComboBoxState.enabled := false;
       gj2web_CountrySButtonState.visible := false;
       gj2web_CountrySButtonCountry.visible := false;
       if gj2web_CountryComboBoxCountry.ItemIndex <> -1 then
       begin
         gj2web_CountrySButtonCountry.visible := true;
         GetStateList(gj2web_CountryComboBoxCountry.Text, gj2web_CountryComboBoxState.Items);
         gj2web_CountryComboBoxState.enabled := (gj2web_CountryComboBoxState.Items.Count > 1);
       end;
end;

procedure CountryComboBoxStateOnChange(Sender :TObject);
begin
    gj2web_CountrySButtonState.visible := (gj2web_CountryComboBoxState.Text <> '');
end;

procedure CountrySButtonStateOnClick(Sender :Tobject);
begin
    gj2web_CountrySButtonState.visible := false;
    gj2web_CountryComboBoxState.ItemIndex := -1;
end;

procedure CountrySButtonCountryOnClick(Sender :Tobject);
begin
    gj2web_CountrySButtonCountry.visible := false;
    gj2web_CountryComboBoxCountry.ItemIndex := -1;
    
    CountrySButtonStateOnClick(Sender);
    CountryComboBoxCountryOnChange(Sender);
end;

procedure CountryRGroupOnClick(Sender :Tobject);
begin
  Case gj2web_CountryRGroup.ItemIndex of
  0 : gj2web_CountryEditNumber.Enabled := false;
  1 : gj2web_CountryEditNumber.Enabled := true;
  Else ShowMessage(_('Problem in CountryRGroup.ItemIndex'));
  end; 
end;

procedure CountryEditNumberOnExit(Sender: Tobject);
begin
    if (gj2web_CountryEditNumber.Text <> '') then
    if (not RegexFind('^0*[1-9]\d*$',gj2web_CountryEditNumber.Text)) then
    begin
      ShowMessage(_('You must enter only positive integers!'));
      gj2web_CountryEditNumber.setfocus;
    end; 
end;

function GeoJarrywebCountryValidate : String;
var
  gjwebResult : String;
begin
  Result := '';
  if (gj2web_CountryRGroup.ItemIndex = -1) then Result := Result + _('You have to select when the downloading should stop. (Unknown "Download" option)') + CRLF;  
  if ((gj2web_CountryRGroup.ItemIndex = 1) And not ((gj2web_CountryEditNumber.Text <> '') And (RegexFind('^0*[1-9]\d*$',gj2web_CountryEditNumber.Text)))) then Result := Result + _('You have to set the maximum number of newest caches. (Unknown maximum number of caches, has to be positive integer)') + CRLF;
    
  gjwebResult := GeoJarrywebAllValidate;
  if gjwebResult <> RESULT_VALID then Result := Result + gjwebResult;
   
  if Result <> '' Then 
      Result := Result + RESULT_INVALID 
  else Result := RESULT_VALID;
end;

function GeoJarrywebCountryLoadSettings(file: String) : String;
var
  iniF: TIniFile;
begin
  Result := GeoJarrywebAllLoadDownloadSettings(file);
  if FileExists(file) and (Result = RESULT_VALID) then
  begin
    iniF := TIniFile.Create(file);
    try
      gj2web_CountryComboBoxCountry.ItemIndex := gj2web_CountryComboBoxCountry.Items.IndexOf(iniF.readString('Query', 'CountryName', ''));
      CountryComboBoxCountryOnChange(nil);
      gj2web_CountryComboBoxState.ItemIndex := gj2web_CountryComboBoxState.Items.IndexOf(iniF.readString('Query', 'StateName', ''));
      CountryComboBoxStateOnChange(nil);
   
      gj2web_CountryRGroup.ItemIndex      := iniF.readInteger('Query', 'Quantity', DEFAULT_RGROUP);
      gj2web_CountryEditNumber.Text       := iniF.readString('Query', 'CacheCount', '');
       
      Result := GeoJarrywebCountryValidate;
    finally
      iniF.Free;
    end;
  end;
end;

function GeoJarrywebCountrySaveSettings(file: String) : String;
var
  iniF: TIniFile;
begin
  Result := GeoJarrywebCountryValidate;
  if Result = RESULT_VALID then
  begin
    iniF := TIniFile.Create(file);
    try
       GeoJarrywebAllSaveQuery(file);
       if gj2web_CountryComboBoxCountry.Text <> '' then iniF.writeString('Query', 'CountryName', gj2web_CountryComboBoxCountry.Text);
       if gj2web_CountryComboBoxState.Text <> '' then iniF.writeString('Query', 'StateName', gj2web_CountryComboBoxState.Text);
       iniF.writeInteger('Query', 'Quantity', gj2web_CountryRGroup.ItemIndex);
       if gj2web_CountryRGroup.ItemIndex = 1 then iniF.writeString('Query', 'CacheCount', gj2web_CountryEditNumber.Text);
      
       Result := GeoJarrywebAllSaveDownloadSettings(file);
    finally
      iniF.Free;
    end;
  end;
end;

procedure GeoJarrywebCountryDetermineCountryAndState(var cid, sid : String);
var
  c,s : String;
begin
  c := gj2web_CountryComboBoxCountry.Text;
  s := gj2web_CountryComboBoxState.Text;
  if (c = '') and (s = '') then //no area set - using home area
  begin
      c := gHomeCountryName;
      s := gHomeStateName;
      if (c = '') then ShowMessage(_('Could not determine country. Go to GeoJarry settings and check your HomeArea options.'));
  end;
  
  cid := TranslateCountryID(c);
  sid := TranslateStateID(c,s);
end;

procedure GeoJarrywebCountryPrepareIniFile;
var
  IniBody, IniFile, cid, sid : String;
begin
  GeoJarrywebCountryDetermineCountryAndState(cid, sid);

  IniFile := GetIniFile;
  IniBody := GetIniHeader;
  IniBody := IniBody + 'countryid=' + cid + CRLF;
  IniBody := IniBody + 'stateid=' + sid + CRLF;
  if (gj2web_CountryRGroup.ItemIndex = 1) then IniBody := IniBody + 'maxcount=' + GetNumOfPages(gj2web_CountryEditNumber.Text, PERPAGE_CACHES) + CRLF;
  StringToFile(IniBody, IniFile);
end;

function GeoJarrywebCountryPrepareCommand(subcommand : String) : String;
var
  ctype,cid,sid : String;
begin
  GeoJarrywebCountryDetermineCountryAndState(cid, sid);

  Result := '"' + GetGeoJarryExe + '" "' + GetIniFile + '"';
  Result := Result + ' '+ subcommand + ' "country_id=' + cid;
  if ((sid <> '') and (sid <> '-1')) then Result := Result + '&state_id=' + sid;  
  if (gj2web_AllRGroupFound.ItemIndex = 1) then Result := Result + '&f=1';
  ctype := CacheTypeToUID(gj2web_AllComboBoxType.Text);
  if (ctype <> RESULT_INVALID) then Result := Result + '&tx=' + ctype;
  Result := Result + '"'; 
end;

{Get stringlist of geocache codes}
function GeoJarrywebCountryGetCacheList(var list: TStringList) : String;
var
  cachecount : Integer;
begin
    //IniFile
    GeoJarrywebCountryPrepareIniFile;
    
    //Download whole list
    Result := GeoJarryResultToString(GeoJarryRunExec(GeoJarrywebCountryPrepareCommand('gclist')));
    
    //Load list from file and cut number of caches 
    if (gj2web_CountryRGroup.ItemIndex = 1) then cachecount := StrToInt(gj2web_CountryEditNumber.Text) else cachecount := -1;
    if Result = RESULT_VALID then list := GetDownloadedList(GetDownloadedGcListFile,cachecount);
end;

{Download geocaches }
function GeoJarrywebCountryDownload : String;
var
  list : TStringList;
begin
  Result := '';
  GeoJarrywebCountryPrepareIniFile;
  list := TStringList.Create;
  try
    Result := GeoJarrywebCountryGetCacheList(list);
    if Result = RESULT_VALID then Result := DownloadWaypointListings(list, false); //download now
  finally
    list.Free;
  end;
end;

function GeoJarrywebCountryGetInfo : String;
var
    area,state,r : String;
begin
    if (gj2web_CountryComboBoxCountry.Text = '')  
      then begin area := gHomeCountryName; state := gHomeStateName; end//home area
      else begin area := gj2web_CountryComboBoxCountry.Text; state := gj2web_CountryComboBoxState.Text; end;
    if state <> '' then area := area + ' - ' + state;
    Result := _('This query will search Geocaching.com webpage for geocaches in %AREA%.');
    Result := ReplaceString(Result,'%AREA%',area) + ' ';
    if (gj2web_CountryRGroup.ItemIndex = 1) then 
    begin
      r := _('Only %CACHES% newest geocaches will be downloaded.');
      r := ReplaceString(r,'%CACHES%',gj2web_CountryEditNumber.Text); 
      Result := Result + r + ' ';
    end;
end;

procedure GeoJarrywebCountrySetDefaults;
begin
     gj2web_CountryComboBoxState.ItemIndex := -1;
     gj2web_CountryComboBoxState.enabled := false;
     gj2web_CountrySButtonCountry.Visible := false;
     gj2web_CountrySButtonState.Visible := false;
     gj2web_CountryRGroup.ItemIndex := 0;
     gj2web_CountryEditNumber.Text := '';
end;

procedure GeoJarrywebCountrySetActions;
begin
  GetCountryList(gj2web_CountryComboBoxCountry.Items);
  gj2web_CountryComboBoxCountry.onChange := @CountryComboBoxCountryOnChange;
  gj2web_CountryComboBoxState.onChange := @CountryComboBoxStateOnChange;
  gj2web_CountrySButtonState.onClick := @CountrySButtonStateOnClick;
  gj2web_CountrySButtonCountry.onClick := @CountrySButtonCountryOnClick;
  
  gj2web_CountryRGroup.onClick := @CountryRGroupOnClick;
  gj2web_CountryEditNumber.onExit := @CountryEditNumberOnExit;

end;
