function GeoJarrywebNameValidate : String;
var
  gjwebResult : String;
begin
  Result := '';
  if (gj2web_NameEditKeyword.Text = '') then Result := Result + _('You have to enter a keyword. (No "Name" specified)') + CRLF;
  
  gjwebResult := GeoJarrywebAllValidate;
  if gjwebResult <> RESULT_VALID then Result := Result + gjwebResult;
   
  if Result <> '' Then 
      Result := Result + RESULT_INVALID 
  else Result := RESULT_VALID;
end;

function GeoJarrywebNameLoadSettings(file: String) : String;
var
  iniF: TIniFile;
begin
  Result := GeoJarrywebAllLoadDownloadSettings(file);
  if FileExists(file) and (Result = RESULT_VALID) then
  begin
    iniF := TIniFile.Create(file);
    try
      gj2web_NameEditKeyword.Text   := iniF.readString('Query', 'Name', '');
      
      Result := GeoJarrywebNameValidate;
    finally
      iniF.Free;
    end;
  end;
end;

function GeoJarrywebNameSaveSettings(file: String) : String;
var
  iniF: TIniFile;
begin
  Result := GeoJarrywebNameValidate;
  if Result = RESULT_VALID then
  begin
    iniF := TIniFile.Create(file);
    try
      GeoJarrywebAllSaveQuery(file);
      iniF.writeString('Query', 'Name', gj2web_NameEditKeyword.Text);
      Result := GeoJarrywebAllSaveDownloadSettings(file);
    finally
      iniF.Free;
    end;
  end;
end;

procedure GeoJarrywebNamePrepareIniFile;
var
  IniBody, IniFile : String;
begin
  IniFile := GetIniFile;
  IniBody := GetIniHeader;
  StringToFile(IniBody, IniFile);
end;

function GeoJarrywebNamePrepareCommand(subcommand : String) : String;
var
  ctype : String;
begin
  Result := '"' + GetGeoJarryExe + '" "' + GetIniFile + '"';
  Result := Result + ' '+ subcommand + ' "key=' + EncodeUrlElement(AnsiToUtf(gj2web_NameEditKeyword.Text));
  if (gj2web_AllRGroupFound.ItemIndex = 1) then Result := Result + '&f=1';
  ctype := CacheTypeToUID(gj2web_AllComboBoxType.Text);
  if (ctype <> RESULT_INVALID) then Result := Result + '&tx=' + ctype;
  Result := Result + '"';
end;

{Get stringlist of geocache codes}
function GeoJarrywebNameGetCacheList(var list: TStringList) : String;
begin
    //IniFile
    GeoJarrywebNamePrepareIniFile;
    
    //Download whole list
    Result := GeoJarryResultToString(GeoJarryRunExec(GeoJarrywebNamePrepareCommand('gclist')));
    
    //Load list from file and cut number of caches 
    if Result = RESULT_VALID then list := GetDownloadedList(GetDownloadedGcListFile,-1);
end;

{Download geocaches }
function GeoJarrywebNameDownload : String;
var
  list : TStringList;
begin
  Result := '';
  GeoJarrywebNamePrepareIniFile;

  list := TStringList.Create;
  try
    Result := GeoJarrywebNameGetCacheList(list);
    if Result = RESULT_VALID then Result := DownloadWaypointListings(list, false);  //download now
  finally
    list.Free;
  end;
end;

function GeoJarrywebNameGetInfo : String;
begin
    Result := _('This query will search Geocaching.com webpage for geocaches containing "%KEYWORD%" in the name.');
    Result := ReplaceString(Result,'%KEYWORD%',gj2web_NameEditKeyword.Text) + ' ';
end;
  
procedure GeoJarrywebNameSetDefaults;
begin
     gj2web_NameEditKeyword.Text := '';
end;

procedure GeoJarrywebNameSetActions;
begin

end; 
