procedure UserRGroupQuantityOnClick(Sender :TObject);
begin
  Case gj2web_UserRGroupQuantity.ItemIndex of
  0 : gj2web_UserEditNumber.Enabled := false;
  1 : gj2web_UserEditNumber.Enabled := true;
  Else ShowMessage(_('Problem in UserRGroupQuantity.ItemIndex'));                                              
  end; 
end;

procedure UserEditUsernameOnChange(Sender :TObject);
var
  enabled: boolean;
begin
  enabled := ((gj2web_UserRGroupRelation.ItemIndex = 0) and ((gj2web_UserEditUsername.Text = gUsername) or (gj2web_UserEditUsername.Text = '')) and (gj2web_UserRGroupLogs.ItemIndex <> 1));
  gj2web_UserCheckBoxDates.Enabled := enabled;
  if not enabled then gj2web_UserCheckBoxDates.Checked := false;
end;

procedure UserEditNumberOnExit(Sender: Tobject);
begin
    if (gj2web_UserEditNumber.Text <> '') then
    if (not RegexFind('^0*[1-9]\d*$',gj2web_UserEditNumber.Text)) then
    begin
      ShowMessage(_('You must enter only positive integers!'));
      gj2web_UserEditNumber.setfocus;
    end; 
end;

function GeoJarrywebUserValidate : String;
var
  gjwebResult : String;
begin
  Result := '';
  if (gj2web_UserRGroupRelation.ItemIndex = -1) then Result := Result + _('You have to select the relation between username and geocaches. (Unknown "Relation" option)') + CRLF;  
  if (gj2web_UserRGroupQuantity.ItemIndex = -1) then Result := Result + _('You have to select when the downloading should stop. (Unknown "Download" option)') + CRLF;
  if ((gj2web_UserRGroupQuantity.ItemIndex = 1) And not ((gj2web_UserEditNumber.Text <> '') And (RegexFind('^0*[1-9]\d*$',gj2web_UserEditNumber.Text)))) then Result := Result + _('You have to set the maximum number of most recent caches. (Unknown maximum number of caches)') + CRLF;
  if (gj2web_UserRGroupLogs.ItemIndex = -1) then Result := Result + _('You have to select the number of logs to download. (Unknown "Download logs" option)') + CRLF;
  if ((gj2web_UserCheckBoxDates.Checked) and (((gj2web_UserEditUsername.Text <> gUsername) and (gj2web_UserEditUsername.Text <> '')) or (gj2web_UserRGroupRelation.ItemIndex <> 0) or (gj2web_UserRGroupLogs.ItemIndex = 1))) then Result := Result + _('Downloading dates of your found geocaches only makes sense if you are downloading your found geocaches without all logs. (Wrong "Download date of finds" option)') + CRLF; 
  if ((gj2web_AllRGroupFound.ItemIndex = 1) and ((gj2web_UserEditUsername.Text = gUsername) or (gj2web_UserEditUsername.Text = ''))) then Result := Result + _('Your query would not return any results. You are trying to filter out all your found/owned geocaches, but you are downloading your found/owned geocaches. (Wrong "Found or owned" option)') + CRLF;    
  
  gjwebResult := GeoJarrywebAllValidate;
  if gjwebResult <> RESULT_VALID then Result := Result + gjwebResult;
   
  if Result <> '' Then 
      Result := Result + RESULT_INVALID 
  else Result := RESULT_VALID;
end;

function GeoJarrywebUserLoadSettings(file: String) : String;
var
  iniF: TIniFile;
begin
  Result := GeoJarrywebAllLoadDownloadSettings(file);
  if FileExists(file) and (Result = RESULT_VALID) then
  begin
    iniF := TIniFile.Create(file);
    try
      gj2web_UserEditUsername.Text        := iniF.readString('Query', 'Username', '');
      gj2web_UserRGroupRelation.ItemIndex := iniF.readInteger('Query', 'Relation', DEFAULT_RGROUP);
      gj2web_UserRGroupQuantity.ItemIndex := iniF.readInteger('Query', 'Quantity', DEFAULT_RGROUP);
      gj2web_UserEditNumber.Text          := iniF.readString('Query', 'CacheCount', '');
      gj2web_UserRGroupLogs.ItemIndex     := iniF.readInteger('Query', 'LogCount', DEFAULT_RGROUP);
      gj2web_UserCheckBoxDates.Checked    := iniF.readBool('Query', 'DownloadDatesOfFinds', false);
                                         
      gj2web_UserCheckBoxDates.Enabled := ((gj2web_UserRGroupRelation.ItemIndex = 0) and ((gj2web_UserEditUsername.Text = gUsername) or (gj2web_UserEditUsername.Text = '')) and (gj2web_UserRGroupLogs.ItemIndex <> 1));
      
      Result := GeoJarrywebUserValidate;
    finally
      iniF.Free;
    end;
  end;
end;

function GeoJarrywebUserSaveSettings(file: String) : String;
var
  iniF: TIniFile;
begin
  Result := GeoJarrywebUserValidate;
  if Result = RESULT_VALID then
  begin
    iniF := TIniFile.Create(file);
    try
      GeoJarrywebAllSaveQuery(file);
      if (gj2web_UserEditUsername.Text <> '') then iniF.writeString('Query', 'Username', gj2web_UserEditUsername.Text);
      iniF.writeInteger('Query', 'Relation', gj2web_UserRGroupRelation.ItemIndex);
      iniF.writeInteger('Query', 'Quantity', gj2web_UserRGroupQuantity.ItemIndex);
      if gj2web_UserRGroupQuantity.ItemIndex = 1 then iniF.writeString('Query', 'CacheCount', gj2web_UserEditNumber.Text);
      iniF.writeInteger('Query', 'LogCount', gj2web_UserRGroupLogs.ItemIndex);      
      if (gj2web_UserCheckBoxDates.Checked) then iniF.writeBool('Query', 'DownloadDatesOfFinds', true);
      
      Result := GeoJarrywebAllSaveDownloadSettings(file);
    finally
      iniF.Free;
    end;
  end;
end;

procedure GeoJarrywebUserPrepareIniFile;
var
  IniBody, IniFile : String;
begin
  IniFile := GetIniFile;
  IniBody := GetIniHeader;
  if (gj2web_UserRGroupQuantity.ItemIndex = 1) then IniBody := IniBody + 'maxcount=' + GetNumOfPages(gj2web_UserEditNumber.Text, PERPAGE_CACHES) + CRLF;
  StringToFile(IniBody, IniFile);
end;

function GeoJarrywebUserPrepareCommand(subcommand : String) : String;
var
  name,relation,ctype : String;
begin
  Result := '"' + GetGeoJarryExe + '" "' + GetIniFile + '"';
  if gj2web_UserEditUsername.Text <> '' then name := gj2web_UserEditUsername.Text else name := gUsername;
  if (gj2web_UserRGroupRelation.ItemIndex = 0) then relation := 'ul=' else if (gj2web_UserRGroupRelation.ItemIndex = 1) then relation := 'u=' else begin Result := ''; Exit; End; 
  Result := Result + ' '+ subcommand +' "' + relation + EncodeUrlElement(AnsiToUtf(name));
  if (gj2web_AllRGroupFound.ItemIndex = 1) then Result := Result + '&f=1';
  ctype := CacheTypeToUID(gj2web_AllComboBoxType.Text);
  if (ctype <> RESULT_INVALID) then Result := Result + '&tx=' + ctype;
  Result := Result + '"';
end;

{Get stringlist of geocache codes}
function GeoJarrywebUserGetCacheList(var list: TStringList) : String;
var
  cachecount : Integer;
begin
    //IniFile
    GeoJarrywebUserPrepareIniFile;
    
    //Download whole list
    Result := GeoJarryResultToString(GeoJarryRunExec(GeoJarrywebUserPrepareCommand('gclist')));
    
    //Load list from file and cut number of caches 
    if (gj2web_UserRGroupQuantity.ItemIndex = 1) then cachecount := StrToInt(gj2web_UserEditNumber.Text) else cachecount := -1;
    if Result = RESULT_VALID then list := GetDownloadedList(GetDownloadedGcListFile,cachecount);
end;

{Download geocaches }
function GeoJarrywebUserDownload : String;
var
  list : TStringList;
begin
  Result := '';
  GeoJarrywebUserPrepareIniFile;
  list := TStringList.Create;
  try
    Result := GeoJarrywebUserGetCacheList(list);                                //all logs or last 5
    if Result = RESULT_VALID then Result := DownloadWaypointListings(list, (gj2web_UserRGroupLogs.ItemIndex = 1)); //download now
  finally
    list.Free;
  end;
  
  if ((Result = RESULT_VALID) and (gj2web_UserCheckBoxDates.Checked)) then //download dates of finds
  begin
     StringToFile(RegexReplace('filename=.+' + CRLF,GetIniHeader,'filename=ZZZZ_DatesOfFinds' + CRLF,false),GetIniFile); //we have to ensure that this file will be imported as the last one
     Result := GeoJarryResultToString(GeoJarryRunExec('"' + GetGeoJarryExe + '" "' + GetIniFile + '" raw "http://www.geocaching.com/my/logs.aspx?s=1"'));
  end;
end;

function GeoJarrywebUserGetInfo : String;
var
    s,r : String;
begin
    if (gj2web_UserRGroupRelation.ItemIndex = 0) then s := _('found by') + ' ' else
    if (gj2web_UserRGroupRelation.ItemIndex = 1) then s := _('placed by') + ' ';
    if (gj2web_UserEditUsername.Text <> '') then s := s + gj2web_UserEditUsername.Text else s := s + gUsername;
    Result := _('This query will search Geocaching.com webpage for geocaches') + ' ' + s + '. ';
    if (gj2web_UserRGroupQuantity.ItemIndex = 1) then 
    begin
      r := _('Only %NUMBER% most recent geocaches will be downloaded.');
      r := ReplaceString(r,'%NUMBER%',gj2web_UserEditNumber.Text);
      Result := Result + r + ' ';
    end; 
    if (gj2web_UserCheckBoxDates.Checked) then Result := Result + _('Dates of your finds will be downloaded.') + ' ';
end;

procedure GeoJarrywebUserSetDefaults;
begin
     gj2web_UserEditUsername.Text := '';
     gj2web_UserRGroupRelation.ItemIndex := 0;
     gj2web_UserRGroupQuantity.ItemIndex := 0;
     gj2web_UserEditNumber.Text := '';
     gj2web_UserCheckBoxDates.Checked := false;
     gj2web_UserCheckBoxDates.Enabled := false;
     gj2web_UserRGroupLogs.ItemIndex := 0;
end;

procedure GeoJarrywebUserSetActions;
begin
  gj2web_UserRGroupQuantity.onClick := @UserRGroupQuantityOnClick;
  gj2web_UserEditNumber.onExit := @UserEditNumberOnExit;
  gj2web_UserEditUsername.onChange := @UserEditUsernameOnChange;
  gj2web_UserRGroupRelation.onClick := @UserEditUsernameOnChange;
  gj2web_UserRGroupLogs.onClick := @UserEditUsernameOnChange;
end;   
