{Fetch waymark codes from form}
function GeoJarrywmCodeGetCodeList : TStringList;
var
    s,p : String;
begin
    Result := TStringList.Create;
    Result.sorted := true;
    Result.duplicates := dupIgnore;
    s := gj2wm_CodeMemoCode.Text;
    while length(s) > 0 do
    begin
        p := ReplaceString(UpperCase(Fetch(s, ';')),CRLF,'');
        if p <> '' then Result.Add(p);
    end;
end; 

function GeoJarrywmCodeValidate : String;
var
    s : String;
begin
    Result := '';
    s := gj2wm_CodeMemoCode.Text;
    if s = '' 
       then Result := Result + _('You have to enter a WM code. (No "Waymark codes" found)') + CRLF
       else Result := WmCodeListValidate(GeoJarrywmCodeGetCodeList);
end;

function GeoJarrywmCodeLoad(file: String) : String;
var
  iniF: TIniFile;
begin
  Result := '';
  if FileExists(file) then
  begin
    iniF := TIniFile.Create(file);
    try
      gj2wm_CodeMemoCode.Text   := UnwrapCRLF(iniF.readString('Query', 'Codes', ''));
      
      Result := GeoJarrywmCodeValidate;
    finally
      iniF.Free;
    end;
  end;
end;

function GeoJarrywmCodeSave(file: String) : String;
var
  iniF: TIniFile;
begin
  Result := GeoJarrywmCodeValidate;
  if Result = RESULT_VALID then
  begin
    iniF := TIniFile.Create(file);
    try
      iniF.writeBool('Criteria','Code', true);
      iniF.writeString('Query', 'Codes', WrapCRLF(gj2wm_CodeMemoCode.Text));
    finally
      iniF.Free;
    end;
  end;
end;

function GeoJarrywmCodeGetInfo : String;
begin
    Result := _('Given waymark codes');
end;


procedure GeoJarrywmCodeSetDefaults;
begin
     gj2wm_CodeMemoCode.Text := '';
end;

procedure GeoJarrywmCodeMemoCodeOnExit(sender : TObject);
begin
    gj2wm_CodeMemoCode.Text := UpperCase(gj2wm_CodeMemoCode.Text);
end;

procedure GeoJarrywmCodeSetActions;
begin
    gj2wm_CodeMemoCode.onExit := @GeoJarrywmCodeMemoCodeOnExit;
end;

