var
   WmLat, WmLon : Extended; //latitude and longitude
   
{Save coordinates into form}  
procedure GeoJarrywmCoordSaveCoordinates;
begin
   if ((WmLat <> 0) or (WmLon <> 0)) 
   then 
     begin
        gj2wm_CoordLabelCoord.Caption := FormatCoordNum(WmLat, WmLon);
        gj2wm_CoordSButtonShowMap.Visible := true;
        gj2wm_CoordSButtonSaveReference.Visible := true;
        gj2wm_CoordSButtonRemoveCoordinates.Visible := true;
     end
   else 
     begin
        gj2wm_CoordLabelCoord.Caption := _('No coordinates selected.'+ CRLF + 'GeoJarry will use current GeoGet reference point.');
        gj2wm_CoordSButtonShowMap.Visible := false;
        gj2wm_CoordSButtonSaveReference.Visible := false;
        gj2wm_CoordSButtonRemoveCoordinates.Visible := false;
     end;
end;

procedure GeoJarrywmCoordButtonChangeOnClick(Sender :TObject);
begin
   if CoordEdit(_('Select coordinates'), _('Coordinates are used as the central point for your search'), WmLat, WmLon) then GeoJarrywmCoordSaveCoordinates;
end;

procedure GeoJarrywmCoordSButtonShowMapOnClick(Sender :TObject);
var
   url : String;
begin
   begin
      url := ReplaceString(MAP_VIEW_URL,'$LATITUDE',FloatToStr(WmLat));
      url := ReplaceString(url,'$LONGITUDE',FloatToStr(WmLon));
      RunShell(url);
   end;
end;

procedure GeoJarrywmCoordSButtonSaveReferenceOnClick(Sender :TObject);
var
   names : TStringList;
   name : String;
begin
   names := TStringList.Create;
   try
    RefPointNames(names);
    if InputComboBox(_('Reference point'), _('Select a name for new reference point'), '',names,true,name) then RefPointSet(name, WmLat, WmLon);
   finally
    names.free;
   end;
end;

procedure GeoJarrywmCoordSButtonRemoveCoordinatesOnClick(Sender :TObject);
begin
   WmLat := 0; WmLon := 0;
   GeoJarrywmCoordSaveCoordinates;   
end;

procedure GeoJarrywmCoordButtonGoogleSearchOnClick(Sender :Tobject);
begin
   if CoordSearch(WmLat, WmLon) then GeoJarrywmCoordSaveCoordinates;
end;

procedure GeoJarrywmCoordButtonLoadRefOnClick(Sender :Tobject);
var
   names : TStringList;
   name : String;
begin
  names := TStringList.Create;
  try
    RefPointNames(names);
    if InputComboBox(_('Reference point'), _('Select reference point for your search'), names[0],names,false,name) and RefPointGet(name, WmLat, WmLon) then GeoJarrywmCoordSaveCoordinates;
  finally
    names.free;
  end;
end;

procedure GeoJarrywmCoordEditDistanceOnExit(Sender: Tobject);
begin
    if (gj2wm_CoordEditDistance.Text <> '') then
    if (not RegexFind('^0*[1-9]\d*$',gj2wm_CoordEditDistance.Text)) then
    begin
      ShowMessage(_('You must enter only positive integers!'));
      gj2wm_CoordEditDistance.setfocus;
    end; 
end;

procedure GeoJarrywmCoordLabelProfileOnClick(Sender: TObject);
begin
    ShowMessage(_('Currently the Waymarking.com system is broken and always uses miles, no matter what you set in your settings!'));
    RunShell('http://www.waymarking.com/my/account.aspx');
end;

function GeoJarrywmCoordValidate : String;
begin
  Result := '';

  if not ((gj2wm_CoordEditDistance.Text <> '') and (RegexFind('^0*[1-9]\d*$',gj2wm_CoordEditDistance.Text)))then Result := Result + _('You have to set the distance limit. (Unknown distance limit, has to be positive integer)') + CRLF; 
  
  if Result = '' then Result := RESULT_VALID;
end;

function GeoJarrywmCoordLoad(file: String) : String;
var
  iniF: TIniFile;
begin
  Result := '';
  if FileExists(file) then
  begin
    iniF := TIniFile.Create(file);
    try
      WmLat                              := iniF.readFloat('Query', 'Latitude', 0);
      WmLon                              := iniF.readFloat('Query', 'Longitude', 0);
      gj2wm_CoordEditDistance.Text       := iniF.readString('Query', 'Distance', '');
      
      Result := GeoJarrywmCoordValidate;
      if Result = RESULT_VALID then GeoJarrywmCoordSaveCoordinates;
    finally
      iniF.Free;
    end;
  end;
end;

function GeoJarrywmCoordSave(file: String) : String;
var
  iniF: TIniFile;
begin
  Result := GeoJarrywmCoordValidate;
  if Result = RESULT_VALID then
  begin
    iniF := TIniFile.Create(file);
    try
      iniF.writeBool('Criteria','Coord', true);
      
      if WmLat <> 0 then iniF.writeFloat('Query', 'Latitude', WmLat);
      if WmLon <> 0 then iniF.writeFloat('Query', 'Longitude', WmLon);
      iniF.writeString('Query', 'Distance', gj2wm_CoordEditDistance.Text);
    finally
      iniF.Free;
    end;
  end;
end;

function GeoJarrywmCoordGetInfo : String;
var
    s : String;
begin
    if ((WmLat = 0) and (WmLon = 0)) 
      then s := _('current reference point')
      else s := _('coordinates') + ' ' + FormatCoordNum(WmLat, WmLon);
    Result := _('Within %DISTANCE%km/mi around %LOCATION%');
    Result := ReplaceString(Result,'%DISTANCE%',gj2wm_CoordEditDistance.Text);
    Result := ReplaceString(Result,'%LOCATION%',s);
    Result := Result + ' ';
end;

function GeoJarrywmCoordGetUrlParameters(var list: TStringList) : String;
var
    lat, lon : String;
begin
  if ((WmLat = 0) And (WmLon = 0)) 
    then begin lat := GEOGET_RefX; lon := GEOGET_RefY; end
    else begin lat := FloatToStr(WmLat); lon := FloatToStr(WmLon); end;

  list.add('lat=' + EncodeUrlElement(lat));
  list.add('lon=' + EncodeUrlElement(lon));
  list.add('r=' + EncodeUrlElement(gj2wm_CoordEditDistance.Text)); //radius
  
  Result := RESULT_VALID;
end;

procedure GeoJarrywmCoordSetDefaults;
begin
     WmLat := 0;
     WmLon := 0;
     gj2wm_CoordLabelCoord.Caption := _('No coordinates selected.'+ CRLF + 'GeoJarry will use current GeoGet reference point.');
     gj2wm_CoordSButtonShowMap.Visible := false;
     gj2wm_CoordSButtonSaveReference.Visible := false;
     gj2wm_CoordSButtonRemoveCoordinates.Visible := false;

     gj2wm_CoordEditDistance.Text := '10';
end;

procedure GeoJarrywmCoordSetActions;
begin
  gj2wm_CoordButtonChange.OnClick := @GeoJarrywmCoordButtonChangeOnClick;
  gj2wm_CoordSButtonShowMap.OnClick := @GeoJarrywmCoordSButtonShowMapOnClick;
  gj2wm_CoordSButtonSaveReference.OnClick := @GeoJarrywmCoordSButtonSaveReferenceOnClick;
  gj2wm_CoordSButtonRemoveCoordinates.OnClick := @GeoJarrywmCoordSButtonRemoveCoordinatesOnClick;
  gj2wm_CoordButtonGoogleSearch.OnClick := @GeoJarrywmCoordButtonGoogleSearchOnClick;
  gj2wm_CoordButtonLoadRef.onClick := @GeoJarrywmCoordButtonLoadRefOnClick;
  gj2wm_CoordEditDistance.onExit := @GeoJarrywmCoordEditDistanceOnExit;
  gj2wm_CoordLabelProfile.onClick := @GeoJarrywmCoordLabelProfileOnClick;
end;  