procedure GeoJarrywmCountryComboBoxCountryOnChange(Sender :TObject);
begin
       gj2wm_CountryComboBoxState.enabled := false;
       gj2wm_CountrySButtonState.visible := false;
       gj2wm_CountrySButtonCountry.visible := false;
       if gj2wm_CountryComboBoxCountry.ItemIndex <> -1 then
       begin
         gj2wm_CountrySButtonCountry.visible := true;
         GetStateList(gj2wm_CountryComboBoxCountry.Text, gj2wm_CountryComboBoxState.Items);
         gj2wm_CountryComboBoxState.enabled := (gj2wm_CountryComboBoxState.Items.Count > 1);
       end;
end;

procedure GeoJarrywmCountryComboBoxStateOnChange(Sender :TObject);
begin
    gj2wm_CountrySButtonState.visible := (gj2wm_CountryComboBoxState.Text <> '');
end;

procedure GeoJarrywmCountrySButtonStateOnClick(Sender :Tobject);
begin
    gj2wm_CountrySButtonState.visible := false;
    gj2wm_CountryComboBoxState.ItemIndex := -1;
end;

procedure GeoJarrywmCountrySButtonCountryOnClick(Sender :Tobject);
begin
    gj2wm_CountrySButtonCountry.visible := false;
    gj2wm_CountryComboBoxCountry.ItemIndex := -1;
    
    GeoJarrywmCountrySButtonStateOnClick(Sender);
    GeoJarrywmCountryComboBoxCountryOnChange(Sender);
end;

function GeoJarrywmCountryValidate : String;
begin
   Result := RESULT_VALID;
end;

function GeoJarrywmCountryLoad(file: String) : String;
var
  iniF: TIniFile;
begin
  Result := '';
  if FileExists(file) then
  begin
    iniF := TIniFile.Create(file);
    try
      gj2wm_CountryComboBoxCountry.ItemIndex := gj2wm_CountryComboBoxCountry.Items.IndexOf(iniF.readString('Query', 'CountryName', ''));
      GeoJarrywmCountryComboBoxCountryOnChange(nil);
      gj2wm_CountryComboBoxState.ItemIndex := gj2wm_CountryComboBoxState.Items.IndexOf(iniF.readString('Query', 'StateName', ''));
      GeoJarrywmCountryComboBoxStateOnChange(nil);
       
      Result := GeoJarrywmCountryValidate;
    finally
      iniF.Free;
    end;
  end;
end;

function GeoJarrywmCountrySave(file: String) : String;
var
  iniF: TIniFile;
begin
  Result := GeoJarrywmCountryValidate;
  if Result = RESULT_VALID then
  begin
    iniF := TIniFile.Create(file);
    try
      iniF.writeBool('Criteria','Country', true);
      
      if gj2wm_CountryComboBoxCountry.Text <> '' then iniF.writeString('Query', 'CountryName', gj2wm_CountryComboBoxCountry.Text);
      if gj2wm_CountryComboBoxState.Text <> '' then iniF.writeString('Query', 'StateName', gj2wm_CountryComboBoxState.Text);
    finally
      iniF.Free;
    end;
  end;
end;

function GeoJarrywmCountryGetInfo : String;
var
    area,state : String;
begin
    if (gj2wm_CountryComboBoxCountry.Text = '')  
      then begin area := gHomeCountryName; state := gHomeStateName; end//home area
      else begin area := gj2wm_CountryComboBoxCountry.Text; state := gj2wm_CountryComboBoxState.Text; end;
    if state <> '' then area := area + ' - ' + state;
    Result := _('Located in: %AREA%');
    Result := ReplaceString(Result,'%AREA%',area);
end;

function GeoJarrywmCountryGetUrlParameters(var list: TStringList) : String;
var
  c,s : String;
begin
  if ((gj2wm_CountryComboBoxCountry.Text = '') And (gj2wm_CountryComboBoxState.Text = '')) //no area set - using home area
    then begin c := gHomeCountryName; s := gHomeStateName; end
    else begin c := gj2wm_CountryComboBoxCountry.Text; s := gj2wm_CountryComboBoxState.Text; end;
    
  if (c = '') 
    then Result := _('Could not determine country. Go to GeoJarry settings and check your home area options.')
    else
    begin
        list.add('ct=' + EncodeUrlElement(TranslateCountryID(c)));
        if s <> '' then list.add('s=' + EncodeUrlElement(TranslateStateID(c,s)));
        Result := RESULT_VALID;
    end;
end;

procedure GeoJarrywmCountrySetDefaults;
begin
     GetCountryList(gj2wm_CountryComboBoxCountry.Items);
     gj2wm_CountryComboBoxState.ItemIndex := -1;
     gj2wm_CountryComboBoxState.enabled := false;
     gj2wm_CountrySButtonCountry.Visible := false;
     gj2wm_CountrySButtonState.Visible := false;
end;

procedure GeoJarrywmCountrySetActions;
begin
  GetCountryList(gj2wm_CountryComboBoxCountry.Items);
  gj2wm_CountryComboBoxCountry.onChange := @GeoJarrywmCountryComboBoxCountryOnChange;
  gj2wm_CountryComboBoxState.onChange := @GeoJarrywmCountryComboBoxStateOnChange;
  gj2wm_CountrySButtonState.onClick := @GeoJarrywmCountrySButtonStateOnClick;
  gj2wm_CountrySButtonCountry.onClick := @GeoJarrywmCountrySButtonCountryOnClick;
end;
