procedure GeoJarrywmDateRGroupLimitOnClick(Sender : TObject);
begin
    gj2wm_DateGroupBoxCustom.Visible := (gj2wm_DateRGroupLimit.ItemIndex = 5);
end;

function GeoJarrywmDateValidate : String;
begin
  Result := '';
  if (gj2wm_DateRGroupLimit.ItemIndex = -1) then Result := Result + _('You have to select date range. (No "Date range" specified)') + CRLF;
  if ((gj2wm_DateRGroupLimit.ItemIndex = 5) and (gj2wm_DateTimePickerFrom.Date >= gj2wm_DateTimePickerTo.Date)) then Result := Result + _('You have to set the "from date" to be before the "to date". (Wrong "Date range" specified)') + CRLF;
   
  if Result = '' then Result := RESULT_VALID;
end;

function GeoJarrywmDateLoad(file: String) : String;
var
  iniF: TIniFile;
begin
  Result := '';
  if FileExists(file) then
  begin
    iniF := TIniFile.Create(file);
    try
      gj2wm_DateRGroupLimit.ItemIndex := iniF.readInteger('Query', 'DateLimit', DEFAULT_RGROUP);
      GeoJarrywmDateRGroupLimitOnClick(nil);
      
      if (gj2wm_DateRGroupLimit.ItemIndex = 5) then
      begin
         gj2wm_DateTimePickerFrom.Date := IntToDate(iniF.readString('Query', 'DateFrom', DateToInt(now-1)));
         gj2wm_DateTimePickerTo.Date := IntToDate(iniF.readString('Query', 'DateTo', DateToInt(now)));
      end;
       
      Result := GeoJarrywmDateValidate;
    finally
      iniF.Free;
    end;
  end;
end;

function GeoJarrywmDateSave(file: String) : String;
var
  iniF: TIniFile;
begin
  Result := GeoJarrywmDateValidate;
  if Result = RESULT_VALID then
  begin
    iniF := TIniFile.Create(file);
    try
      iniF.writeBool('Criteria','Date', true);
      
      iniF.writeInteger('Query', 'DateLimit', gj2wm_DateRGroupLimit.ItemIndex);
      if (gj2wm_DateRGroupLimit.ItemIndex = 5) then
      begin
         iniF.writeString('Query', 'DateFrom', DateToInt(gj2wm_DateTimePickerFrom.Date));
         iniF.writeString('Query', 'DateTo', DateToInt(gj2wm_DateTimePickerTo.Date));
      end;

    finally
      iniF.Free;
    end;
  end;
end;

function GeoJarrywmDateGetInfo : String;
var
    date : String;
begin
    case gj2wm_DateRGroupLimit.ItemIndex of
    0 : begin date := _('last 7 days'); end;
    1 : begin date := _('last 30 days'); end;
    2 : begin date := _('last 60 days'); end;
    3 : begin date := _('last 180 days'); end;
    4 : begin date := _('last 365 days'); end;
    5 : begin date := formatdatetime('dd". "mm". "yyyy', gj2wm_DateTimePickerFrom.Date)+ ' - ' + formatdatetime('dd". "mm". "yyyy', gj2wm_DateTimePickerTo.Date); end;
    else date := _('unknown dates'); 
    end;
    Result := _('Published within %DATES%');
    Result := ReplaceString(Result,'%DATES%',date);
end;

function GeoJarrywmDateGetUrlParameters(var list: TStringList) : String;
var
  s : String;
begin
    Result := RESULT_VALID;
    case gj2wm_DateRGroupLimit.ItemIndex of
    0 : begin s := '2'; end;
    1 : begin s := '3'; end;
    2 : begin s := '4'; end;
    3 : begin s := '5'; end;
    4 : begin s := '6'; end;
    5 : begin s := '7'; end;
    else Result := _('Unknown date range'); 
    end;
    
    if Result = RESULT_VALID then
    begin
       list.add('tp=' + EncodeUrlElement(s));
       if s = '7' then
       begin
          list.add('d1=' + EncodeUrlElement(formatdatetime('mm"/"dd"/"yyyy', gj2wm_DateTimePickerFrom.Date)));
          list.add('d2=' + EncodeUrlElement(formatdatetime('mm"/"dd"/"yyyy', gj2wm_DateTimePickerTo.Date)));
       end;
   end;
end;

procedure GeoJarrywmDateSetDefaults;
begin
     gj2wm_DateRGroupLimit.ItemIndex := 0;
     gj2wm_DateGroupBoxCustom.Visible := false;
     
     gj2wm_DateTimePickerTo.MaxDate := now;
     gj2wm_DateTimePickerTo.Date := now;
     gj2wm_DateTimePickerFrom.MaxDate := now - 1;
     gj2wm_DateTimePickerFrom.Date := now - 30;
end;

procedure GeoJarrywmDateSetActions;
begin
    gj2wm_DateRGroupLimit.OnClick := @GeoJarrywmDateRGroupLimitOnClick;
end;        