function GeoJarrywmKeywordValidate : String;
begin
  Result := '';
  if (gj2wm_KeywordEditKeyword.Text = '') then Result := Result + _('You have to enter a keyword. (No "Keyword" specified)') + CRLF;
  
  If Result = '' then Result := RESULT_VALID;
end;

function GeoJarrywmKeywordLoad(file: String) : String;
var
  iniF: TIniFile;
begin
  Result := '';
  if FileExists(file) then
  begin
    iniF := TIniFile.Create(file);
    try
      gj2wm_KeywordEditKeyword.Text := iniF.readString('Query', 'Keyword','');
      
      Result := GeoJarrywmKeywordValidate;
    finally
      iniF.Free;
    end;
  end;
end;

function GeoJarrywmKeywordSave(file: String) : String;
var
  iniF: TIniFile;
begin
  Result := GeoJarrywmKeywordValidate;
  if Result = RESULT_VALID then
  begin
    iniF := TIniFile.Create(file);
    try
      iniF.writeBool('Criteria','Keyword', true);
      iniF.writeString('Query', 'Keyword',gj2wm_KeywordEditKeyword.Text);
    finally
      iniF.Free;
    end;
  end;
end;

function GeoJarrywmKeywordGetInfo : String;
begin
    Result := _('Keyword: %KEYWORD%');
    Result := ReplaceString(Result,'%KEYWORD%',gj2wm_KeywordEditKeyword.Text);
end;
  
procedure GeoJarrywmKeywordSetDefaults;
begin
     gj2wm_KeywordEditKeyword.Text := '';
end;

function GeoJarrywmKeywordGetUrlParameters(var list: TStringList) : String;
begin
    list.add('kw=' + EncodeUrlElement(AnsiToUtf(gj2wm_KeywordEditKeyword.Text)));
    Result := RESULT_VALID;
end;

procedure GeoJarrywmKeywordSetActions;
begin

end; 
