var
   wmdownloaded : boolean; //was the query downloaded?
   wmqueryfile : string; //what file was the query loaded from?
   
const
   WM_URLBASE = 'http://www.waymarking.com/wm/search.aspx?f=1';
   WM_URLBASE_CATEGORY = 'http://www.waymarking.com/cat/details.aspx?f=1';
   
{$include gj2wm.category.lib.pas}
{$include gj2wm.code.lib.pas}
{$include gj2wm.coord.lib.pas}
{$include gj2wm.country.lib.pas}
{$include gj2wm.date.lib.pas}
{$include gj2wm.keyword.lib.pas}
{$include gj2wm.user.lib.pas}

{Is this query a waymark code query?}
function isGeojarrywmCodeQuery : boolean;
begin
   Result := gj2wm_AllListBoxAppliedCriteria.Items.IndexOf(_('Code')) <> -1;
end;

{Validate the common part of the query}   
function GeoJarrywmAllValidate : String;
begin
  Result := '';
  if not isGeojarrywmCodeQuery then
  begin
    if (gj2wm_AllRGroupNumber.ItemIndex = -1) then Result := Result + _('You have to select when the downloading should stop. (Unknown "Download" option)') + CRLF;  
    if ((gj2wm_AllRGroupNumber.ItemIndex = 1) And not ((gj2wm_AllEditNumber.Text <> '') And (RegexFind('^0*[1-9]\d*$',gj2wm_AllEditNumber.Text)))) then Result := Result + _('You have to enter the number of waymarks to download. (Unknown waymark count limit, has to be positive integer)') + CRLF;
    if (gj2wm_AllRGroupListing.ItemIndex = -1) then Result := Result + _('You have to select the waymark details to download. (Unknown "Waymark details" option)') + CRLF;
  end;

  if Result = '' Then Result := RESULT_VALID;   
end;

{This procedure hides all criteria pages}
procedure GeoJarrywmHideAllCriteriaPages;
begin
    gj2wm_CategoryGroupBox.Visible := false;
    gj2wm_CodeGroupBox.Visible := false; 
    gj2wm_CoordGroupBox.Visible := false; 
    gj2wm_CountryGroupBox.Visible := false; 
    gj2wm_DateGroupBox.Visible := false; 
    gj2wm_KeywordGroupBox.Visible := false; 
    gj2wm_UserGroupBox.Visible := false; 
end;

{This procedure sets contents of available criteria to defaults}
procedure GeoJarrywmSetDefaultAvailableCriteria;
begin
   gj2wm_AllListBoxAvailableCriteria.Items.Clear;
   gj2wm_AllListBoxAvailableCriteria.Items.Add(_('Category'));
   gj2wm_AllListBoxAvailableCriteria.Items.Add(_('Code'));
   gj2wm_AllListBoxAvailableCriteria.Items.Add(_('Coordinates'));
   gj2wm_AllListBoxAvailableCriteria.Items.Add(_('Country'));
   gj2wm_AllListBoxAvailableCriteria.Items.Add(_('Date of publication'));
   gj2wm_AllListBoxAvailableCriteria.Items.Add(_('Keyword'));
   gj2wm_AllListBoxAvailableCriteria.Items.Add(_('User'));
end;

procedure GeoJarrywmSelectCriteriaPage(Name : String);
begin
    GeoJarrywmHideAllCriteriaPages;    
    Case name of
      _('Category'):           begin; gj2wm_CategoryGroupBox.Visible := true; end; 
      _('Code'):               begin; gj2wm_CodeGroupBox.Visible := true; end; 
      _('Coordinates'):        begin; gj2wm_CoordGroupBox.Visible := true; end; 
      _('Country'):            begin; gj2wm_CountryGroupBox.Visible := true; end; 
      _('Date of publication'):begin; gj2wm_DateGroupBox.Visible := true; end; 
      _('Keyword'):            begin; gj2wm_KeywordGroupBox.Visible := true; end; 
      _('User'):               begin; gj2wm_UserGroupBox.Visible := true; end; 
      else                     begin; ShowMessage(_('Could not determine criteria name')); end;
    end;
end;

{This procedure calls a proper function which validates criteria of given name}
function GeoJarrywmValidateCriteria(name : String) : String;
begin
  Result := '';
  Case name of
    _('Category'):           begin; Result := GeoJarrywmCategoryValidate(); end; 
    _('Code'):               begin; Result := GeoJarrywmCodeValidate(); end; 
    _('Coordinates'):        begin; Result := GeoJarrywmCoordValidate(); end; 
    _('Country'):            begin; Result := GeoJarrywmCountryValidate(); end; 
    _('Date of publication'):begin; Result := GeoJarrywmDateValidate(); end; 
    _('Keyword'):            begin; Result := GeoJarrywmKeywordValidate(); end; 
    _('User'):               begin; Result := GeoJarrywmUserValidate(); end; 
    else                     begin; Result := _('Could not determine criteria name to validate.') + CRLF; end;
  end;
end;

{This procedure calls a proper function which saves criteria of given name to given file}
function GeoJarrywmSaveCriteria(name, file : String) : String;
begin
  Result := '';
  Case name of
    _('Category'):           begin; Result := GeoJarrywmCategorySave(file); end; 
    _('Code'):               begin; Result := GeoJarrywmCodeSave(file); end; 
    _('Coordinates'):        begin; Result := GeoJarrywmCoordSave(file); end; 
    _('Country'):            begin; Result := GeoJarrywmCountrySave(file); end; 
    _('Date of publication'):begin; Result := GeoJarrywmDateSave(file); end; 
    _('Keyword'):            begin; Result := GeoJarrywmKeywordSave(file); end; 
    _('User'):               begin; Result := GeoJarrywmUserSave(file); end; 
    else                     begin; Result := _('Could not determine criteria name to save.') + CRLF; end;
  end;
end;

{This procedure calls a proper function which loads criteria of given name from given file}
function GeoJarrywmLoadCriteria(name, file : String) : String;
begin
  Result := '';
  Case name of
    _('Category'):           begin; Result := GeoJarrywmCategoryLoad(file); end; 
    _('Code'):               begin; Result := GeoJarrywmCodeLoad(file); end; 
    _('Coordinates'):        begin; Result := GeoJarrywmCoordLoad(file); end; 
    _('Country'):            begin; Result := GeoJarrywmCountryLoad(file); end; 
    _('Date of publication'):begin; Result := GeoJarrywmDateLoad(file); end; 
    _('Keyword'):            begin; Result := GeoJarrywmKeywordLoad(file); end; 
    _('User'):               begin; Result := GeoJarrywmUserLoad(file); end; 
    else                     begin; Result := _('Could not determine criteria name to load.') + CRLF; end;
  end;
end;

{This procedure calls a proper function which writes information about criteria of given name}
function GeoJarrywmGetCriteriaInfo(name: String) : String;
begin
  Result := '';
  Case name of
    _('Category'):           begin; Result := GeoJarrywmCategoryGetInfo(); end; 
    _('Code'):               begin; Result := GeoJarrywmCodeGetInfo(); end; 
    _('Coordinates'):        begin; Result := GeoJarrywmCoordGetInfo(); end; 
    _('Country'):            begin; Result := GeoJarrywmCountryGetInfo(); end; 
    _('Date of publication'):begin; Result := GeoJarrywmDateGetInfo(); end; 
    _('Keyword'):            begin; Result := GeoJarrywmKeywordGetInfo(); end; 
    _('User'):               begin; Result := GeoJarrywmUserGetInfo(); end; 
    else                     begin; Result := _('Could not determine criteria name to get info about.') + CRLF; end;
  end;
end;

{This procedure calls a proper function which adds url parameters to the given string list}
function GeoJarrywmGetCriteriaUrlParameters(name: String; var list : TStringList) : String;
begin
  Result := '';
  Case name of
    _('Category'):           begin; Result := GeoJarrywmCategoryGetUrlParameters(list); end; 
    //'Code':               begin; Result := GeoJarrywmCodeGetUrlParameters(list); end; Can not use URL parameters to search by Code
    _('Coordinates'):        begin; Result := GeoJarrywmCoordGetUrlParameters(list); end; 
    _('Country'):            begin; Result := GeoJarrywmCountryGetUrlParameters(list); end; 
    _('Date of publication'):begin; Result := GeoJarrywmDateGetUrlParameters(list); end; 
    _('Keyword'):            begin; Result := GeoJarrywmKeywordGetUrlParameters(list); end; 
    _('User'):               begin; Result := GeoJarrywmUserGetUrlParameters(list); end; 
    else                     begin; Result := _('Could not determine criteria name to get url parameters.') + CRLF; end;
  end;
end;

procedure GeoJarrywmAllListBoxAvailableCriteriaOnClick(Sender : TObject);
begin
   gj2wm_AllButtonApply.Enabled := (gj2wm_AllListBoxAvailableCriteria.ItemIndex <> -1);
   
   if (gj2wm_AllListBoxAvailableCriteria.ItemIndex <> -1) 
     then GeoJarrywmSelectCriteriaPage(gj2wm_AllListBoxAvailableCriteria.Items[gj2wm_AllListBoxAvailableCriteria.ItemIndex]);
end;

procedure GeoJarrywmAllListBoxAppliedCriteriaOnClick(Sender : TObject);
begin
    gj2wm_AllButtonRemove.Enabled := (gj2wm_AllListBoxAppliedCriteria.ItemIndex <> -1);
    
    if (gj2wm_AllListBoxAppliedCriteria.ItemIndex <> -1) 
      then GeoJarrywmSelectCriteriaPage(gj2wm_AllListBoxAppliedCriteria.Items[gj2wm_AllListBoxAppliedCriteria.ItemIndex]);
end;

{This procedure transfers record of a given name from one TStrings to other}
function GeoJarrywmTransferCriteria(Name : String; From: TStrings; Into: TStrings) : boolean;
var
   formerIndex : Integer;
begin
   formerIndex := From.IndexOf(Name);
   Result := (formerIndex <> -1);
   If Result Then
   begin
       From.Delete(formerIndex);
       Into.Add(Name);
   end;
end;

{This procedure applies criteria}
function GeoJarrywmApplyCriteria(Name : String) : String;
begin
   Result := RESULT_INVALID;
   if (((name = _('Code')) and (gj2wm_AllListBoxAppliedCriteria.Items.Count > 0)) or (gj2wm_AllListBoxAppliedCriteria.Items.IndexOf(_('Code')) <> -1)) then 
   begin
      Result := _('Code criteria can not be combined with other criteria.');
      Exit;   
   end;

   if GeoJarrywmTransferCriteria(name,gj2wm_AllListBoxAvailableCriteria.Items,gj2wm_AllListBoxAppliedCriteria.Items) then
   begin
      //Code can not be combined with other criteria
      if name = _('Code') then begin
        gj2wm_AllListBoxAvailableCriteria.Enabled := false;
        gj2wm_AllRGroupNumber.Enabled := false;
        gj2wm_AllCheckBoxVisited.Enabled := false;
        gj2wm_AllCheckBoxOwned.Enabled := false;
        gj2wm_AllRGroupListing.Enabled := false;
        gj2wm_AllLabelPreviewOnline.Visible := false;
      end;       

      //Refresh
      gj2wm_AllListBoxAvailableCriteria.ItemIndex := -1;
      gj2wm_AllListBoxAppliedCriteria.ItemIndex := gj2wm_AllListBoxAppliedCriteria.Items.IndexOf(name);
      
      GeoJarrywmAllListBoxAppliedCriteriaOnClick(nil);
      GeoJarrywmAllListBoxAvailableCriteriaOnClick(nil);
      
      Result := RESULT_VALID;
   end;
end;

{This procedure removes applied criteria}
function GeoJarrywmRemoveCriteria(Name: String): String;
begin
   Result := RESULT_INVALID;
   if GeoJarrywmTransferCriteria(name,gj2wm_AllListBoxAppliedCriteria.Items,gj2wm_AllListBoxAvailableCriteria.Items) then
   begin
      //Code could not be combined with other criteria
      if name = _('Code') then begin
        gj2wm_AllListBoxAvailableCriteria.Enabled := true;
        gj2wm_AllRGroupNumber.Enabled := true;
        gj2wm_AllCheckBoxVisited.Enabled := true;
        gj2wm_AllCheckBoxOwned.Enabled := true;
        gj2wm_AllRGroupListing.Enabled := true;
        gj2wm_AllLabelPreviewOnline.Visible := true;
      end;        
      
      //Refresh
      gj2wm_AllListBoxAppliedCriteria.ItemIndex := -1;
      gj2wm_AllListBoxAvailableCriteria.ItemIndex := -1;
      
      GeoJarrywmAllListBoxAvailableCriteriaOnClick(nil);
      GeoJarrywmAllListBoxAppliedCriteriaOnClick(nil);
      GeoJarrywmHideAllCriteriaPages;
      
      Result := RESULT_VALID;
   end;
end;

{This procedure reads saved query and loads applied criteria to form}
function GeoJarrywmLoadAppliedCriteria(file : String) : String;
var
  iniF: TIniFile;
begin
  Result := RESULT_INVALID;
  if FileExists(file) then
  begin
    iniF := TIniFile.Create(file);
    try
        Result := RESULT_VALID;
        if ((iniF.readBool('Criteria','Category',false)) and (Result = RESULT_VALID)) then Result := GeoJarrywmApplyCriteria(_('Category'));
        if ((iniF.readBool('Criteria','Code',false))     and (Result = RESULT_VALID)) then Result := GeoJarrywmApplyCriteria(_('Code'));
        if ((iniF.readBool('Criteria','Coord',false))    and (Result = RESULT_VALID)) then Result := GeoJarrywmApplyCriteria(_('Coordinates'));
        if ((iniF.readBool('Criteria','Country',false))  and (Result = RESULT_VALID)) then Result := GeoJarrywmApplyCriteria(_('Country'));
        if ((iniF.readBool('Criteria','Date',false))     and (Result = RESULT_VALID)) then Result := GeoJarrywmApplyCriteria(_('Date of publication'));
        if ((iniF.readBool('Criteria','Keyword',false))  and (Result = RESULT_VALID)) then Result := GeoJarrywmApplyCriteria(_('Keyword'));
        if ((iniF.readBool('Criteria','User',false))     and (Result = RESULT_VALID)) then Result := GeoJarrywmApplyCriteria(_('User'));
        if gj2wm_AllListBoxAppliedCriteria.Items.Count = 0 then Result := _('No applied criteria found');
    finally
        iniF.Free;
    end;
  end;
end; 

{Validate the query. Does it fulfill all formal rules?}
function GeoJarrywmValidate : String;
var
   n : Integer;
   res : String;
begin
    Result := '';
    if gj2wm_AllListBoxAppliedCriteria.Items.Count > 0 then
    begin
      for n := 0 to gj2wm_AllListBoxAppliedCriteria.Items.Count-1 do
      begin
         res := GeoJarrywmValidateCriteria(gj2wm_AllListBoxAppliedCriteria.Items[n]);
         if res <> RESULT_VALID then Result := Result + res; 
      end;
    end else Result := Result + _('No applied criteria. You must apply at least one criteria.') + CRLF;
    
    res := GeoJarrywmAllValidate();
    if res <> RESULT_VALID then Result := Result + res;
    
    if Result = '' 
      then Result := RESULT_VALID
      else Result := Result + RESULT_INVALID;
end;

{Set default values into the form}
procedure GeoJarrywmSetDefaults;
begin
   gj2wm_AllButtonApply.Enabled := false;
   gj2wm_AllButtonRemove.Enabled := false;
   gj2wm_AllListBoxAvailableCriteria.ItemIndex := -1;
   gj2wm_AllListBoxAvailableCriteria.Enabled := true;
   gj2wm_AllRGroupNumber.Enabled := true;
   gj2wm_AllCheckBoxVisited.Enabled := true;
   gj2wm_AllCheckBoxOwned.Enabled := true;
   gj2wm_AllRGroupListing.Enabled := true;
   gj2wm_AllLabelPreviewOnline.Visible := true
   gj2wm_AllListBoxAppliedCriteria.ItemIndex := -1;
   gj2wm_AllListBoxAppliedCriteria.Items.Clear;
   gj2wm_AllRGroupNumber.ItemIndex := 0;
   gj2wm_AllEditNumber.Text := '';
   gj2wm_AllEditNumber.Enabled := false;
   gj2wm_AllCheckBoxVisited.Checked := false;
   gj2wm_AllCheckBoxOwned.Checked := false;
   gj2wm_AllRGroupListing.ItemIndex := 0;
   gj2wm_AllCheckBoxVisited.Enabled := true;
   
   GeoJarrywmSetDefaultAvailableCriteria;
   GeoJarrywmHideAllCriteriaPages;
   
   GeoJarrywmCategorySetDefaults;
   GeoJarrywmCodeSetDefaults;
   GeoJarrywmCoordSetDefaults;
   GeoJarrywmCountrySetDefaults;
   GeoJarrywmDateSetDefaults;
   GeoJarrywmKeywordSetDefaults;
   GeoJarrywmUserSetDefaults;
 
   wmqueryfile := '';
end;

{Load common information about this query}
function GeoJarrywmAllLoadQuery(file: String) : String;
var
  iniF: TIniFile;
  res : String;
begin
  Result := '';
  iniF := TIniFile.Create(file);
  try
    Result := isQueryCompatible(file);
    if Result = RESULT_VALID then Result := '' else Result := Result + CRLF;

    gj2wm_AllRGroupNumber.ItemIndex  := iniF.readInteger('Query', 'Quantity', DEFAULT_RGROUP);
    if (gj2wm_AllRGroupNumber.ItemIndex = 1) then gj2wm_AllEditNumber.Text := iniF.readString('Query', 'WaymarkCount', '');
    gj2wm_AllCheckBoxVisited.Checked := iniF.readBool('Query', 'ExcludeVisited', false);
    gj2wm_AllCheckBoxOwned.Checked   := iniF.readBool('Query', 'ExcludeOwned', false);
    gj2wm_AllRGroupListing.ItemIndex := iniF.readInteger('Query', 'DownloadListings', DEFAULT_RGROUP);

    res := GeoJarrywmAllValidate;
    if res = RESULT_VALID then res := '';
    
    if ((Result <> '') or (res <> '')) 
      then Result := Result + res
      else Result := RESULT_VALID;
  finally
    iniF.Free;
  end;
end;

{Save common information about this query}
function GeoJarrywmAllSaveQuery(file: String) : String;
var
  iniF: TIniFile;
begin
  Result := GeoJarrywmAllValidate;
  if Result = RESULT_VALID then                                                               
  begin
  iniF := TIniFile.Create(file);
    try
      iniF.writeString('GeoJarry','Version', GEOJARRY_VERSION);
      iniF.writeString('Query', 'QueryBase', QUERYBASE_WM);
      
      iniF.writeInteger('Query', 'Quantity', gj2wm_AllRGroupNumber.ItemIndex);
      if (gj2wm_AllRGroupNumber.ItemIndex = 1) then iniF.writeString('Query', 'WaymarkCount', gj2wm_AllEditNumber.Text);
      iniF.writeBool('Query', 'ExcludeVisited', gj2wm_AllCheckBoxVisited.Checked);
      iniF.writeBool('Query', 'ExcludeOwned', gj2wm_AllCheckBoxOwned.Checked);
      iniF.writeInteger('Query', 'DownloadListings', gj2wm_AllRGroupListing.ItemIndex);
    finally
      iniF.Free;
    end;
  end;
end;

{Add common url parameters to the given string list}
procedure GeoJarrywmAllGetUrlParameters(var list : TStringList);
begin
   if gj2wm_AllCheckBoxVisited.Checked then list.add('fw=True');
   if gj2wm_AllCheckBoxOwned.Checked then list.add('pw=True');
end;

{Save query to given file}
function GeoJarrywmSaveQuery(file: String) : String;
var
  iniF: TIniFile;
  n : Integer;
begin
  Result := GeoJarrywmValidate;
  if Result = RESULT_VALID then
  begin
    iniF := TIniFile.Create(file);
    try
      GeoJarrywmAllSaveQuery(file);
      for n := 0 to gj2wm_AllListBoxAppliedCriteria.Items.Count-1 do
      begin
         GeoJarrywmSaveCriteria(gj2wm_AllListBoxAppliedCriteria.Items[n],file);
      end;
    finally
      iniF.Free;
    end;
  end;
end;
 
{Load the query into the dialog}
function GeoJarrywmLoadQuery(file : String) : String;
var
  iniF: TIniFile;
  res : String;
  n : Integer;
begin
  Result := '';
  GeoJarrywmSetDefaults;
  if FileExists(file) then
  begin
    iniF := TIniFile.Create(file);
    try
       Result := GeoJarrywmAllLoadQuery(file);
       if Result = RESULT_VALID then begin
         res := GeoJarrywmLoadAppliedCriteria(file);
         if res = RESULT_VALID then
         begin
           for n := 0 to gj2wm_AllListBoxAppliedCriteria.Items.Count-1 do
           begin
              GeoJarrywmLoadCriteria(gj2wm_AllListBoxAppliedCriteria.Items[n],file);
           end;
           Result := GeoJarrywmValidate();
           wmqueryfile := file;
         end
         else 
           begin
              Result := _('Error loading query: %RESULT%');
              Result := ReplaceString(Result,'%RESULT%',res);
           end;
       end;
    finally
        iniF.Free;
  end;
  end 
  else 
    begin
      Result := _('No such file: %FILE%');
      Result := ReplaceString(Result,'%FILE%',file);
    end;
end;

{Show information about the query}
function GeoJarrywmQueryInfo(file : String) : String;
var
  n : Integer;
  s : String;
begin
  Result := GeoJarrywmLoadQuery(file);
  if Result = RESULT_VALID then
  begin
       Result := _('This query will search Waymarking.com webpage for waymarks by the following criteria') + ':' + CRLF + CRLF;
       for n := 0 to gj2wm_AllListBoxAppliedCriteria.Items.Count-1 do
       begin
          Result := Result + '- ' + GeoJarrywmGetCriteriaInfo(gj2wm_AllListBoxAppliedCriteria.Items[n]) + CRLF;
       end;
       
       Result := Result + CRLF;
       If (gj2wm_AllRGroupNumber.ItemIndex = 1) then 
       begin
          s := _('Only %NUMBER% most suitable waymarks will be downloaded.');
          s := ReplaceString(s,'%NUMBER%',gj2wm_AllEditNumber.Text);
          Result := Result + s + ' ';
       end;
       If (gj2wm_AllCheckBoxVisited.Checked) then Result := Result + _('Visited waymarks will not be downloaded.') + ' ';
       If (gj2wm_AllCheckBoxOwned.Checked) then Result := Result + _('Owned waymarks will not be downloaded.') + ' ';
       if (gj2wm_AllRGroupListing.ItemIndex = 1) then Result := Result + _('The query will download listings.') + ' ';
  end
  else 
    begin
      s := _('This query is invalid. Errors: ' + CRLF + '%ERRORS%');
      s := ReplaceString(s,'%ERRORS%',Result);
      Result := s;
    end;
end; 

{This function generates the query URL}
function GeojarrywmGetQueryUrl(var url : String) : String;
var
    n : Integer;
    list : TStringList; 
    res : String;  
begin
    if not isGeojarrywmCodeQuery then
    begin
      Result := '';
      list := TStringList.Create;
      try
        //get the base part of URL
        if (gj2wm_AllListBoxAppliedCriteria.Items.IndexOf(_('Category')) <> -1) 
          then url := WM_URLBASE_CATEGORY
          else url := WM_URLBASE;
        
        //get parameters from applied criteria
        for n := 0 to gj2wm_AllListBoxAppliedCriteria.Items.Count-1 do
        begin
           res := GeoJarrywmGetCriteriaUrlParameters(gj2wm_AllListBoxAppliedCriteria.Items[n],list);
           if res <> RESULT_VALID then 
           begin
              Result := Result + res;
           end;
        end;
        
        //get parameters from common part of the form
        GeojarrywmAllGetUrlParameters(list);
        
        for n := 0 to list.count-1 do
        begin
           url := url + '&' + list[n];
        end;
        
        if Result = '' then Result := RESULT_VALID;
      finally  
        list.Free;
      end;
    end else Result := _('This is a code query. URL can not be generated.');  
end;

{Prepares the ini file for geojarry engine}
procedure GeojarrywmPrepareIniFile;
var
  IniBody, IniFile : String;
begin
  IniFile := GetIniFile;
  IniBody := GetIniHeader;
  if (gj2wm_AllRGroupNumber.ItemIndex = 1) then IniBody := IniBody + 'maxcount=' + GetNumOfPages(gj2wm_AllEditNumber.Text, PERPAGE_WAYMARKS) + CRLF;
  StringToFile(IniBody, IniFile);
end;

{Prepares the command for geojarry engine}
function GeojarrywmPrepareCommand(subcommand : String) : String;
var
  url,res : String;
begin
  Result := '"' + GetGeoJarryExe + '" "' + GetIniFile + '"';
  res := GeojarrywmGetQueryUrl(url);
  if res = RESULT_VALID then
  begin
     Result := Result + ' ' + subcommand + ' "' + url +'"';
  end 
  else
  begin
     url := '';
     ShowMessage(res);
  end; 
end;

function GeojarrywmGetWaymarkList(var list : TStringList) : String;
var
  wmcount : Integer;
begin
  if not isGeojarrywmCodeQuery then
  begin
    //IniFile
    GeoJarrywmPrepareIniFile;
    
    //Download whole list
    Result := GeoJarryResultToString(GeoJarryRunExec(GeojarrywmPrepareCommand('rawpagerlist')));
    
    //Load list from file and cut number of waymarks 
    if (gj2wm_AllRGroupNumber.ItemIndex = 1) then wmcount := StrToInt(gj2wm_AllEditNumber.Text) else wmcount := -1;
    if Result = RESULT_VALID then list := GetDownloadedList(GetDownloadedRawpagerListFile,wmcount);
  end else 
  begin
    list := GeoJarrywmCodeGetCodeList;
    Result := WmCodeListValidate(list);
  end;
end;  

function GeojarrywmDownload : String;
var
  list : TStringList;
begin
  Result := '';
  if not isGeojarrywmCodeQuery then
  begin
    GeojarrywmPrepareIniFile;
    
    if (gj2wm_AllRGroupListing.ItemIndex = 1) then //with listings
      begin
         list := TStringList.Create;
         try
          Result := GeoJarrywmGetWaymarkList(list);
          if Result = RESULT_VALID then Result := DownloadWaypointListings(list, false); //download now
         finally
          list.Free;
         end;
      end
    else Result := GeoJarryResultToString(GeoJarryRunExec(GeoJarrywmPrepareCommand('rawpager'))); //basic info
  end
  else
  begin
     list := TStringList.Create;
     try
        Result := GeojarrywmGetWaymarkList(list);
        if Result = RESULT_VALID then Result := DownloadWaypointListings(list, false);
     finally
        list.Free;
     end;
  end
end; 

{Run this query}
function GeoJarrywmRunQuery: String;
begin
  NewGjFilename;
  
  Result := GeojarrywmValidate;
  if Result = RESULT_VALID then Result := GeojarrywmDownload;
end;

{Run and import this query}
function GeoJarrywmRunAndImportQuery: String;
begin
  EmptyDir(GetDatadir);
  Result := GeoJarrywmRunQuery;
  if Result = RESULT_VALID then
  begin
     GeoJarryGeoImportBegin;
     GeoJarryGeoImportDir(GetDatadir);
     GeoJarryGeoImportEnd;
  end;
end;

{Load and run this query}
function GeoJarrywmLoadAndRunQuery(file : String) : String;
begin
    Result := GeoJarrywmLoadQuery(file);
    if Result = RESULT_VALID then Result := GeoJarrywmRunQuery;
end;

{Load query and get list of waymark codes}
function GeoJarrywmLoadAndGetWMList(file : String; var wmlist : TStringList) : String;
begin
    Result := GeoJarrywmLoadQuery(file);
    if Result = RESULT_VALID then Result := GeojarrywmGetWaymarkList(wmlist);
end;

{Load run and import this query}
function GeoJarrywmLoadRunAndImportQuery(file : String) : String;
begin
    Result := GeoJarrywmLoadQuery(file); 
    if Result = RESULT_VALID then Result := GeoJarrywmRunAndImportQuery; 
end;

{Show me the dialog}
function GeoJarrywmShow : String;
begin
    Result := '';
    wmdownloaded := false;
    gj2wm.showmodal;
    if wmdownloaded then Result := RESULT_DOWNLOADED;   
end;

{Load query and show in the dialog}
function GeoJarrywmLoadQueryAndShow(file : String) : String;
var s : String;
begin
    Result := GeoJarrywmLoadQuery(file);
    If Result <> RESULT_VALID then 
      begin
        s := _('This query is invalid. Errors: ' + CRLF + '%ERRORS%');
        s := ReplaceString(s,'%ERRORS%',Result); 
        ShowMessage(s);
      end;
    Result := GeoJarrywmShow;
end;

procedure GeoJarrywmAllLabelPreviewOnlineOnClick(Sender : TObject);
var            
   res,url : String;
begin
   res := GeojarrywmValidate;
   if res <> RESULT_VALID 
     then ShowMessage(res)
     else 
     begin
        res := GeojarrywmGetQueryUrl(url);
        if res = RESULT_VALID 
          then RunShell(url)
          else ShowMessage(res);
     end;
end;

procedure GeoJarrywmAllButtonSaveOnClick(Sender :TObject);
var
  res,file : String;
begin
  res := GeoJarrywmValidate;
  if res = RESULT_VALID then
  begin
    file := GetFile(QUERY_DIR, QUERY_SUFFIX, _('Query'), GetQueryName(wmqueryfile));
    if file <> '' then GeoJarrywmSaveQuery(file);
  end
  else ShowMessage(res);
end;

procedure GeoJarrywmAllButtonDownloadNowOnClick(Sender :TObject);
var
  res: String;
begin
  gj2wm.hide;
  res := GeoJarrywmRunAndImportQuery;
  if res <> RESULT_VALID then 
  begin
     ShowMessage(res);
     gj2wm.show;
  end
  else
  begin
     wmdownloaded := true;
     gj2wm.close;
  end;
end;

procedure GeoJarrywmAllButtonGgtOnClick(Sender :TObject);
var
  file,res,s : String;
  list : TStringList;
begin
  res := GeojarrywmValidate;
  if res = RESULT_VALID then
  begin
    if SaveDlg(_('Select a GGT list'), GEOGET_DATADIR, 'ofFileMustExist',_('GeoGet GGT lists')+' (*.ggt)|*.ggt',file) then 
    begin
      if not RegexFind('.ggt$', file) then file := file + '.ggt';
      s := _('%FILE% already exists. Would you like to overwrite?');
      s := ReplaceString(s,'%FILE%',file);
      if FileExists(file) then if (MessBox(s, _('List file'),4) <> 6)then  Exit;
      
      gj2wm.hide;
      list := TStringList.Create;
      try
        res := GeojarrywmGetWaymarkList(list);
        if res = RESULT_VALID then
        begin
          list.saveToFile(file);
        end else ShowMessage(res);
      finally
        list.Free;
      end;
      gj2wm.show;
    end;
  end
  else ShowMessage(res);
  
end;

procedure GeoJarrywmAllButtonApplyOnClick(Sender : TObject);
var
   res : String;
begin
   if gj2wm_AllListBoxAvailableCriteria.ItemIndex <> -1 then
   begin
     res := GeoJarrywmApplyCriteria(gj2wm_AllListBoxAvailableCriteria.Items[gj2wm_AllListBoxAvailableCriteria.ItemIndex]);
     if res <> RESULT_VALID then ShowMessage(res);
   end;
end;

procedure GeoJarrywmAllButtonRemoveOnClick(Sender : TObject);
var
   res : String;
begin
   res := GeoJarrywmRemoveCriteria(gj2wm_AllListBoxAppliedCriteria.Items[gj2wm_AllListBoxAppliedCriteria.ItemIndex]);
   if res <> RESULT_VALID then ShowMessage(res);
end;

procedure GeoJarrywmAllRGroupNumberOnClick(Sender :TObject);
begin
    gj2wm_AllEditNumber.Enabled := (gj2wm_AllRGroupNumber.ItemIndex = 1);
end;

procedure GeoJarrywmAllEditNumberOnExit(Sender: Tobject);
begin
    if (gj2wm_AllEditNumber.Text <> '') then
    if (not RegexFind('^0*[1-9]\d*$',gj2wm_AllEditNumber.Text)) then
    begin
      ShowMessage(_('You must enter only positive integers!'));
      gj2wm_AllEditNumber.setfocus;
    end; 
end;

procedure GeoJarrywmSetActions;
begin
  gj2wm.Caption := _('GeoJarry %VERSION% - Waymarking.com based query');
  gj2wm.Caption := ReplaceString(gj2wm.Caption,'%VERSION%',GEOJARRY_VERSION);
  
  gj2wm_AllListBoxAvailableCriteria.OnClick := @GeoJarrywmAllListBoxAvailableCriteriaOnClick;
  gj2wm_AllListBoxAvailableCriteria.OnDblClick := @GeoJarrywmAllButtonApplyOnClick;
  gj2wm_AllListBoxAppliedCriteria.OnClick := @GeoJarrywmAllListBoxAppliedCriteriaOnClick;
  gj2wm_AllButtonApply.OnClick := @GeoJarrywmAllButtonApplyOnClick;
  gj2wm_AllButtonRemove.OnClick := @GeoJarrywmAllButtonRemoveOnClick;
  gj2wm_AllRGroupNumber.OnClick := @GeoJarrywmAllRGroupNumberOnClick;
  gj2wm_AllEditNumber.OnExit := @GeoJarrywmAllEditNumberOnExit;
  
  gj2wm_AllLabelPreviewOnline.OnClick := @GeoJarrywmAllLabelPreviewOnlineOnClick;
  gj2wm_AllButtonSave.OnClick := @GeoJarrywmAllButtonSaveOnClick;
  gj2wm_AllButtonGgt.OnClick := @GeoJarrywmAllButtonGgtOnClick;
  gj2wm_AllButtonDownloadNow.OnClick := @GeoJarrywmAllButtonDownloadNowOnClick;
  
  GeoJarrywmCategorySetActions;
  GeoJarrywmCodeSetActions;
  GeoJarrywmCoordSetActions;
  GeoJarrywmCountrySetActions;
  GeoJarrywmDateSetActions;
  GeoJarrywmKeywordSetActions;
  GeoJarrywmUserSetActions;
end;
