procedure GeojarrywmUserRGroupRelationOnClick(Sender : TObject);
begin
    if (gj2wm_UserRGroupRelation.ItemIndex = 0) then gj2wm_AllCheckBoxVisited.Checked := false;
    gj2wm_AllCheckBoxVisited.Enabled := (gj2wm_UserRGroupRelation.ItemIndex <> 0);
end;

function GeoJarrywmUserValidate : String;
begin
  Result := '';
  if (gj2wm_UserRGroupRelation.ItemIndex = -1) then Result := Result + _('You have to select the relation between username and waymarks. (Unknown "Relation" option)') + CRLF;
  
  if Result = '' then Result := RESULT_VALID;
end;

function GeoJarrywmUserLoad(file: String) : String;
var
  iniF: TIniFile;
begin
  Result := '';
  if FileExists(file) then
  begin
    iniF := TIniFile.Create(file);
    try
      gj2wm_UserEditUsername.Text := iniF.readString('Query', 'Username','');
      gj2wm_UserRGroupRelation.ItemIndex := iniF.readInteger('Query','Relation',DEFAULT_RGROUP);
      
      GeojarrywmUserRGroupRelationOnClick(nil);
      
      Result := GeoJarrywmUserValidate;
    finally
      iniF.Free;
    end;
  end;
end;

function GeoJarrywmUserSave(file: String) : String;
var
  iniF: TIniFile;
begin
  Result := GeoJarrywmUserValidate;
  if Result = RESULT_VALID then
  begin
    iniF := TIniFile.Create(file);
    try
      iniF.writeBool('Criteria','User', true);
      
      iniF.writeString('Query', 'Username',gj2wm_UserEditUsername.Text);
      iniF.writeInteger('Query','Relation',gj2wm_UserRGroupRelation.ItemIndex);
    finally
      iniF.Free;
    end;
  end;
end;

function GeojarrywmGetUIDFromWeb(username : String; var uid : String) : String;
var
  Command, file, profilepage, s : String;
  
begin
  Result := RESULT_INVALID;
  uid := '';
  
  //Inifile
  NewGjFilename();
  StringToFile(GetIniHeader, GetIniFile);
  
  //Command
  Command := '"' + GetGeoJarryExe + '" "' + GetIniFile + '" raw "http://www.geocaching.com/profile/?u=' + EncodeUrlElement(AnsiToUtf(username)) + '"';
  
  Result := GeoJarryResultToString(GeoJarryRunExec(Command));
  if (Result = RESULT_VALID) then
  begin
      file := GetDownloadedRawFile;
      if FileExists(file) then
      begin
          profilepage := FileToString(file);
          DeleteFile(file);
          s := RegexSubstitute('<\s*(a|A)([^>])*(' + GUID_REGEX + ')([^>])*(>){1}([a-zA-Z0-9]|\s)*(Gift|Give)+([^>])*(a|A)\s*>',profilepage,'$3');
          if IsGUID(s) then
          begin
             Result := RESULT_VALID;
             uid := s;
             
             //save it for later use
             if FileExists(GetUserIDListFile()) 
               then s := FileToString(GetUserIDListFile())
               else s := '';
               
             s := s + uid + '|' + lowercase(username) + CRLF;
             StringToFile(s,GetUserIDListFile());
            
          end else Result := _('Could not parse user ID.');
      end else Result := _('Could not find downloaded profile page. Can not translate username to user ID.');
  end; 
end;

function GeojarrywmGetUID(username : String; var uid : String) : String;
begin
    uid := GetGUID(lowercase(username),GetUserIDListFile());
    if IsGUID(uid) 
      then Result := RESULT_VALID
      else Result := GeojarrywmGetUIDFromWeb(username,uid);
end;

function GeoJarrywmUserGetInfo : String;
var
   relation,user : String;
begin
    case gj2wm_UserRGroupRelation.ItemIndex of
    0: begin relation := _('Visited by'); end;
    1: begin relation := _('Owned by'); end;
    Else begin relation := _('Unknown relation between user and waymarks!'); end;
    End;
    
    if gj2wm_UserEditUsername.Text = '' 
      then user := gUsername
      else user := gj2wm_UserEditUsername.Text;
    
    Result := relation + ' ' + user;
end;

function GeoJarrywmUserGetUrlParameters(var list: TStringList) : String;
var
    username,wft,uid : String;
begin
    if gj2wm_UserEditUsername.Text = ''
      then username := gUsername
      else username := gj2wm_UserEditUsername.Text; 
    
    Result := GeojarrywmGetUID(username,uid);
    if Result = RESULT_VALID then
    begin
       list.add('uid=' + EncodeUrlElement(uid));

       case gj2wm_UserRGroupRelation.ItemIndex of
       0 : begin wft := '3'; end;
       1 : begin wft := '2'; end;
       Else begin Result := _('Unknown relation between user and waymarks!'); end;
       end;
       
       if Result = RESULT_VALID then list.add('wft=' + EncodeUrlElement(wft));
    end;
end;

procedure GeoJarrywmUserSetDefaults;
begin
     gj2wm_UserRGroupRelation.ItemIndex := 0;
     gj2wm_UserEditUsername.Text := '';
end;

procedure GeoJarrywmUserSetActions;
begin
    gj2wm_UserRGroupRelation.OnClick := @GeojarrywmUserRGroupRelationOnClick;
end; 
