//mapy.cz code based on the code by dobrm5am 

// mapy.cz modified UTM projection
// (UTM projection with fixed Zone)
function UTM32Projection() {};

UTM32Projection.prototype.fromLatLngToPoint = function(latLng) {
  var z = 0;
	var en = this._wgsToPP(latLng.lat(), latLng.lng());		
	var pp_per_px = Math.pow(2, 28-8-(z-1)); //kolik metru(pp) meri jeden pixel			
	var px = en.x / pp_per_px;
	var py = en.y / pp_per_px;
  return new google.maps.Point(px, -py);
};

UTM32Projection.prototype.fromPointToLatLng = function(point, noWrap) {
  var z = 0;
	var pp_per_px = Math.pow(2, 28-8-(z-1)); //kolik metru(pp) meri jeden pixel
	var px = point.x * pp_per_px;
	var py = point.y * pp_per_px;
	var en = this.ppToWGS( px, -py);
  return new google.maps.LatLng(en.latNum, en.lonNum, noWrap);
};

//======= from the mapy.cz
UTM32Projection.prototype.WGS_RGX=/[-]?\d+(?:[.|,][\d]+)?(?=[\D\s])/g;
UTM32Projection.prototype.LO_RGX=/[w]/gi;
UTM32Projection.prototype.PI=Math.PI;
UTM32Projection.prototype.SF=0.9996;
UTM32Projection.prototype.SA=6378137;
UTM32Projection.prototype.FL=1/298.257223563;
UTM32Projection.prototype.UNITS=1;
UTM32Projection.prototype.DISTSIZE=3;
UTM32Projection.prototype.SECSIZE=3;
UTM32Projection.prototype.UTMSIZE=2;
UTM32Projection.prototype.wgsToUTM=function(la,lo){if(arguments.length==1){var wgsPair=this._parseFullWGSString(arguments[0]);var wgsDD=this._parseWGS(wgsPair[0],wgsPair[1]);}else{if((typeof la=="number")&&(typeof lo=="number")){return this._wgs2UTM(la,lo);}else{if((typeof la=="string")&&(typeof lo=="string")){var wgsDD=this._parseWGS(la,lo);}else{throw new Error("wgsToPP input: wrong wgs data format");}}}return this._wgs2UTM(wgsDD.la,wgsDD.lo);};
UTM32Projection.prototype._wgs2UTM=function(la,lo){var rad=this._wgsDegToRad(la,lo);var utm=this._wgsToUTM(rad.la,rad.lo,1);var utmEE=this._wgsToUTM(rad.la,rad.lo);return utm;};
UTM32Projection.prototype.utmToWGS=function(east,north,zone){var out=this._utmToWGS(east,north,zone);var lat=this._resToString(out.degLat,"lat");var lon=this._resToString(out.degLon,"lon");var wgs={"lat":lat.locNum+lat.locStr,"lon":lon.locNum+lon.locStr};return wgs;};
UTM32Projection.prototype.wgsToPP=function(la,lo){if(arguments.length==1){var wgsPair=this._parseFullWGSString(arguments[0]);var wgsDD=this._parseWGS(wgsPair[0],wgsPair[1]);}else{if((typeof la=="number")||(typeof lo=="number")){return this._wgsToPP(la,lo);}else{if((typeof la=="string")&&(typeof lo=="string")){var wgsDD=this._parseWGS(la,lo);}else{throw new Error("wgsToPP input: wrong wgs data format (la: "+ typeof la +" lo:"+ typeof lo +")");}}}return this._wgsToPP(wgsDD.la,wgsDD.lo);};
UTM32Projection.prototype.utmToPP=function(east,north,zone){var pp=this._utmToPP(east,north,zone);if(this.checkPP(pp.x,pp.y)){return pp;}else{return false;}};
UTM32Projection.prototype.ppToUTM=function(x,y){if(this.checkPP(x,y)){var utmEE=this._ppToUTMEE(x,y);var wgs=this._utmToWGS(utmEE.east,utmEE.north);var utm=this._wgsToUTM(wgs.radLat,wgs.radLon,1);return utm;}else{return false;}};
UTM32Projection.prototype.ppToWGS=function(x,y){if(this.checkPP(x,y)){var utmEE=this._ppToUTMEE(x,y);var out=this._utmToWGS(utmEE.east,utmEE.north,33);var lat=this._resToString(out.degLat,"lat");var lon=this._resToString(out.degLon,"lon");var wgs={"lat":lat.locNum+lat.locStr,"lon":lon.locNum+lon.locStr,"latNum":out.degLat,"lonNum":out.degLon};return wgs;}else{return false;}};
//UTM32Projection.prototype.checkPP=function(x,y){var map=this.main.port.map;if((x<map.LIMIT_LEFT)||(x>map.LIMIT_RIGHT)||(y>map.LIMIT_TOP)||(y<map.LIMIT_BOTTOM)){return false;}else{return true;}};
UTM32Projection.prototype.checkPP=function(x,y){return true;};
UTM32Projection.prototype.ppToMeter=function(ppDiff){return ppDiff/32;};
UTM32Projection.prototype.meterToPP=function(meterDiff){return meterDiff*32;};
UTM32Projection.prototype._ppToUTMEE=function(x,y){var north=(y)*Math.pow(2,-5)+1300000;var east=(x)*Math.pow(2,-5)+(-3700000);east=this._roundoff(east,this.UTMSIZE);north=this._roundoff(north,this.UTMSIZE);return {"east":east,"north":north,"zone":33};};
UTM32Projection.prototype._utmToPP=function(east,north,zone){var utmEE=this._utmToUTMEE(east,north,zone);var pp=this._utmEEToPP(utmEE.east,utmEE.north);return pp;};
UTM32Projection.prototype._utmEEToPP=function(east,north){x=(Math.round(east)-(-3700000))*Math.pow(2,5);y=(Math.round(north)-(1300000))*Math.pow(2,5);return {"x":x,"y":y};};
UTM32Projection.prototype._utmToUTMEE=function(east,north,zone){var wgs=this._utmToWGS(east,north,zone);var utm=this._wgsToUTM(wgs.radLat,wgs.radLon);return {"east":utm.east,"north":utm.north,"zone":33};};
UTM32Projection.prototype._utmToWGS=function(east,north,zone){var pi=this.PI;var units=this.UNITS;if(typeof zone!="undefined"){var zone=zone;}else{var zone=33;}var k=parseFloat(this.SF);var a=parseFloat(this.SA);var f=parseFloat(this.FL);var b=a*(1-f);var e2=(a*a-b*b)/(a*a);var e=Math.sqrt(e2);var ei2=(a*a-b*b)/(b*b);var ei=Math.sqrt(ei2);var n=(a-b)/(a+b);var G=a*(1-n)*(1-n*n)*(1+(9/4)*n*n+(255/64)*Math.pow(n,4))*(pi/180);var north=(north-0)*units;var east=(east-500000)*units;var m=north/k;var sigma=(m*pi)/(180*G);var footlat=sigma+((3*n/2)-(27*Math.pow(n,3)/32))*Math.sin(2*sigma)+((21*n*n/16)-(55*Math.pow(n,4)/32))*Math.sin(4*sigma)+(151*Math.pow(n,3)/96)*Math.sin(6*sigma)+(1097*Math.pow(n,4)/512)*Math.sin(8*sigma);var rho=a*(1-e2)/Math.pow(1-(e2*Math.sin(footlat)*Math.sin(footlat)),(3/2));var nu=a/Math.sqrt(1-(e2*Math.sin(footlat)*Math.sin(footlat)));var psi=nu/rho;var t=Math.tan(footlat);var x=east/(k*nu);var laterm1=(t/(k*rho))*(east*x/2);var laterm2=(t/(k*rho))*(east*Math.pow(x,3)/24)*(-4*psi*psi+9*psi*(1-t*t)+12*t*t);var laterm3=(t/(k*rho))*(east*Math.pow(x,5)/720)*(8*Math.pow(psi,4)*(11-24*t*t)-12*Math.pow(psi,3)*(21-71*t*t)+15*psi*psi*(15-98*t*t+15*Math.pow(t,4))+180*psi*(5*t*t-3*Math.pow(t,4))+360*Math.pow(t,4));var laterm4=(t/(k*rho))*(east*Math.pow(x,7)/40320)*(1385+3633*t*t+4095*Math.pow(t,4)+1575*Math.pow(t,6));var latrad=footlat-laterm1+laterm2-laterm3+laterm4;var lat=this._rad2deg(latrad);var seclat=1/Math.cos(footlat);var loterm1=x*seclat;var loterm2=(Math.pow(x,3)/6)*seclat*(psi+2*t*t);var loterm3=(Math.pow(x,5)/120)*seclat*(-4*Math.pow(psi,3)*(1-6*t*t)+psi*psi*(9-68*t*t)+72*psi*t*t+24*Math.pow(t,4));var loterm4=(Math.pow(x,7)/5040)*seclat*(61+662*t*t+1320*Math.pow(t,4)+720*Math.pow(t,6));var w=loterm1-loterm2+loterm3-loterm4;var longrad=this._deg2rad(this._getLCM(zone))+w;var lon=this._rad2deg(longrad);return {"degLat":lat,"degLon":lon,"radLat":latrad,"radLon":longrad};};
UTM32Projection.prototype._wgsToUTM=function(la,lo){var pi=this.PI;var units=this.UNITS;var distsize=this.DISTSIZE;var latrad=la;var lonrad=lo;var latddd=this._rad2deg(la);var londdd=this._rad2deg(lo);if(arguments[2]){var zone=Math.round((londdd+183)/6);}else{var zone=33;}var k=parseFloat(this.SF);var a=parseFloat(this.SA);var f=parseFloat(this.FL);var b=a*(1-f);var e2=(a*a-b*b)/(a*a);var e=Math.sqrt(e2);var ei2=(a*a-b*b)/(b*b);var ei=Math.sqrt(ei2);var n=(a-b)/(a+b);var G=a*(1-n)*(1-n*n)*(1+(9/4)*n*n+(255/64)*Math.pow(n,4))*(pi/180);var w=londdd-parseFloat(zone*6-183);w=this._deg2rad(w);var t=Math.tan(latrad);var rho=a*(1-e2)/Math.pow(1-(e2*Math.sin(latrad)*Math.sin(latrad)),(3/2));var nu=a/Math.sqrt(1-(e2*Math.sin(latrad)*Math.sin(latrad)));var psi=nu/rho;var coslat=Math.cos(latrad);var sinlat=Math.sin(latrad);var A0=1-(e2/4)-(3*e2*e2/64)-(5*Math.pow(e2,3)/256);var A2=(3/8)*(e2+(e2*e2/4)+(15*Math.pow(e2,3)/128));var A4=(15/256)*(e2*e2+(3*Math.pow(e2,3)/4));var A6=35*Math.pow(e2,3)/3072;var m=a*((A0*latrad)-(A2*Math.sin(2*latrad))+(A4*Math.sin(4*latrad))-(A6*Math.sin(6*latrad)));var eterm1=(w*w/6)*coslat*coslat*(psi-t*t);var eterm2=(Math.pow(w,4)/120)*Math.pow(coslat,4)*(4*Math.pow(psi,3)*(1-6*t*t)+psi*psi*(1+8*t*t)-psi*2*t*t+Math.pow(t,4));var eterm3=(Math.pow(w,6)/5040)*Math.pow(coslat,6)*(61-479*t*t+179*Math.pow(t,4)-Math.pow(t,6));var dE=k*nu*w*coslat*(1+eterm1+eterm2+eterm3);var east=parseFloat(500000)+(dE/units);east=this._roundoff(east,this.UTMSIZE);var nterm1=(w*w/2)*nu*sinlat*coslat;var nterm2=(Math.pow(w,4)/24)*nu*sinlat*Math.pow(coslat,3)*(4*psi*psi+psi-t*t);var nterm3=(Math.pow(w,6)/720)*nu*sinlat*Math.pow(coslat,5)*(8*Math.pow(psi,4)*(11-24*t*t)-28*Math.pow(psi,3)*(1-6*t*t)+psi*psi*(1-32*t*t)-psi*2*t*t+Math.pow(t,4));var nterm4=(Math.pow(w,8)/40320)*nu*sinlat*Math.pow(coslat,7)*(1385-3111*t*t+543*Math.pow(t,4)-Math.pow(t,6));var dN=k*(m+nterm1+nterm2+nterm3+nterm4);var north=(parseFloat(0)+(dN/units));north=this._roundoff(north,this.UTMSIZE);return {"zone":zone,"east":east,"north":north};};
UTM32Projection.prototype._wgsStrToRad=function(la,lo){var testCharSep=/([0-9]{1,2})[d\260]([0-9]{1,2})[m\']([0-9]{1,2}(?:\.[0-9]+)*)[s\"]{1}([new]{1}$)/i;var laOut=testCharSep.exec(la);var loOut=testCharSep.exec(lo);if(laOut&&loOut){var coords=this._testWgsData(laOut,loOut);}else{throw new Error("wgs input: wrong wgs data format");}if(coords.set){return coords;}else{throw new Error("wgs input: wrong wgs data");}};
UTM32Projection.prototype._testWgsData=function(la,lo){var laDms={};laDms.degree=la[1];laDms.minut=la[2];laDms.second=la[3];laDms.dir=la[4];var loDms={};loDms.degree=lo[1];loDms.minut=lo[2];loDms.second=lo[3];loDms.dir=lo[4];loDms.degree=(loDms.dir=="W")?-loDms.degree:loDms.degree;var laDec=this._dms2ddd(laDms.degree,laDms.minut,laDms.second);var loDec=this._dms2ddd(loDms.degree,loDms.minut,loDms.second);var loRad=this._deg2rad(loDec);var laRad=this._deg2rad(laDec);return {"la":laRad,"lo":loRad,"set":true};};
UTM32Projection.prototype._wgsDegToRad=function(la,lo){var loRad=this._deg2rad(lo);var laRad=this._deg2rad(la);return {"la":laRad,"lo":loRad,"set":true};};
UTM32Projection.prototype._deg2rad=function(x){var x=x*this.PI/180;return x;};
UTM32Projection.prototype._rad2deg=function(x){var x=x*180/this.PI;return x;};
UTM32Projection.prototype._dms2ddd=function(d,m,s){if(this._isblank(d)){d="0";}else{var y=d.toString(10).slice(0,1);d=parseFloat(d);}if(this._isblank(m)){m="0";}else{m=parseFloat(m);}if(this._isblank(s)){s="0";}else{s=parseFloat(s);}var x=Math.abs(d)+(Math.abs(m)/60)+(Math.abs(s)/3600);if((y=="-")||(d<0)||(m<0)||(s<0)){x=-x;}return x;};
UTM32Projection.prototype._isblank=function(s){var s=s.toString(10);for(var i=0;i<s.length;i++){var c=s.charAt(i);if((c!=" ")&&(c!="\n")&&(c!="\t")){return false;}}return true;};
UTM32Projection.prototype._roundoff=function(x,y){var x=parseFloat(x);var y=parseFloat(y);x=Math.round(x*Math.pow(10,y))/Math.pow(10,y);return x;};
UTM32Projection.prototype._resToString=function(num,dir){if(dir=="lon"){if(num<0){var str="W";var num=Math.abs(num);}else{var str="E";}}else{var str="N";}var y=Math.abs(parseFloat(num));var degree=parseInt(y+1)-1;var x=y-degree;var minut=parseInt(x*60+1)-1;var second=((x*60)-minut)*60;second=this._roundoff(second,this.SECSIZE);if(second==60){second="0";minut=minut*1+1;if(minut==60){minut="0";degree=degree*1+1;}}var value=degree+"°"+minut+"'"+second+"\"";return {"locNum":value,"locStr":str};};
UTM32Projection.prototype._getLCM=function(zone){if((zone<1)||(zone>60)){throw new Error("coordCalculator:UTM Zone number is not between 1 and 60.");}else{return ((zone*6)-183);}};
UTM32Projection.prototype._parseFullWGSString=function(str){if(str.indexOf("N")!=-1){var out=str.split("N");}else{if(str.indexOf("n")!=-1){var out=str.split("n");}else{throw new Error("wgsToPP -> parsFullWGSString: wrong wgs data format");}}if(out.length!=2){throw new Error("wgsToPPP -> parsFullWGSString: wrong wgs data format");}return out;};
UTM32Projection.prototype._parseWGS=function(la,lo){var out={};out.la=this._str2num(la.match(this.WGS_RGX));out.lo=this._str2num(lo.match(this.WGS_RGX));if(this.LO_RGX.test(lo)){out.lo=-1*out.lo;};return out;};
UTM32Projection.prototype._str2num=function(data){if(!data.length||data.length>3){throw new Error("wgsToPP -> parseWgs -> str2num: wrong wgs data format");}var out=0;var exp=1;for(var i=0;i<data.length;i++){var num=(data[i]).replace(/,/g,".");out+=parseFloat(num)/exp;exp*=60;}return out;};
UTM32Projection.prototype._wgsToPP=function(la,lo){var rad=this._wgsDegToRad(la,lo);var utmEE=this._wgsToUTM(rad.la,rad.lo);var pp=this._utmEEToPP(utmEE.east,utmEE.north);if(this.checkPP(pp.x,pp.y)){return pp;}else{return false;}};		
// =================================================================

function layer_mapycz_utm( mapname, maptype, minResolution, maxResolution ) {
  var tileLayer = new google.maps.ImageMapType({
    getTileUrl: function(coord, zoom) {
     	//http://m1.mapserver.mapy.cz/turist/12_7bc8000_80b0000
      var w = ((coord.x + coord.y) % 4)+1;
     	var pp_per_px = Math.pow(2,28-8-(zoom-1)); //kolik metru(pp) meri jeden pixel	        	
     	var pp_tile_width = Math.pow(2,28-(zoom-1)); //kolik metru(pp) meri jeden tile	
     	var x = new Number((coord.x)*pp_tile_width);
      var y = new Number(-(coord.y+1)*pp_tile_width);
      var x = x.toString(16);
      var y = y.toString(16)
//     	return 	"http://m" + w + ".mapserver.mapy.cz/" +
     	return 	"http://mapserver.mapy.cz/" +
      	maptype + "/" +
        (zoom-1) +"_"+
        x +"_"+ y;     
    },
    tileSize: new google.maps.Size(256, 256),
    name: mapname,
    maxZoom: maxResolution,
    minZoom: minResolution 
  });
  tileLayer.projection = new UTM32Projection();
  return tileLayer;        
};

// =================================================================
//mapy.cz layers
	var LAYER_MAPYCZ_BASE_S42_BASE		= layer_mapycz_utm('Mapy.cz Base', 'base-n', 5, 17);
	var LAYER_MAPYCZ_BASE_S42_ARMY2		= layer_mapycz_utm('Mapy.cz Historic', 'army2', 7, 14);
	var LAYER_MAPYCZ_BASE_S42_TURIST 	= layer_mapycz_utm('Mapy.cz Tourist', 'turist', 5, 17);
	var LAYER_MAPYCZ_BASE_S42_OPHOTO 	= layer_mapycz_utm('Mapy.cz Orto', 'ophoto', 5, 19);
	var LAYER_MAPYCZ_BASE_S42_OPHOTO2 = layer_mapycz_utm('Mapy.cz Orto_old', 'ophoto0203', 5, 17);
	var LAYER_MAPYCZ_BASE_S42_HYBRID 	= layer_mapycz_utm('Mapy.cz Hybrid', 'ophoto', 5, 19);

	var LAYER_MAPYCZ_OVER_S42_TURIST	= layer_mapycz_utm('', 'ttur', 12, 17);
	var LAYER_MAPYCZ_OVER_S42_CYKLO		= layer_mapycz_utm('', 'tcyklo', 12, 17);
	var LAYER_MAPYCZ_OVER_S42_HYBRID	= layer_mapycz_utm('', 'hybrid', 5, 17);
	var LAYER_MAPYCZ_OVER_S42_RELIEFH	= layer_mapycz_utm('', 'relief-h', 5, 13);
	var LAYER_MAPYCZ_OVER_S42_RELIEFL	= layer_mapycz_utm('', 'relief-l', 5, 13);
	
//AMapy CZ layers
var LAYER_AMAPY = new google.maps.ImageMapType({
    getTileUrl: function(coord, zoom) {
      return "http://maps11.i0.cz/mps/ch_turis/" + zoom + "/" + coord.x + "/" + coord.x + "_" + coord.y + ".gif";
    },
    tileSize: new google.maps.Size(256, 256),
    name: "AMapy.cz",
    minZoom: 13,
    maxZoom: 16
  });


function regMapId_CZ(mapTypeIds) {
  mapTypeIds.push("MAPYCZ_BASE");
  mapTypeIds.push("MAPYCZ_ORTO");
  mapTypeIds.push("MAPYCZ_HYBR");
  mapTypeIds.push("MAPYCZ_TUR");
  mapTypeIds.push("MAPYCZ_HIST");
  mapTypeIds.push("AMAPYCZ");
};

function regMapType_CZ(map) {
  map.mapTypes.set("MAPYCZ_BASE", LAYER_MAPYCZ_BASE_S42_BASE);
  map.mapTypes.set("MAPYCZ_ORTO", LAYER_MAPYCZ_BASE_S42_OPHOTO);
  map.mapTypes.set("MAPYCZ_HYBR", LAYER_MAPYCZ_BASE_S42_HYBRID);
  map.mapTypes.set("MAPYCZ_TUR", LAYER_MAPYCZ_BASE_S42_TURIST);
  map.mapTypes.set("MAPYCZ_HIST", LAYER_MAPYCZ_BASE_S42_ARMY2);
  map.mapTypes.set("AMAPYCZ", LAYER_AMAPY);
};

function changedMap_CZ(map, copyrightNode) {
  var mi = map.getMapTypeId();
  if ((mi == "MAPYCZ_BASE") || (mi == "MAPYCZ_ORTO") || (mi == "MAPYCZ_TUR"))
    copyrightNode.innerHTML = 'Map data by <a href="http://www.mapy.cz/">mapy.cz</a>';
  if (mi == "AMAPYCZ")
    copyrightNode.innerHTML = 'Map data © PPWK, Tele Atlas';
  if (mi == "MAPYCZ_TUR") {
    map.overlayMapTypes.insertAt(0, LAYER_MAPYCZ_OVER_S42_TURIST);
    map.overlayMapTypes.insertAt(0, LAYER_MAPYCZ_OVER_S42_CYKLO);
  };
  if (mi == "MAPYCZ_HYBR") {
    map.overlayMapTypes.insertAt(0, LAYER_MAPYCZ_OVER_S42_HYBRID);
    map.overlayMapTypes.insertAt(0, LAYER_MAPYCZ_OVER_S42_TURIST);
    map.overlayMapTypes.insertAt(0, LAYER_MAPYCZ_OVER_S42_CYKLO);
  };
};
