
var MAPOSM_MAPNIK     = new google.maps.ImageMapType({
    getTileUrl: function(coord, zoom) {
      return "http://tile.openstreetmap.org/" + zoom + "/" + coord.x + "/" + coord.y + ".png";
    },
    tileSize: new google.maps.Size(256, 256),
    name: "OSM Standard",
    maxZoom: 18
  });

var MAPOSM_CYCLE   = new google.maps.ImageMapType({
    getTileUrl: function(coord, zoom) {
      return "http://tile.opencyclemap.org/cycle/" + zoom + "/" + coord.x + "/" + coord.y + ".png";
    },
    tileSize: new google.maps.Size(256, 256),
    name: "OSM Cycle",
    maxZoom: 18
  });

var MAPOSM_TRANSPORT = new google.maps.ImageMapType({
    getTileUrl: function(coord, zoom) {
      return "http://tile2.opencyclemap.org/transport/" + zoom + "/" + coord.x + "/" + coord.y + ".png";
    },
    tileSize: new google.maps.Size(256, 256),
    name: "OSM Transport",
    maxZoom: 18
  });

var MAPOSM_MTB     = new google.maps.ImageMapType({
    getTileUrl: function(coord, zoom) {
      return "http://www.mtbmap.cz/mtbmap_tiles/" + zoom + "/" + coord.x + "/" + coord.y + ".png";
    },
    tileSize: new google.maps.Size(256, 256),
    name: "OSM mtb.cz",
    maxZoom: 18
  });

var MAPOSM_FREEMAPSK = new google.maps.ImageMapType({
    getTileUrl: function(coord, zoom) {
      var i = 1 + (coord.x % 2) + 2 * (coord.y % 2);
      return "http://t" + i +".freemap.sk/T/"+zoom+ "/" + coord.x+"/"+coord.y + ".png";
    },
    tileSize: new google.maps.Size(256, 256),
    name: "Freemap.sk",
    maxZoom: 18
  });

function regMapId_OSM(mapTypeIds) {
  mapTypeIds.push("OSM");
  mapTypeIds.push("OSM_CYCLE");
  mapTypeIds.push("OSM_TRANSPORT");
  mapTypeIds.push("OSM_MTB");
  mapTypeIds.push("FREEMAP.SK");
};

function regMapType_OSM(map) {
  map.mapTypes.set("OSM", MAPOSM_MAPNIK);
  map.mapTypes.set("OSM_CYCLE", MAPOSM_CYCLE);
  map.mapTypes.set("OSM_TRANSPORT", MAPOSM_TRANSPORT);
  map.mapTypes.set("OSM_MTB", MAPOSM_MTB);
  map.mapTypes.set("FREEMAP.SK", MAPOSM_FREEMAPSK);
};

function changedMap_OSM(map, copyrightNode) {
  var mi = map.getMapTypeId();
  if (mi == "OSM")
    copyrightNode.innerHTML = 'Map data © <a href="http://www.openstreetmap.org/">OpenStreetMap</a> Contributors, '
      + '<a href="http://creativecommons.org/licenses/by-sa/2.0/deed.cs">CC BY-SA</a>';
  if (mi == "OSM_CYCLE")
    copyrightNode.innerHTML = 'Map data © <a href="http://www.openstreetmap.org/">OpenStreetMap</a> Contributors, '
      + '<a href="http://creativecommons.org/licenses/by-sa/2.0/deed.cs">CC BY-SA</a>'
      + ', tiles courtesy of <a href="http://www.opencyclemap.org/">Andy Allan<a>';
  if (mi == "OSM_TRANSPORT")
    copyrightNode.innerHTML = 'Map data © <a href="http://www.openstreetmap.org/">OpenStreetMap</a> Contributors, '
      + '<a href="http://creativecommons.org/licenses/by-sa/2.0/deed.cs">CC BY-SA</a>'
      + ', tiles courtesy of <a href="http://www.opencyclemap.org/">Andy Allan<a>';
  if (mi == "OSM_MTB")
    copyrightNode.innerHTML = 'Map data © <a href="http://www.openstreetmap.org/">OpenStreetMap</a> Contributors, '
      + '<a href="http://creativecommons.org/licenses/by-sa/2.0/deed.cs">CC BY-SA</a>'
      + ', <a href="http://dds.cr.usgs.gov/srtm/">USGS<a>';
  if (mi == "FREEMAP.SK")
    copyrightNode.innerHTML = 'Map data © <a href="http://www.openstreetmap.org/">OpenStreetMap</a> Contributors, '
      + '<a href="http://creativecommons.org/licenses/by-sa/2.0/deed.cs">CC BY-SA</a>'
      + ', <a href="http://www.freemap.sk">Freemap.sk<a>';
};
