//GeoGet 2

function ExportExtension: string;
begin
  result := 'GPX';
end;

function ExportDescription: string;
begin
  result := 'Geoget GPX (Extended PQ GPX)';
end;

function ExportHint: string;
begin
  result := 'Basic exchange format for Geoget. All in one file. (Include Geoget specific data.)<br><b>Obsolete! Use gpxgeoget2 export instead!</b>';
  if copy(GetCurrentLanguage, 1, 2) = 'cs' then
    result := 'Zkladn vmnn formt pro Geoget. Ve do jednoho souboru. (Vetn specifickch dat Geogetu.)<br><b>Zastaral! Pouijte msto nj export gpxgeoget2!</b>';
end;

function ExportHeader: string;
begin
  Result := '<?xml version="1.0" encoding="utf-8" standalone="no"?>' + CRLF;
  Result := Result + '<gpx xmlns="http://www.topografix.com/GPX/1/0"'
    + ' creator="' + Geoget_Version + '" version="1.0"'
    + ' xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"'
    + ' xsi:schemaLocation="'
    + 'http://geoget.ararat.cz/GpxExtensions/v2 http://geoget.ararat.cz/GpxExtensions/v2/geoget.xsd' 
    + ' http://www.groundspeak.com/cache/1/0 http://www.groundspeak.com/cache/1/0/cache.xsd'
    + ' http://www.topografix.com/GPX/1/0 http://www.topografix.com/GPX/1/0/gpx.xsd'
    + '">' + CRLF;
  Result := Result + ' <desc>Geoget data file</desc>' + CRLF;
  Result := Result + ' <time>' + formatdatetime('yyyy"-"mm"-"dd"T"hh":"nn":"ss"."zzz', now) + '</time>' + CRLF;
  Result := Result + CRLF;
end;

function ExportFooter: string;
begin
  result := '</gpx>' + CRLF;
end;

function ExportPoint: string;
var
  s: string;
  n, m: integer;
  l: TStringlist;
  lv: TStringlist;
begin
  Result := '';
  //Export for Geocaches
  if GC.IsListed then
  begin
    Result := Result + ' <wpt lat="' + GC.Lat + '" lon="' + GC.Lon + '">' + CRLF;
    Result := Result + '  <time>'
      + formatdatetime('yyyy"-"mm"-"dd"T"hh":"nn":"ss"."zzz', GC.Hidden) + '</time>' + CRLF;
    Result := Result + '  <name>' + GC.ID +'</name>' + CRLF;
    Result := Result + '  <desc>' + cdata(GC.Name + ' by ' + GC.Author
          + ' (' + GC.Difficulty + '/' + GC.Terrain + ')') +'</desc>' + CRLF;
    Result := Result + '  <url>' + cdata(GC.URL) +'</url>' + CRLF;
    Result := Result + '  <urlname>' + cdata(GC.Name + ' by ' + GC.Author) + '</urlname>' + CRLF;
    if GC.IsFound then
      Result := Result + '  <sym>Geocache Found</sym>' + CRLF
    else
      Result := Result + '  <sym>Geocache</sym>' + CRLF;
    Result := Result + '  <type>Geocache|' + GC.CacheType + '</type>' + CRLF;
    if GC.IsDisabled then
      s := 'available="False"'
    else
      s := 'available="True"';
    if GC.IsArchived then
      s := s + ' archived="True"'
    else
      s := s + ' archived="False"';
    s := 'id="' + GC.CacheID +'" ' + s;
    Result := Result + '  <groundspeak:cache ' + s + ' xmlns:groundspeak="http://www.groundspeak.com/cache/1/0">' + CRLF;
    Result := Result + '   <groundspeak:name>' + cdata(GC.Name) + '</groundspeak:name>' + CRLF;
    Result := Result + '   <groundspeak:placed_by>' + cdata(GC.Author) +'</groundspeak:placed_by>' + CRLF;
    if GC.OwnerID <> '' then
      Result := Result + '   <groundspeak:owner id="' + GC.OwnerID + '">' + cdata(GC.Author) +'</groundspeak:owner>' + CRLF;
    Result := Result + '   <groundspeak:type>' + GC.CacheType +'</groundspeak:type>' + CRLF;
    Result := Result + '   <groundspeak:container>' + GC.Size +'</groundspeak:container>' + CRLF;
    Result := Result + '   <groundspeak:difficulty>' + GC.Difficulty +'</groundspeak:difficulty>' + CRLF;
    Result := Result + '   <groundspeak:terrain>' + GC.Terrain +'</groundspeak:terrain>' + CRLF;
    Result := Result + '   <groundspeak:country>' + GC.Country +'</groundspeak:country>' + CRLF;
    Result := Result + '   <groundspeak:state>' + GC.State +'</groundspeak:state>' + CRLF;
    Result := Result + '   <groundspeak:short_description html="True">' + cdata(GC.ShortDescription) +'</groundspeak:short_description>' + CRLF;
    Result := Result + '   <groundspeak:long_description html="True">' + cdata(GC.LongDescription) +'</groundspeak:long_description>' + CRLF;
    Result := Result + '   <groundspeak:encoded_hints>' + cdata(GC.Hint) +'</groundspeak:encoded_hints>' + CRLF;
    Result := Result + '   <groundspeak:logs>' + CRLF;
    for n := 0 to GC.Logs.Count - 1 do
    begin
      Result := Result + '    <groundspeak:log id="' + GC.Logs[n].LogID + '">' + CRLF;
      Result := Result + '     <groundspeak:date>' 
        + formatdatetime('yyyy"-"mm"-"dd"T"hh":"nn":"ss"."zzz', GC.Logs[n].Date) + '</groundspeak:date>' + CRLF;
      Result := Result + '     <groundspeak:type>' + GC.Logs[n].LogType + '</groundspeak:type>' + CRLF;
      s := '';
      if GC.Logs[n].FinderID <> '' then
        s := ' id="' + GC.Logs[n].FinderID + '"'; 
      Result := Result + '     <groundspeak:finder' + s + '>' + cdata(GC.Logs[n].Finder) + '</groundspeak:finder>' + CRLF;
      Result := Result + '     <groundspeak:text encoded="False">' + cdata(GC.Logs[n].Text) + '</groundspeak:text>' + CRLF;
      Result := Result + '    </groundspeak:log>' + CRLF;
    end;
    Result := Result + '   </groundspeak:logs>' + CRLF;
    Result := Result + '  </groundspeak:cache>' + CRLF;
    Result := Result + '  <gpxg:GeogetExtension xmlns:gpxg="http://geoget.ararat.cz/GpxExtensions/v2">' + CRLF;
    if GC.Comment <> '' then
      Result := Result + '    <gpxg:Comment>'+cdata(GC.Comment)+'</gpxg:Comment>' + CRLF;
    if GC.IsFound then
      Result := Result + '    <gpxg:Found>' + formatdatetime('yyyy"-"mm"-"dd"T"hh":"nn":"ss"."zzz', GC.found + GC.Foundtime) + '</gpxg:Found>' + CRLF;
    s := GC.TagCategories;
    if s <> '' then
    begin
      Result := Result + '    <gpxg:Tags>' + CRLF;
      l := TStringlist.create;
      lv := TStringlist.create;
      try
        l.text := s;
        for n := 0 to l.count - 1 do
        begin
          s := GC.TagValues(l[n]);
          lv.text := s;
          for m := 0 to lv.count - 1 do
            Result := Result + '      <gpxg:Tag Category="'+l[n]+'">'+cdata(lv[m]) + '</gpxg:Tag>' + CRLF;
        end;
      finally
        lv.free;
        l.free;
      end;
      Result := Result + '    </gpxg:Tags>' + CRLF;
    end;
    Result := Result + '  </gpxg:GeogetExtension>' + CRLF;
    Result := Result + ' </wpt>' + CRLF + CRLF;
  end;
  //Export for Waypoints
  for n := 0 to GC.Waypoints.Count - 1 do
    if GC.Waypoints[n].IsListed then
    begin
      Result := Result + ' <wpt lat="' + GC.Waypoints[n].Lat + '" lon="' + GC.Waypoints[n].Lon + '">' + CRLF;
      Result := Result + '  <time>'
        + formatdatetime('yyyy"-"mm"-"dd"T"hh":"nn":"ss"."zzz', GC.Hidden) + '</time>' + CRLF;
      Result := Result + '  <name>' + GC.Waypoints[n].ID +'</name>' + CRLF;
      Result := Result + '  <cmt>' + cdata(GC.Waypoints[n].Description) +'</cmt>' + CRLF;
      Result := Result + '  <desc>' + cdata(GC.Waypoints[n].Name) +'</desc>' + CRLF;
      Result := Result + '  <url>' + cdata(GC.Waypoints[n].URL) +'</url>' + CRLF;
      Result := Result + '  <urlname>' + cdata(GC.Waypoints[n].Name) + '</urlname>' + CRLF;
      Result := Result + '  <sym>' + GC.Waypoints[n].WptType + '</sym>' + CRLF
      Result := Result + '  <type>Waypoint|' + GC.Waypoints[n].WptType + '</type>' + CRLF;
      Result := Result + '  <gpxg:GeogetExtension xmlns:gpxg="http://geoget.ararat.cz/GpxExtensions/v2">' + CRLF;
      if GC.Waypoints[n].Comment <> '' then
        Result := Result + '    <gpxg:Comment>'+cdata(GC.Waypoints[n].Comment)+'</gpxg:Comment>' + CRLF;
      Result := Result + '     <gpxg:Flag>'+IntToStr(GC.Waypoints[n].flags)+'</gpxg:Flag>' + CRLF;
      Result := Result + '  </gpxg:GeogetExtension>' + CRLF;
      Result := Result + ' </wpt>' + CRLF + CRLF;
    end;
end;
